<?php
// Variablen die bei jedem Plugin existieren
// $GLOBALS['smarty']               Smarty Template Engine Object
// $GLOBALS['oPlugin']              Plugin Object
global $smarty, $oPlugin;

define ('SHOPPGATE_MY_CONFIG', PFAD_ROOT.'shopgate_library/config/myconfig.php');

$shopgateConfigDefault = array (
  'customer_number'     => '',
  'shop_number'         => '',
  'apikey'              => '',
  'alias'               => '',
  'cname'               => '',
  'server'              => 'live',
  'shop_is_active'      => '1',
  'encoding'            => 'UTF-8',
  'plugin'              => 'ShopgatePluginJTL',
  'enable_get_customer' => 1,
  'enable_add_order'    => 1,
  'enable_update_order' => 1,
  'enable_cron'         => 1
);
$allowed_chars = '/^[A-Za-z0-9_äöüÄÖÜß &;().,`´@\'\"\-\/]*$/';

// ist die config Datei beschreibbar?
$confFileExists = file_exists(SHOPPGATE_MY_CONFIG);
$confFileIsWritable = is_writable(SHOPPGATE_MY_CONFIG);
$textFileNotExists = 'Die Shopgate-Konfigurationsdatei &quot;'.SHOPPGATE_MY_CONFIG.'&quot; ist nicht vorhanden. Es wird versucht, diese beim Speichern der Einstellungen anzulegen.';
$textFileIsNotWritable = 'Die Shopgate-Konfigurationsdatei &quot;'.SHOPPGATE_MY_CONFIG.'&quot; ist nicht beschreibbar, &Auml;nderungen k&ouml;nnen nicht gespeichert werden. Setzen Sie die Dateirechte auf 777 um vorgenommene &Auml;nderungen zu speichern.';
$textFileIsWritable = 'Die Shopgate-Konfigurationsdatei &quot;'.SHOPPGATE_MY_CONFIG.'&quot; ist beschreibbar. Dies kann ein Sicherheitsrisiko darstellen. Setzen Sie die Dateirechte auf 444, wenn Sie derzeit keine &Auml;nderungen an der Konfiguration speichern m&ouml;chten.';

if ($confFileExists)
  require SHOPPGATE_MY_CONFIG;
else
  $shopgate_config = $shopgateConfigDefault;
$form_preset = $shopgate_config;
if (!array_key_exists('enable_cron', $form_preset))
  $form_preset['enable_cron'] = 1;
  
if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['btn_save']))
{
  $submited_config = array();
  if (isset($_POST['sc_customer_number']))
  {
    if (preg_match($allowed_chars, $_POST['sc_customer_number']))
    {
      $tmp = trim($_POST['sc_customer_number']);
      if (!empty($tmp))
        $submited_config['customer_number'] = $tmp;
    }
  }
  if (isset($_POST['sc_shop_number']))
  {
    if (preg_match($allowed_chars, $_POST['sc_shop_number']))
    {
      $tmp = trim($_POST['sc_shop_number']);
      if (!empty($tmp))
        $submited_config['shop_number'] = $tmp;
    }
  }
  if (isset($_POST['sc_apikey']))
  {
    if (preg_match($allowed_chars, $_POST['sc_apikey']))
    {
      $tmp = trim($_POST['sc_apikey']);
      if (!empty($tmp))
        $submited_config['apikey'] = $tmp;
    }
  }
  if (isset($_POST['sc_alias']))
  {
    if (preg_match($allowed_chars, $_POST['sc_alias']))
    {
      $tmp = trim($_POST['sc_alias']);
      if (!empty($tmp))
        $submited_config['alias'] = $tmp;
    }
  }
  if (isset($_POST['sc_cname']))
  {
    if (preg_match($allowed_chars, $_POST['sc_cname']))
    {
      $tmp = trim($_POST['sc_cname']);
      if (!empty($tmp))
        $submited_config['cname'] = $tmp;
    }
  }
  if (!empty($submited_config))
  {
    foreach ($submited_config as $key => $value)
      $form_preset[$key] = $value;
    
    // Erzeuge die Konfig-Datei
    $fp = @fopen(SHOPPGATE_MY_CONFIG, 'w+');
    if ($fp)
    {
      $content  = '<?php'.chr(10);
      $content .= '$shopgate_config = array ('.chr(10);
      foreach ($form_preset as $pkey => $pValue)
        $content .= chr(9)."'$pkey' => '$pValue',".chr(10);
      $content .= ')'.chr(10);
      $content .= '?>';
      fwrite($fp, $content);
      fclose($fp);
    }
    else
      $form_preset = $shopgate_config;
  }
  $confFileExists = file_exists(SHOPPGATE_MY_CONFIG);
  $confFileIsWritable = is_writable(SHOPPGATE_MY_CONFIG);
}

$smarty->assign('bConfFileExists', $confFileExists);
$smarty->assign('bConfFileIsWritable', $confFileIsWritable);
$smarty->assign('cTextFileNotExists', $textFileNotExists);
$smarty->assign('cTextFileIsWritable', $textFileIsWritable);
$smarty->assign('cTextFileIsNotWritable', $textFileIsNotWritable);

$smarty->assign('cValueCustomerNumber', $form_preset['customer_number']);
$smarty->assign('cValueShopNumber', $form_preset['shop_number']);
$smarty->assign('cValueApikey', $form_preset['apikey']);
$smarty->assign('cValueAlias', $form_preset['alias']);
$smarty->assign('cValueCname', $form_preset['cname']);

$smarty->assign("URL_SHOP", URL_SHOP);
$smarty->assign("URL_ADMINMENU", URL_SHOP . "/" . PFAD_PLUGIN . $oPlugin->cVerzeichnis . "/" . PFAD_PLUGIN_VERSION . $oPlugin->nVersion . "/" . PFAD_PLUGIN_ADMINMENU);
//$smarty->assign("stepPlugin", $stepPlugin);
print_r($smarty->fetch($oPlugin->cAdminmenuPfad . "template/shopgate_config.tpl"));
?>