<?php
/* includes/plugins/agi_shopgate_plugin/version/105/api_plugin.php
.---------------------------------------------------------------------------.
|    Software: AGI Shopgate - JTL - Connector                               |
|     Version: 1.2                                                          |
|        Date: 2017-02-03                                                   |
|     Contact: info@andreas-guder.de                                        |
| ------------------------------------------------------------------------- |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2013 Andreas Guder [info@andreas-guder.de]                  |
|               All Rights Reserved.                                        |
|                      Based on Shopgate Example-Plugin                     |
'---------------------------------------------------------------------------ü
*/

require_once DIR_BASE_PATH.'/shopgate_library/shopgate.php';
require_once AGI_PLUGIN_PATH.'plugin.class.php';

class AGIShopgatePlugin extends AGIShopgatePluginBase
{
  protected $bExportProduktKonfiguration = false; // 20160509 konfiguration
  protected $agi_mb_search_replace = array('search'=>array(),'replace'=>array());
  
  /* called by $this->startup(); */
  public function agiStartup()
  {
    $this->_prepare_agi_mb_search_replace();
    // empty
  }
  
  /* called by $this->getCustomer(); */
  public function agiGetCustomerIndividualAddData($customer)
  {
    // add individual customer-data here
    return $customer; // return manipulated $customer-Object
  }
  
  /* called by $this->createItems(); after configuration is load */
  public function agiCreateItemsOnStart()
  {
    // empty
  }
  
  /* called by $this->createCategories(); */
  public function agiOverwriteCategoriesArray($aKategories, $limit=null, $offset=null, $uids=array())
  {
    return $aKategories; // return manipulated $aKategorie-Array
  }
  public function agiManipulateCategoriesArrayItem($aItem)
  {
    return $aItem; // return manipulated $aItem-Array
  }
  
  /* manipulate article item object $this->oExportArticle */
  public function agiManipulateItemObject()
  {
    // empty
  }
  
  /* called by $this->addOrder(); */
  public function agiAddOrderIndividual($order)
  {
    /*
    if ($order->getOrderNumber() == '') {
      var_dump($order);
      exit;
    }
    */
    // do something
    // exit;
  }
  
  /* called by $this->updateOrder(); */
  public function agiUpdateOrderIndividual($order)
  {
    // do something
    // exit;
  }
  
  /* called by $this->registerCustomer(); */
  public function agiRegisterCustomerIndividual($user, $pass, $customer)
  {
    // do something
    // exit;
  }
  
  /* called by $this->checkStock(); */
  public function agiCheckStockIndividual($shopgateCart)
  {
    // do something
    // exit;
  }
  
  /* called by $this->checkCart(); */
  public function agiCheckCartIndividual($shopgateCart)
  {
    // do something
    // exit;
  }
  
  /* called by $this->redeemCoupons(); */
  public function agiRedeemCouponsIndividual($shopgateCart)
  {
    // do something
    // exit;
  }
  
  public function agi_mb_replace($string) 
  {
    if (!empty($this->agi_mb_search_replace['search']) && !empty($string) && is_string($string))
      return str_replace($this->agi_mb_search_replace['search'],$this->agi_mb_search_replace['replace'],$string);
    else
      return $string;
  }
  protected function _prepare_agi_mb_search_replace() {
    $serach_replace = array();
    //polnisch
    $serach_replace[] = array('ą','a');
    $serach_replace[] = array('Ą','A');
    $serach_replace[] = array('ć','c');
    $serach_replace[] = array('Ć','C');
    $serach_replace[] = array('ę','e');
    $serach_replace[] = array('Ę','E');
    $serach_replace[] = array('ł','i');
    $serach_replace[] = array('Ł','L');
    $serach_replace[] = array('ń','n');
    $serach_replace[] = array('Ń','N');
    $serach_replace[] = array('Ó','O');
    $serach_replace[] = array('ó','o');
    $serach_replace[] = array('ś','s');
    $serach_replace[] = array('Ś','S');
    $serach_replace[] = array('ż','z');
    $serach_replace[] = array('Ż','Z');
    $serach_replace[] = array('ź','z');
    $serach_replace[] = array('Ź','Z');
    
    $this->agi_mb_search_replace = array('search'=>array(),'replace'=>array());
    foreach ($serach_replace as $value) {
      $this->agi_mb_search_replace['search'][] = $value[0];
      $this->agi_mb_search_replace['replace'][] = $value[1];
    }
  }
}

$ShopgateFramework = new AGIShopgatePlugin();
$ShopgateFramework->handleRequest($_REQUEST);
?>