<?php
// Variablen die bei jedem Plugin existieren
// $GLOBALS['smarty']               Smarty Template Engine Object
// $GLOBALS['oPlugin']              Plugin Object
global $smarty, $oPlugin;
$loadOptions = array('sgRedirectActive');
$sLoadOptions = '';
foreach ($loadOptions as $value)
  $sLoadOptions .= empty($sLoadOptions) ? "'".$value."'" : ",'".$value."'";

define ('SHOPPGATE_MY_CONFIG', PFAD_ROOT.'shopgate_library/config/myconfig.php');
if(file_exists(SHOPPGATE_MY_CONFIG) && date('Y-m-d',strtotime($oPlugin->dZuletztAktualisiert)) == date('Y-m-d'))
{
  require SHOPPGATE_MY_CONFIG;
  $v104_preset = $shopgate_config;
}

require_once $oPlugin->cAdminmenuPfad . 'lib/functions.lib.php';

$aOptions = array();
$aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `xplugin_".$oPlugin->cPluginID."_config` WHERE `cKey` IN ($sLoadOptions) ORDER BY `cKey`", 9);
foreach ($aRes as $row)
{
  $aOptions[$row['cKey']] = $row['cValue'];
}

define ('SHOPGATE_CONFIG_FOLDER', PFAD_ROOT.'shopgate_library/config/');

$aLanguages = array();
$nDefaultLanguage = 1;
$aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tsprache` ORDER BY `cNameDeutsch`", 9);
foreach ($aRes as $row)
{
  $aLanguages[$row['kSprache']] = array('kSprache'=>$row['kSprache'], 'cName'=>$row['cNameDeutsch']);
  if ($row['cShopStandard'] == 'Y')
    $nDefaultLanguage = $row['kSprache'];
}

$shopgateConfigDefault = array (
  'customer_number'     => isset($v104_preset['customer_number']) ? $v104_preset['customer_number'] : '',
  'shop_number'         => isset($v104_preset['shop_number']) ? $v104_preset['shop_number'] : '',
  'apikey'              => isset($v104_preset['apikey']) ? $v104_preset['apikey'] : '',
  'alias'               => isset($v104_preset['alias']) ? $v104_preset['alias'] : '',
  'cname'               => isset($v104_preset['cname']) ? $v104_preset['cname'] : '',
  'jtlSprache'          => $nDefaultLanguage,
  'plugin'              => 'ShopgatePluginJTL',
  'shop_is_active'      => 1
);
$allowed_chars = '/^[A-Za-z0-9_äöüÄÖÜß &;().,`´@\'\"\-\/]*$/';
$textFileIsNotWritable = 'ist <strong>nicht beschreibbar</strong><br />&Auml;nderungen k&ouml;nnen nicht gespeichert werden. Setzen Sie die Dateirechte auf 777 um vorgenommene &Auml;nderungen zu speichern.';
$textFileIsWritable = '<strong>ist beschreibbar</strong>';

$config_files = array();
$files = scandir(PFAD_ROOT.'shopgate_library/config/');
foreach ($files as $file) 
{
  if (!is_file(SHOPGATE_CONFIG_FOLDER.$file))
    continue;
  
  if (preg_match('/^config_([0-9]{4,})/', $file, $matches))
  {
    $confFileIsWritable = is_writable(SHOPGATE_CONFIG_FOLDER.$file);
    $sfile_number = $matches[1];
    require SHOPGATE_CONFIG_FOLDER.$file;
    $config_files[$sfile_number] = array(
      'file'        => SHOPGATE_CONFIG_FOLDER.$file,
      'shopnumber'  => $sfile_number,
      'data'        => $shopgate_config,
      'writable'    => $confFileIsWritable
    );
  }
}

if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['btn_save']) && $_GET['cPluginTab'] == 'API-Einrichtung')
{
  if(file_exists(SHOPPGATE_MY_CONFIG))
    @unlink(SHOPPGATE_MY_CONFIG);
  
  agi_plugin_saveConfig($oPlugin->cPluginID, 'sgRedirectActive', isset($_POST['inputSgRedirectActive']) ? 'Y' : 'N');
  $aOptions['sgRedirectActive'] = isset($_POST['inputSgRedirectActive']) ? 'Y' : 'N';
  
  $sgLanguagesToShops = array();
  if (isset($_POST['sg_shop_number_ref']))
  {
    foreach ($_POST['sg_shop_number_ref'] as $skey)
    {
      if (preg_match($allowed_chars, $skey))
      {
        if (isset($_POST['sg_delete_'.$skey]))
        {
          if (array_key_exists($skey, $config_files))
          {
            @unlink($config_files[$skey]['file']);
            unset($config_files[$skey]);
          }
        }
        else
        {
          if (!empty($_POST['sg_shop_number_'.$skey]) && preg_match($allowed_chars, $_POST['sg_shop_number_'.$skey]))
          {
            $tmp = trim($_POST['sg_shop_number_'.$skey]);
            if (!empty($tmp))
            {
              $use_key = $skey;
              if ($tmp != $skey)
              {
                @unlink($config_files[$skey]['file']);
                unset($config_files[$skey]);
                $config_files[$tmp] = array(
                  'file'        => SHOPGATE_CONFIG_FOLDER.'config_'.$tmp.'.php',
                  'shopnumber'  => $tmp,
                  'data'        => $shopgateConfigDefault,
                  'writable'    => false
                );
                $config_files[$tmp]['data']['shop_number'] = $tmp;
                $use_key = $tmp;
              }
              
              if (isset($_POST['sg_customer_number_'.$skey]) && preg_match($allowed_chars, $_POST['sg_customer_number_'.$skey]))
              {
                $tmp = trim($_POST['sg_customer_number_'.$skey]);
                if (!empty($tmp))
                  $config_files[$use_key]['data']['customer_number'] = $tmp;
              }
              
              if (isset($_POST['sg_apikey_'.$skey]) && preg_match($allowed_chars, $_POST['sg_apikey_'.$skey]))
              {
                $tmp = trim($_POST['sg_apikey_'.$skey]);
                if (!empty($tmp))
                  $config_files[$use_key]['data']['apikey'] = $tmp;
              }
              
              if (isset($_POST['sg_alias_'.$skey]) && preg_match($allowed_chars, $_POST['sg_alias_'.$skey]))
              {
                $tmp = trim($_POST['sg_alias_'.$skey]);
                if (!empty($tmp))
                  $config_files[$use_key]['data']['alias'] = $tmp;
              }
              
              if (isset($_POST['sg_cname_'.$skey]) && preg_match($allowed_chars, $_POST['sg_cname_'.$skey]))
              {
                $tmp = trim($_POST['sg_cname_'.$skey]);
                if (!empty($tmp))
                  $config_files[$use_key]['data']['cname'] = $tmp;
              }
              
              if (isset($_POST['sg_lang_'.$skey]) && array_key_exists($_POST['sg_lang_'.$skey], $aLanguages))
              {
                $tmp = trim($_POST['sg_lang_'.$skey]);
                if (!empty($tmp))
                  $config_files[$use_key]['data']['jtlSprache'] = $tmp;
                else
                  $config_files[$use_key]['data']['jtlSprache'] = $nDefaultLanguage;
              }
            }
          }
        }
      }
    }
  }
  
  if (isset($_POST['sg_shop_number_new']))
  {
    $tmp = trim($_POST['sg_shop_number_new']);
    if (!empty($tmp))
    {
      $use_key = $tmp;
      $config_files[$tmp] = array(
        'file'        => SHOPGATE_CONFIG_FOLDER.'config_'.$tmp.'.php',
        'shopnumber'  => $tmp,
        'data'        => $shopgateConfigDefault,
        'writable'    => false
      );
      $config_files[$tmp]['data']['shop_number'] = $tmp;
      
      if (isset($_POST['sg_customer_number_new']) && preg_match($allowed_chars, $_POST['sg_customer_number_new']))
      {
        $tmp = trim($_POST['sg_customer_number_new']);
        if (!empty($tmp))
          $config_files[$use_key]['data']['customer_number'] = $tmp;
      }
      
      if (isset($_POST['sg_apikey_new']) && preg_match($allowed_chars, $_POST['sg_apikey_new']))
      {
        $tmp = trim($_POST['sg_apikey_new']);
        if (!empty($tmp))
          $config_files[$use_key]['data']['apikey'] = $tmp;
      }
      
      if (isset($_POST['sg_alias_new']) && preg_match($allowed_chars, $_POST['sg_alias_new']))
      {
        $tmp = trim($_POST['sg_alias_new']);
        if (!empty($tmp))
          $config_files[$use_key]['data']['alias'] = $tmp;
      }
      
      if (isset($_POST['sg_cname_new']) && preg_match($allowed_chars, $_POST['sg_cname_new']))
      {
        $tmp = trim($_POST['sg_cname_new']);
        if (!empty($tmp))
          $config_files[$use_key]['data']['cname'] = $tmp;
      }
      
      if (isset($_POST['sg_lang_new']) && array_key_exists($_POST['sg_lang_new'], $aLanguages))
      {
        $tmp = trim($_POST['sg_lang_new']);
        if (!empty($tmp))
          $config_files[$use_key]['data']['jtlSprache'] = $tmp;
        else
          $config_files[$use_key]['data']['jtlSprache'] = $nDefaultLanguage;
      }
    }
  }
  
  foreach ($config_files as $fkey => $fdata)
  {
    $fp = @fopen($fdata['file'], 'w+');
    if ($fp)
    {
      $content  = '<?php'.chr(10);
      $content .= '$shopgate_config = array ('.chr(10);
      foreach ($fdata['data'] as $pkey => $pValue)
        $content .= chr(9)."'$pkey' => '$pValue',".chr(10);
      $content .= ');'.chr(10);
      $content .= '?>';
      fwrite($fp, $content);
      fclose($fp);
      $sgLanguagesToShops[$config_files[$use_key]['data']['jtlSprache']] = $fkey;
    }
    if (!file_exists($fdata['file']))
      $config_files[$fkey]['writable'] = false;
    else
      $config_files[$fkey]['writable'] = is_writable($fdata['file']);
  }
  agi_plugin_saveConfig($oPlugin->cPluginID, 'sgLanguagesToShops', empty($sgLanguagesToShops) ? '' : serialize($sgLanguagesToShops));
}

$smarty->assign('shopConfigArray', $config_files);
$smarty->assign('cTextFileIsWritable', $textFileIsWritable);
$smarty->assign('cTextFileIsNotWritable', $textFileIsNotWritable);
$smarty->assign('bConfDirIsWritable',is_writable(PFAD_ROOT.'shopgate_library/config/'));
$smarty->assign('cShopgateConfigDir', PFAD_ROOT.'shopgate_library/config/');
$smarty->assign('aShopSprachen', $aLanguages);
$smarty->assign('aShopSpracheDefault', $nDefaultLanguage);
$smarty->assign('shop_new', $shopgateConfigDefault);

$smarty->assign('bTempDirIsWritable',is_writable(PFAD_ROOT.'shopgate_library/temp/'));
$smarty->assign('cShopgateTempDir', PFAD_ROOT.'shopgate_library/temp/');

$smarty->assign('bCacheDirIsWritable',is_writable(PFAD_ROOT.'shopgate_library/temp/cache/'));
$smarty->assign('cShopgateCacheDir', PFAD_ROOT.'shopgate_library/temp/cache/');

$smarty->assign('bLogDirIsWritable',is_writable(PFAD_ROOT.'shopgate_library/temp/logs/'));
$smarty->assign('cShopgateLogDir', PFAD_ROOT.'shopgate_library/temp/logs/');

$smarty->assign('valueSgRedirectActive', $aOptions['sgRedirectActive']);
$smarty->assign('titleSgRedirectActive', 'Mobile-Weiterleitung aktivieren');
$smarty->assign('descrSgRedirectActive', 'Soll die automatische Umleitung zum Shopgate-Shop aktiviert werden?');

$smarty->assign('SHOPGATE_PLUGIN_URL', URL_SHOP.'/shopgate_request/agi_shopgate_plugin.php');

$test_lizenz = false;
if (empty($oPlugin->cLizenz) || strtolower($oPlugin->cLizenz) == 'test')
  $test_lizenz = true;
$smarty->assign('IS_TEST_LIZENZ', $test_lizenz);

$smarty->assign("URL_SHOP", URL_SHOP);
$smarty->assign("URL_ADMINMENU", URL_SHOP . "/" . PFAD_PLUGIN . $oPlugin->cVerzeichnis . "/" . PFAD_PLUGIN_VERSION . $oPlugin->nVersion . "/" . PFAD_PLUGIN_ADMINMENU);
//$smarty->assign("stepPlugin", $stepPlugin);
print_r($smarty->fetch($oPlugin->cAdminmenuPfad . "template/api_config.tpl"));
?>