<?php
// Variablen die bei jedem Plugin existieren
// $GLOBALS['smarty']               Smarty Template Engine Object
// $GLOBALS['oPlugin']              Plugin Object
global $smarty, $oPlugin;

require_once(PFAD_ROOT.PFAD_CLASSES."class.JTL-Shop.Bestellung.php");

// Zähle alle vorhandenen Shopgate-Bestellungen
$tmp = $GLOBALS["DB"]->executeQuery("SELECT COUNT(*) AS icount FROM `xplugin_agi_shopgate_plugin_connect` AS xp, `tbestellung` AS tb WHERE tb.kBestellung = xp.kBestellung", 1);
$count_all = $tmp->icount;

$allowed['order_by']    = array('xp.created', 'xp.modified');
$allowed['order_by_asc'] = array('ASC', 'DESC');
$filter['order_by']     = 'xp.created';
$filter['order_by_asc'] = 'DESC';
$filter['db_amount']    = 30;
$filter['db_limit']     = 0;
$filter['nb_page']      = 1;

$max_pages = ceil($count_all/$filter['db_amount']);
if (empty($max_pages))
  $max_pages = 1;
// Formular wurde abgeschickt
if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['btn_show']))
{
  if (isset($_POST['psb_order_by']))
  {
    if (in_array($_POST['psb_order_by'], $allowed['order_by']))
      $filter['order_by'] = $_POST['psb_order_by'];
  }
  if (isset($_POST['psb_order_by_asc']))
  {
    if (in_array($_POST['psb_order_by_asc'], $allowed['order_by_asc']))
      $filter['order_by_asc'] = $_POST['psb_order_by_asc'];
  }
  if (isset($_POST['nb_page']))
  {
    $tmp = (int) $_POST['nb_page'];
    if ($tmp >= 1 && $tmp <= $max_pages)
      $filter['nb_page'] = $_POST['nb_page'];
  }
}

// calculate the output limit
$filter['db_limit'] = ($filter['nb_page']*$filter['db_amount'])-$filter['db_amount'];
if ($filter['db_limit'] < 0)
  $filter['db_limit'] = 0;

// Build actually query
$orders = $GLOBALS["DB"]->executeQuery("SELECT tb.*, xp.kBestellungShopgate, xp.created, xp.modified, xp.history FROM `xplugin_agi_shopgate_plugin_connect` AS xp, `tbestellung` AS tb WHERE tb.kBestellung = xp.kBestellung ORDER BY ".$filter['order_by']." ".$filter['order_by_asc']." LIMIT ".$filter['db_limit'].",".$filter['db_amount'], 2);
if (empty($orders))
  $orders = array();

$tmp_count = count($orders);
$count_shown = array();
$count_shown['from'] = $filter['db_limit']+1;
$count_shown['to']   = $count_shown['from']+$tmp_count-1;

$aOrder = array();
$iKey = 0;

foreach ($orders as $order)
{
  $oOrder = new Bestellung($order->kBestellung, true);
  $aOrder[$iKey] = array(
    'kBestellung'     => $oOrder->kBestellung,
    'kBestellungShopgate' => $order->kBestellungShopgate,
    'cVersandartName' => $oOrder->cVersandartName,
    'cZahlungsartName'=> $oOrder->cZahlungsartName,
    'cBestellNr'      => $oOrder->cBestellNr,
    'cVersandInfo'    => $oOrder->cVersandInfo,
    'dVersandDatum'   => $oOrder->dVersanddatum_de,
    'dBezahltDatum'   => $oOrder->dBezahldatum_de,
    'dErstellt'       => date('d.m.Y H:i', strtotime($order->created)),
    'dGeaendert'      => date('d.m.Y H:i', strtotime($order->modified)),
    'cKommentar'      => nl2br($oOrder->cKommentar),
    'bAbgeholt'       => $order->cAbgeholt == 'Y' ? true : false,
    'cStatus'         => $oOrder->Status,
    'cWaehrung'       => $oOrder->Waehrung->cISO,
    'cGesamtsumme'    => number_format($oOrder->fGesamtsumme,2,$oOrder->Waehrung->cTrennzeichenCent,$oOrder->Waehrung->cTrennzeichenTausend),
    'cHistory'        => nl2br(htmlentities($order->history)),
    'aKunde'          => array(
      'kKunde'          => isset($oOrder->oKunde) ? $oOrder->oKunde->kKunde   : 0,
      'cKundenNr'       => isset($oOrder->oKunde) ? $oOrder->oKunde->cKundenNr: '',
      'cAnrede'         => isset($oOrder->oKunde) ? $oOrder->oKunde->cAnrede  : $oOrder->oRechnungsadresse->cAnrede,
      'cVorname'        => isset($oOrder->oKunde) ? $oOrder->oKunde->cVorname : $oOrder->oRechnungsadresse->cVorname,
      'cNachname'       => isset($oOrder->oKunde) ? $oOrder->oKunde->cNachname: $oOrder->oRechnungsadresse->cNachname,
      'cFirma'          => isset($oOrder->oKunde) ? $oOrder->oKunde->cFirma   : $oOrder->oRechnungsadresse->cFirma,
      'cStrasse'        => isset($oOrder->oKunde) ? $oOrder->oKunde->cStrasse : $oOrder->oRechnungsadresse->cStrasse,
      'cHausnummer'     => isset($oOrder->oKunde) ? $oOrder->oKunde->cHausnummer : $oOrder->oRechnungsadresse->cHausnummer,
      'cPLZ'            => isset($oOrder->oKunde) ? $oOrder->oKunde->cPLZ     : $oOrder->oRechnungsadresse->cPLZ,
      'cOrt'            => isset($oOrder->oKunde) ? $oOrder->oKunde->cOrt     : $oOrder->oRechnungsadresse->cOrt,
      'cLand'           => isset($oOrder->oKunde) ? $oOrder->oKunde->cLand    : $oOrder->oRechnungsadresse->cLand,
      'cMail'           => isset($oOrder->oKunde) ? $oOrder->oKunde->cMail    : $oOrder->oRechnungsadresse->cMail,
    ),
    'aPositionen'       => array()
  );
  $aOrder[$iKey]['aKunde']['cName'] = empty($aOrder[$iKey]['aKunde']['cVorname']) ? $aOrder[$iKey]['aKunde']['cNachname'] : $aOrder[$iKey]['aKunde']['cVorname'].' '.$aOrder[$iKey]['aKunde']['cNachname'];
  foreach ($oOrder->Positionen as $position)
  {
    $wkEigenschaften = array();
    if (!empty($position->WarenkorbPosEigenschaftArr))
    {
      foreach ($position->WarenkorbPosEigenschaftArr as $eValue)
        $wkEigenschaften[] = $eValue->cEigenschaftName.': '.$eValue->cEigenschaftWertName;
    }
    $aOrder[$iKey]['aPositionen'][] = array(
      'nAnzahl'   => $position->nAnzahl,
      'cName'     => $position->cName,
      'cArtNr'    => $position->cArtNr,
      'fPreis'    => $position->cEinzelpreisLocalized[0],
      'cEigenschaften' => implode('<br />', $wkEigenschaften)
    );
  }
  $iKey++;
}

$smarty->assign('aBestellungen', $aOrder);
$smarty->assign('cAktuelleSeite', $filter['nb_page']);
$smarty->assign('cMaximaleSeite', $max_pages);
$smarty->assign('cAktuellAngezeigt', $count_shown['from'].' - '.$count_shown['to']);
$smarty->assign('cMaximalAngezeigt', $count_all);
$smarty->assign('filter_psb_order_by', $filter['order_by']);
$smarty->assign('filter_psb_order_by_asc', $filter['order_by_asc']);

$test_lizenz = false;
if (empty($oPlugin->cLizenz) || strtolower($oPlugin->cLizenz) == 'test')
  $test_lizenz = true;
$smarty->assign('IS_TEST_LIZENZ', $test_lizenz);

$smarty->assign("URL_SHOP", URL_SHOP);
$smarty->assign("URL_ADMINMENU", URL_SHOP . "/" . PFAD_PLUGIN . $oPlugin->cVerzeichnis . "/" . PFAD_PLUGIN_VERSION . $oPlugin->nVersion . "/" . PFAD_PLUGIN_ADMINMENU);
//$smarty->assign("stepPlugin", $stepPlugin);
print_r($smarty->fetch($oPlugin->cAdminmenuPfad . "template/shopgate_orders.tpl"));
?>