<?php
/* includes/plugins/agi_shopgate_plugin/version/105/api_plugin.php
.---------------------------------------------------------------------------.
|    Software: AGI Shopgate - JTL - Connector                               |
|     Version: 1.2                                                          |
|        Date: 2017-02-03                                                   |
|     Contact: info@andreas-guder.de                                        |
| ------------------------------------------------------------------------- |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2013 Andreas Guder [info@andreas-guder.de]                  |
|               All Rights Reserved.                                        |
|                      Based on Shopgate Example-Plugin                     |
'---------------------------------------------------------------------------ü
*/

require_once DIR_BASE_PATH.'/shopgate_library/shopgate.php';
require_once AGI_PLUGIN_PATH.'plugin.class.php';

class AGIShopgatePlugin extends AGIShopgatePluginBase
{
  protected $agi_mb_search_replace = array('search'=>array(),'replace'=>array());
  public $agi_ppp_instruction = '';
  
  /* called by $this->startup(); */
  public function agiStartup()
  {
    $this->_prepare_agi_mb_search_replace();
    $ppp_string = 'Bitte überweisen Sie den Betrag in Höhe von %value% bis zum %payment_due_date% auf das unten angegebene Konto

Empfänger: %account_holder_name%
IBAN: %international_bank_account_number%
BIC: %bank_identifier_code%
Name der Bank: %bank_name%
Referenznummer: %reference_number%

%company% hat die Forderung gegen Sie im Rahmen eines laufenden Factoringvertrages an die PayPal (Europe) S.àr.l. et Cie, S.C.A. abgetreten. Zahlungen mit schuldbefreiender Wirkung können nur an die PayPal (Europe) S.àr.l. et Cie, S.C.A. geleistet werden.
';

    $this->agi_ppp_instruction = utf8_decode($ppp_string);
    // empty
  }
  
  /* called by $this->getCustomer(); */
  public function agiGetCustomerIndividualAddData($customer)
  {
    // add individual customer-data here
    return $customer; // return manipulated $customer-Object
  }
  
  /* called by $this->createItems(); after configuration is load */
  public function agiCreateItemsOnStart()
  {
    // empty
  }
  
  /* called by $this->createCategories(); */
  public function agiOverwriteCategoriesArray($aKategories, $limit=null, $offset=null, $uids=array())
  {
    return $aKategories; // return manipulated $aKategorie-Array
  }
  public function agiManipulateCategoriesArrayItem($aItem)
  {
    return $aItem; // return manipulated $aItem-Array
  }
  
  /* manipulate article item object $this->oExportArticle */
  public function agiManipulateItemObject()
  {
    // empty
  }
  
  /* add JTL-AttributesAssoc to Description
    use this function to add and format items of $this->oExportArticle->AttributeAssoc to $this->oExportArticle->cBeschreibung
   */
  /* remove comments if needed
  public function agi_addAttributeAssocToDesc() {
    
    
  }
  */
  
  /* called by $this->addOrder(); */
  public function agiAddOrderIndividual($order)
  {
    /*
    if ($order->getOrderNumber() == '') {
      var_dump($order);
      exit;
    }
    */
    // do something
    // exit;
  }
  
  /* called by $this->updateOrder(); */
  public function agiUpdateOrderIndividual($order)
  {
    // do something
    // exit;
  }
  
  /* called by $this->registerCustomer(); */
  public function agiRegisterCustomerIndividual($user, $pass, $customer)
  {
    // do something
    // exit;
  }
  
  /* called by $this->checkStock(); */
  public function agiCheckStockIndividual($shopgateCart)
  {
    // do something
    // exit;
  }
  
  /* called by $this->checkCart(); */
  public function agiCheckCartIndividual($shopgateCart)
  {
    // do something
    // exit;
  }
  
  /* Payment-functions */
  /*
    use "agi_ownPaymentMethod_XXXX()"
    @param $order: Shopgate $order-Object
    @param $return_result: array
    return array
  
  public function agi_ownPaymentMethod_DEBIT($order, $return_result) {
    $paymentInfos = $order->getPaymentInfos();
    $return_result['paymentComment'] = '';
    $return_result['paymentComment'] .= 'bank_account_holder: '.$this->_prepare_string_for_jtl($paymentInfos["bank_account_holder"]).chr(10);
    $return_result['paymentComment'] .= 'iban: '.$this->_prepare_string_for_jtl($paymentInfos["iban"]).chr(10);
    $return_result['paymentComment'] .= 'bank_name: '.$this->_prepare_string_for_jtl($paymentInfos["bank_name"]).chr(10);
    $return_result['paymentComment'] .= 'bic: '.$this->_prepare_string_for_jtl($paymentInfos["bic"]).chr(10);
    
    return $return_result;
  }
  */

  public function agi_mb_replace($string) 
  {
    if (!empty($this->agi_mb_search_replace['search']) && !empty($string) && is_string($string))
      return str_replace($this->agi_mb_search_replace['search'],$this->agi_mb_search_replace['replace'],$string);
    else
      return $string;
  }
  protected function _prepare_agi_mb_search_replace() {
    $serach_replace = array();
    //polnisch
    $serach_replace[] = array('ą','a');
    $serach_replace[] = array('Ą','A');
    $serach_replace[] = array('ć','c');
    $serach_replace[] = array('Ć','C');
    $serach_replace[] = array('ę','e');
    $serach_replace[] = array('Ę','E');
    $serach_replace[] = array('ł','i');
    $serach_replace[] = array('Ł','L');
    $serach_replace[] = array('ń','n');
    $serach_replace[] = array('Ń','N');
    $serach_replace[] = array('Ó','O');
    $serach_replace[] = array('ó','o');
    $serach_replace[] = array('ś','s');
    $serach_replace[] = array('Ś','S');
    $serach_replace[] = array('ż','z');
    $serach_replace[] = array('Ż','Z');
    $serach_replace[] = array('ź','z');
    $serach_replace[] = array('Ź','Z');
    
    // Türkisch
    $serach_replace[] = array('Ç','C');
    $serach_replace[] = array('ç','c');
    $serach_replace[] = array('Ğ','G');
    $serach_replace[] = array('ğ','g');
    $serach_replace[] = array('İ','I');
    $serach_replace[] = array('Ş','S');
    $serach_replace[] = array('ş','s');
    
    $this->agi_mb_search_replace = array('search'=>array(),'replace'=>array());
    foreach ($serach_replace as $value) {
      $this->agi_mb_search_replace['search'][] = $value[0];
      $this->agi_mb_search_replace['replace'][] = $value[1];
    }
  }
}

$ShopgateFramework = new AGIShopgatePlugin();
$ShopgateFramework->handleRequest($_REQUEST);
?>