<?php
  class agi_shopgate_pluginPluginLicence implements PluginLizenz
  {
    private $buchstabenwert = array(
      'a'=>1, 'b'=>2, 'c'=>3, 'd'=>4, 'e'=>5, 'f'=>6, 'g'=>7, 'h'=>8, 'i'=>9, 'j'=>10, 'k'=>11, 'l'=>12, 'm'=>13, 
      'n'=>14, 'o'=>15, 'p'=>16, 'q'=>17, 'r'=>18, 's'=>19, 't'=>20, 'u'=>21, 'v'=>22, 'w'=>23, 'x'=>24, 'y'=>25, 'z'=>26
    );
    private $error_notice = '';
    
    public function getErrorNotice()
    {
      return $this->error_notice;
    }
    
    private function cleanText($string)
    {
      $string = strtolower($string);
      $string = str_replace(array('','','',''),array('ae','oe','ue','ss'),$string);
      $string = preg_replace('/\W+/', '-', $string);
      return $string;
    }
    
    private function getCheckSum($string)
    {
      $cs = 0;
      $check_array = str_split($string);
      foreach ($check_array as $row)
        $cs += array_key_exists($row, $this->buchstabenwert) ? $this->buchstabenwert[$row] : 0;
      $date = gmdate('ymd');
      $cs += (int)$date;
      return $cs;
    }
    
    private function getLiveCheckRequired()
    {
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `cValue` FROM `xplugin_agi_shopgate_plugin_config` WHERE `cKey`='livecheck'",
        1
      );
      $valdate = (int)gmdate('ymd')*4.3*100;
      if ($tmp)
      {
        settype($valdate, 'string');
        return $tmp->cValue == $valdate ? false : true;
      }
      else
      {
        $tmp = $GLOBALS["DB"]->executeQuery(
          "INSERT INTO `xplugin_agi_shopgate_plugin_config` (`cKey`,`cValue`) VALUES ('livecheck','0')",
          10
        );
      }
      return true;
    }
    
    public function checkLicence($cLicence)
    {
      $cLicence = strtolower($cLicence);
      $cLicence = preg_replace('/\s/', '', $cLicence);
      $lKey = (strlen($cLicence) > 0 && $cLicence != "test") ? $cLicence : '';
      
      if ($this->getLiveCheckRequired())
      {
        $domain = parse_url(URL_SHOP, PHP_URL_HOST);
        $domain = preg_replace('/^www\./', '', $domain);
        $ck = $this->getCheckSum($this->cleanText($domain).$this->cleanText($lKey));
        $pams = array(
          'domain' => rawurlencode($domain),
          'licence'=> rawurlencode($lKey),
          'ckey'   => rawurlencode($ck)
        );
        if (defined('AGI_PLUGIN_VERSION'))
          $pams['version'] = AGI_PLUGIN_VERSION;
        $lizenz_check = false;
        $ch = curl_init();
        if ($ch)
        {
          $parameter = '';
          foreach ($pams as $key => $value)
            $parameter .= empty($parameter) ? $key.'='.$value : '&'.$key.'='.$value;
          curl_setopt($ch, CURLOPT_TIMEOUT, 10);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
          curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
          curl_setopt($ch, CURLOPT_URL, 'http://pruefe-lizenz.agisolution.de/jtl_shopgate_plugin_new.php?'.$parameter);
          curl_setopt($ch, CURLOPT_HTTPGET, true);
          $response_body = curl_exec($ch);  
          $response_info = curl_getinfo($ch);
          if ($response_info['http_code'] == 200)
          {
            if (strlen($response_body) == 4 && $response_body == 'true')
            {
              $valdate = (int)gmdate('ymd')*4.3*100;
              $tmp = $GLOBALS["DB"]->executeQuery(
                "UPDATE `xplugin_agi_shopgate_plugin_config` SET `cValue`='$valdate' WHERE `cKey`='livecheck'",
                10
              );
              $lizenz_check = true;
            }
            else
            {
              $response_body = utf8_decode($response_body);
              $response_parts = explode(':',$response_body);
              $this->error_notice = $response_parts[1];
              $lizenz_check = false;
            }
          }
          elseif ($response_info['http_code'] == 204)
          {
            $lizenz_check = false;
          }
          else
          {
            $this->error_notice = 'Error '.$response_info['http_code'].chr(10).$response_body;
            $lizenz_check = true;
          }
        }
        else
          $this->error_notice = 'CURL ist nicht ativiert';
        curl_close($ch);
        return $lizenz_check;
        
      }
      return true;
    }
  }
?>
