<?php
/* includes/plugins/agi_shopgate_plugin/version/105/plugin.class.php
.---------------------------------------------------------------------------.
|    Software: AGI Shopgate - JTL - Connector                               |
|     Version: 1.0                                                          |
|        Date: 2014-09-15                                                   |
|     Contact: info@andreas-guder.de                                        |
| ------------------------------------------------------------------------- |
|      Author: Andreas Guder                                                |
|     Contact: info@andreas-guder.de                                        |
| Copyright (c) 2013 Andreas Guder [info@andreas-guder.de]                  |
|               All Rights Reserved.                                        |
|                      Based on Shopgate Example-Plugin                     |
'--------------------------------------------------------------------------'
IONCUBE!!
*/
define('SHOPGATE_PLUGIN_VERSION', AGI_PLUGIN_VERSION.': 2.06');
require_once DIR_BASE_PATH.'/classes/interface.JTL-Shop.PluginLizenz.php';
require_once AGI_PLUGIN_PATH.'licence/class.PluginLicence.php';
class AGIShopgatePluginBase extends ShopgatePlugin
{
  public $request_shop_number = 0;
  public $kSprache = 1;
  public $kKundengruppe = 1;
  public $oExportArticle = null;
  public $shopURLEndSlash = false;
  private $startExecutionTime = 0;
  private $maxExecutionTime = 55;
  private $fallback_steuersatz = 19;
  public $jtl_plugin_configuration = array();
  protected $aTeinstellungenFields = array();
  
  /** Variablen fr Produktexport */
  protected $aVersandart = array();
  protected $cLieferLand = 'DE';
  protected $cNurAbhaengigeVersandart = "N";
  protected $aKundengruppen = array();
  protected $aSteuerklassen = array();
  protected $aAttributNichtExportieren = array();
  protected $aAddDescAttribute = array();
  protected $inaktivStatus_Arr = array();
  public $cWrapDescriptionAttribute = '<p><strong>%s:</strong> %s</p>';
  private $cTrennzeichen = ';';
  private $tSprache = array('vat'=>'MwSt.');
  
  /// NECESSARY SHOPGATE FUNCTIONS ///
  /// BOF STARTUP-FUNCTIONS ///
  public function startup() 
  {
    $liz = new agi_shopgate_pluginPluginLicence();
    if (!$liz->checkLicence(AGI_PLUGIN_LICENCE))
    {
      Jtllog::writeLog('Shopgate-Plugin: '.$liz->getErrorNotice(), JTLLOG_LEVEL_ERRROR);
      throw new ShopgateLibraryException(ShopgateLibraryException::CONFIG_PLUGIN_NOT_ACTIVE, 'JTL-Plugin: '.$liz->getErrorNotice(), true);
      exit;
    }
    $this->startExecutionTime = time();
    $mt = @ini_get('max_execution_time');
    if (!empty($mt) && $mt > -1)
      $this->maxExecutionTime = $mt-5;
    
    $this->kKundengruppe = gibStandardKundengruppe();
    gibKundengruppe($this->kKundengruppe);
    $t = gibStandardsprache(true);
    $this->kSprache = $t->kSprache;
    if (isset($_REQUEST['shop_number']) && !empty($_REQUEST['shop_number']))
    {
      $this->request_shop_number = (int) $_REQUEST['shop_number'];
      $this->config = new ShopgateConfig(); 
      $this->config->loadByShopNumber((int) $_REQUEST['shop_number']);
      $this->config->setServer('live');
      $this->config->setApiUrl('https://api.shopgate.com/merchant/');
      $this->config->setEncoding('UTF-8');
      $this->config->setPluginName('ShopgatePluginJTL');
      $this->config->setEnableAddOrder(1);
      $this->config->setEnableUpdateOrder(1);
      $this->config->setEnableCheckStock(1);
      $this->config->setEnableGetCustomer(1);
      $this->config->setEnableRegisterCustomer(1);
      $this->config->setEnableGetItems(1);
      $this->config->setEnableGetCategories(1);
      $this->config->setEnableCron(1);
      $this->config->setEnableGetSettings(1);
      $this->config->setEnableCheckCart(1);
      $this->config->setEnableRedeemCoupons(1);
      $this->config->setEnableGetReviews(1);
      
      $this->config->setEnableGetOrders(0);
      $this->config->setEnableGetItemsCsv(0);
      $this->config->setEnableGetCategoriesCsv(1);
      $this->config->setEnableGetReviewsCsv(0);
      
      if (isset($this->config->jtlSprache) && !empty($this->config->jtlSprache))
        $this->kSprache = $this->config->jtlSprache;
    }
    else
      throw new ShopgateLibraryException(ShopgateLibraryException::PLUGIN_API_UNKNOWN_SHOP_NUMBER, '', true);
    
    // lese diverse Optionen
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `xplugin_agi_shopgate_plugin_config` ORDER BY `cKey`", 9);
    foreach ($aRes as $row)
    {
      $this->jtl_plugin_configuration[$row['cKey']] = $row['cValue'];
    }
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `twaehrung` WHERE `cStandard`='Y'", 1);
    if($aRes)
      $this->_setSessionVar('Waehrung', $aRes);
    else
    {
      $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `twaehrung` LIMIT 0,1", 1);
      if($aRes)
        $this->_setSessionVar('Waehrung', $aRes);
      else
        throw new ShopgateLibraryException(999, 'JTL-Plugin: Shopwaehrung kann nicht geladen werden', true);
    }
    if (substr(URL_SHOP,-1) == '/')
      $this->shopURLEndSlash = true;
    setzeSteuersaetze();
    $this->_setSessionVar('kSprache', $this->kSprache); 
    $this->_setSessionVar('cISOSprache', 'ger');
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT `cISO` FROM `tsprache` WHERE `kSprache`=".$this->kSprache, 1);
    if ($aRes)
    {
      $this->_setSessionVar('cISOSprache', $aRes->cISO);
      $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tsprache` WHERE `kSprache`=".$this->kSprache, 1);
      $this->_setSessionVar('Sprachen', array($aRes));
    }
    else
    {
      $t = gibStandardsprache(true);
      $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tsprache` WHERE `kSprache`=".$t->kSprache, 1);
      $this->_setSessionVar('Sprachen', array($aRes));
    }
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tsprachwerte` WHERE `cName` IN ('vat') AND `kSprachISO`=".$this->kSprache, 9);
    foreach ($aRes as $row)
      $this->tSprache[$row['cName']] = $row['cWert'];
    
    // lade teinstellungen
    $aTeinstellungenFields = array("'kundenregistrierung_standardland'","'bewertung_anzeigen'","'bewertung_freischalten'");
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `teinstellungen` WHERE `cName` IN (".implode(',', $aTeinstellungenFields).")", 9);
    foreach ($aRes as $row)
    {
      $this->aTeinstellungenFields[$row['cName']] = $row['cWert'];
    }
    $this->cLieferLand = $this->aTeinstellungenFields['kundenregistrierung_standardland'];
  }
  /// EOF STARTUP-FUNCTIONS ///
  
  /// BOF CATEGORIES-FUNCTIONS ///
  public function createCategories($limit = null, $offset = null, array $uids = array())
  {
    $aKategories = array();
    $aKategorieIDs = $this->_loadCategories($limit, $offset, $uids);
    foreach ($aKategorieIDs as $nID)
    {
      $oKategorie = new Kategorie($nID, $this->kSprache, $this->kKundengruppe);
      $item = array(
        'nID'       => $oKategorie->kKategorie,
        'name'      => $oKategorie->cName,
        'active'    => 1,
        'parentID'  => $oKategorie->kOberKategorie,
        'cDeeplink' => $this->shopURLEndSlash ? URL_SHOP.$oKategorie->cURL : URL_SHOP.'/'.$oKategorie->cURL,
        'nSort'     => 100000-$oKategorie->nSort,
        'hasImage'  => $oKategorie->nBildVorhanden,
        'cBild'     => $oKategorie->cBild
      );
      $aKategories[$nID] = $this->agiManipulateCategoriesArrayItem($item);
    }
    $aKategories = $this->agiOverwriteCategoriesArray($aKategories, $limit, $offset, $uids);
    
    foreach ($aKategories as $key => $value)
    {
      $categoryItem = new Shopgate_Model_Catalog_Category();
      $categoryItem->setUid($key);
      $categoryItem->setName($this->_pss(html_entity_decode($value['name'],ENT_QUOTES,"ISO-8859-15")));
      $categoryItem->setParentUid($value['parentID']);
      $categoryItem->setIsActive($value['active']); // AGI 20150202
      $categoryItem->setDeeplink($this->_pss($value['cDeeplink']));
      //$categoryItem->setIsAnchor(1);
      $categoryItem->setSortOrder($value['nSort']);
      if ($value['hasImage'])
      {
        $imageItem = new Shopgate_Model_Media_Image();
        $imageItem->setUid($key);
        //$imageItem->setSortOrder(10);
        $imageItem->setAlt($this->_pss($value['name']));
        $imageItem->setUrl($value['cBild']);
        $imageItem->setTitle($this->_pss($value['name']));
        $categoryItem->setImage($imageItem);
      }
      $this->addCategoryModel($categoryItem);
      if (time()-$this->startExecutionTime > $this->maxExecutionTime)
        break;
    }
  }
  public function createCategoriesCsv()
  {
    $aKategories = array();
    $aKategorieIDs = $this->_loadCategories();
    foreach ($aKategorieIDs as $nID)
    {
      $oKategorie = new Kategorie($nID, $this->kSprache, $this->kKundengruppe);
      $item = array(
        'nID'       => $oKategorie->kKategorie,
        'name'      => $oKategorie->cName,
        'active'    => 1,
        'parentID'  => $oKategorie->kOberKategorie,
        'cDeeplink' => $this->shopURLEndSlash ? URL_SHOP.$oKategorie->cURL : URL_SHOP.'/'.$oKategorie->cURL,
        'nSort'     => 100000-$oKategorie->nSort,
        'hasImage'  => $oKategorie->nBildVorhanden,
        'cBild'     => $oKategorie->cBild
      );
      $aKategories[$nID] = $this->agiManipulateCategoriesArrayItem($item);
    }
    $aKategories = $this->agiOverwriteCategoriesArray();
    
    foreach ($aKategories as $key => $value)
    {
      $row = $this->buildDefaultCategoryRow();
			$row['parent_id']       = $value['parentID'];
			$row['category_number'] = $key;
			$row['category_name']   = $this->_pss($value['name'], true);
			$row["is_active"]       = 1;
			$row['url_deeplink']    = $this->_pss($value['cDeeplink']);
      $row['order_index']     = $value['nSort'];
      if ($value['hasImage'])
        $row["url_image"] = $value['cBild'];
			$this->addCategoryRow($row);
      if (time()-$this->startExecutionTime > $this->maxExecutionTime)
        break;
    }
  }

  protected function _loadCategories($limit = null, $offset = null, array $uids = array())
  {
    if (!empty($uids))
    {
      $inUids = '';
      foreach ($uids as $value)
      {
        if (!empty($inUids))
          $inUids .= ',';
        $inUids .= "'".$value."'";
      }
      $result = $GLOBALS["DB"]->executeQuery(
        "SELECT 
          tkategorie.kKategorie
        FROM tkategorie
        LEFT JOIN tkategoriesichtbarkeit ON 
          tkategoriesichtbarkeit.kKategorie = tkategorie.kKategorie AND tkategoriesichtbarkeit.kKundengruppe=".$this->kKundengruppe."
        WHERE tkategorie.kKategorie IN ($inUids) AND tkategoriesichtbarkeit.kKategorie IS NULL
        ORDER BY tkategorie.kOberKategorie, tkategorie.kOberKategorie",
        9
      );
    }
    else
    {
      $sLimit = '';
      if (!empty($limit))
        $sLimit = (int) $limit;
      if (!empty($limit) && !empty($offset))
        $sLimit = ((int) $offset).','.$sLimit;
      if (!empty($sLimit))
        $sLimit = ' LIMIT '.$sLimit;
      $result = $GLOBALS["DB"]->executeQuery(
        "SELECT 
          tkategorie.kKategorie
        FROM tkategorie
        LEFT JOIN tkategoriesichtbarkeit ON 
          tkategoriesichtbarkeit.kKategorie = tkategorie.kKategorie AND tkategoriesichtbarkeit.kKundengruppe=".$this->kKundengruppe."
        WHERE tkategoriesichtbarkeit.kKategorie IS NULL
        ORDER BY tkategorie.kOberKategorie, tkategorie.kOberKategorie".$sLimit,
        9
      );
    }
    $aKategorieIDs = array();
    if (!empty($result))
    {
      foreach ($result as $value)
        $aKategorieIDs[$value['kKategorie']] = $value['kKategorie'];
    }
    return $aKategorieIDs;
  }
  /// EOF CATEGORIES-FUNCTIONS ///
  
  /// BOF ITEM-FUNCTIONS ///
  public function createItems($limit = null, $offset = null, array $uids = array())
  {
    $this->_loadCreateItemsConfig();
    $this->agiCreateItemsOnStart();
    $aItemIDs = $this->_loadItems($limit, $offset, $uids);
    
    foreach ($aItemIDs as $key => $value)
    {
      $this->_loadOExportArticle($key);
      $this->_prepareItemObject();
      if (time()-$this->startExecutionTime > $this->maxExecutionTime)
        break;
    }
  }
  protected function _loadOExportArticle($kArtikel)
  {
    $oArtikelOptionen = new stdClass(0);
    $oArtikelOptionen->nMerkmale = 1;
    $oArtikelOptionen->nAttribute = 1;
    $oArtikelOptionen->nArtikelAttribute = 1;
    $oArtikelOptionen->nKategorie = 1;
    $oArtikelOptionen->nKeinLagerbestandBeachten = 1;
    $oArtikelOptionen->nVariationKombiKinder = 1;
    //$oArtikelOptionen->nMedienDatei = 1; // Shop versucht sonst die URLs per CURL zu laden
    
    $this->oExportArticle = new Artikel();
    $this->oExportArticle->fuelleArtikel(
      $kArtikel,
      $oArtikelOptionen,
      $this->kKundengruppe,
      $this->kSprache
    );
  }
  protected function _loadCreateItemsConfig()
  {
    $this->cLieferLand = isset($_SESSION['cLieferlandISO']) ? $_SESSION['cLieferlandISO'] : 'DE';
    /** BOF Bestandspuffer und Lagerbestand 2014-04-07 */
    $this->jtl_plugin_configuration['aBestandspuffer'] = array();
    $this->jtl_plugin_configuration['maxBestand']      = 0;
    if (array_key_exists('cBestandspuffer', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['cBestandspuffer']))
    {
      $aBestandspuffer = array();
      $tmp = explode(',', $this->jtl_plugin_configuration['cBestandspuffer']);
      $maxBestand = 0;
      foreach ($tmp as $row)
      {
        $vars = explode(':', $row);
        if (count($vars) == 2 && !empty($vars[0]))
        {
          if (strtolower($vars[0]) == 'max')
            $maxBestand = empty($vars[1]) ? 0 : $vars[1];
          else
            $aBestandspuffer[(int)$vars[0]] = (int)$vars[1];
        }
      }
      ksort($aBestandspuffer, SORT_NUMERIC);
      $this->jtl_plugin_configuration['aBestandspuffer'] = $aBestandspuffer;
      $this->jtl_plugin_configuration['maxBestand']      = $maxBestand;
    }
    /** EOF Bestandspuffer und Lagerbestand 2014-04-07 */
    
    // Worte auslesen, die den Artikel deaktivieren
    if(array_key_exists('cInaktivStatusString', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['cInaktivStatusString']))
    {
      $temp = explode(';', $this->jtl_plugin_configuration['cInaktivStatusString']);
      foreach ($temp as $value)
      {
        $tmp = trim($value);
        if (!empty($tmp))
          $this->inaktivStatus_Arr[] = strtolower($tmp);
      }
    }
    
    // standard-versandart
    $this->aVersandart[$this->jtl_plugin_configuration['nStandardVersandklasse']] = $GLOBALS["DB"]->executeQuery(
      "SELECT *
        FROM tversandart
        WHERE cNurAbhaengigeVersandart='" . $this->cNurAbhaengigeVersandart . "'
        AND cLaender like \"%" . $this->cLieferLand . "%\"
        AND (
          cVersandklassen='-1' or 
          (cVersandklassen like \"% " . $this->jtl_plugin_configuration['nStandardVersandklasse'] . " %\" or cVersandklassen like \"% " . $this->jtl_plugin_configuration['nStandardVersandklasse'] . "\")
        )
        AND (cKundengruppen='-1' or cKundengruppen like '%;" . intval($this->kKundengruppe) . ";%') order by nSort
      ",
      2
    );
    
    // attribute, die nicht exportiert werden
    if (array_key_exists('cAttributNichtExportieren', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['cAttributNichtExportieren']))
    {
      $tmp = explode(',',$this->jtl_plugin_configuration['cAttributNichtExportieren']);
      foreach ($tmp as $value)
      {
        $value = trim($value);
        if (!empty($value))
          $this->aAttributNichtExportieren[] = strtolower($value);
      }
    }
    
    if (array_key_exists('cAttributeAnBeschreibung', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['cAttributeAnBeschreibung']))
    {
      $tmp = explode(',',$this->jtl_plugin_configuration['cAttributeAnBeschreibung']);
      foreach ($tmp as $value)
      {
        $value = trim($value);
        if (!empty($value))
          $this->aAddDescAttribute[] = strtolower($value);
      }
    }
    
    if (array_key_exists('cWrapAttributeAnBeschreibung', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['cWrapAttributeAnBeschreibung']))
    {
      $tmp = str_replace(array('[wert]', '[inhalt]'), array('%s', '%s'), $this->jtl_plugin_configuration['cWrapAttributeAnBeschreibung']);
      $tcount = array(
        'wert'  => substr_count($this->jtl_plugin_configuration['cWrapAttributeAnBeschreibung'], '[wert]'),
        'inhalt'=> substr_count($this->jtl_plugin_configuration['cWrapAttributeAnBeschreibung'], '[inhalt]')
      );
      if ($tcount['wert'] === 1 || $tcount['inhalt'] === 1)
        $this->cWrapDescriptionAttribute = $tmp;
    }

    // lade KundengruppenIds
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tkundengruppe`", 9);
    foreach ($aRes as $row)
      $this->aKundengruppen[] = $row['kKundengruppe'];
      
    // lade steuerklassen
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tsteuerklasse`", 9);
    foreach ($aRes as $row)
      $this->aSteuerklassen[$row['kSteuerklasse']] = $row;
    
    // lade teinstellungen
    $aTeinstellungenFields = array("'artikeldetails_attribute_anhaengen'");
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `teinstellungen` WHERE `cName` IN (".implode(',', $aTeinstellungenFields).")", 9);
    foreach ($aRes as $row)
    {
      $this->aTeinstellungenFields[$row['cName']] = $row['cWert'];
    }
  }
  protected function _loadItems($limit = null, $offset = null, array $uids = array())
  {
    if (!empty($uids))
    {
      $inUids = '';
      foreach ($uids as $value)
      {
        if (!empty($inUids))
          $inUids .= ',';
        $inUids .= "'".$value."'";
      }
      $result = $GLOBALS["DB"]->executeQuery(
        "SELECT 
          tartikel.kArtikel
        FROM tartikel
        LEFT JOIN tartikelsichtbarkeit ON 
          tartikelsichtbarkeit.kArtikel = tartikel.kArtikel AND tartikelsichtbarkeit.kKundengruppe=".$this->kKundengruppe."
        WHERE tartikel.kArtikel IN ($inUids) AND tartikel.kVaterArtikel=0 AND tartikelsichtbarkeit.kArtikel IS NULL
        ORDER BY kArtikel",
        9
      );
    }
    else
    {
      $sLimit = '';
      if (!empty($limit))
        $sLimit = (int) $limit;
      if (!empty($limit) && !empty($offset))
        $sLimit = ((int) $offset).','.$sLimit;
      if (!empty($sLimit))
        $sLimit = ' LIMIT '.$sLimit;
      $result = $GLOBALS["DB"]->executeQuery(
        "SELECT 
          tartikel.kArtikel
        FROM tartikel
        LEFT JOIN tartikelsichtbarkeit ON 
          tartikelsichtbarkeit.kArtikel = tartikel.kArtikel AND tartikelsichtbarkeit.kKundengruppe=".$this->kKundengruppe."
        WHERE tartikel.kVaterArtikel=0 AND tartikelsichtbarkeit.kArtikel IS NULL
        ORDER BY kArtikel".$sLimit,
        9
      );
    }
    $aItemIDs = array();
    if (!empty($result))
    {
      foreach ($result as $value)
        $aItemIDs[$value['kArtikel']] = $value;
    }
    return $aItemIDs;
  }
  protected function _prepareItemObject($thisIsChild = 0)
  {
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `dLetzteAktualisierung`, `kHersteller` FROM `tartikel` WHERE `kArtikel`=".$this->oExportArticle->kArtikel,
      1
    );
    $this->oExportArticle->cDeeplink = $this->shopURLEndSlash ? URL_SHOP.$this->oExportArticle->cURL : URL_SHOP.'/'.$this->oExportArticle->cURL;
    $this->oExportArticle->dLetzteAktualisierung = $tmp->dLetzteAktualisierung;
    $this->oExportArticle->kHersteller = $tmp->kHersteller;
    $this->oExportArticle->nHasChildren = $this->oExportArticle->nIstVater ? 1 : 0;
    $this->oExportArticle->cParentItemNumber = empty($this->oExportArticle->kVaterArtikel) ? '' : $this->oExportArticle->kVaterArtikel;
    
    $this->oExportArticle->fUst = gibUst($this->oExportArticle->kSteuerklasse);
    
    $this->_loadShippingCost();
    $this->_loadItemCategories();
    $this->_itemGetGrundpreis();
    $this->_itemCheckHightlight();
    $this->_itemCheckStatusAktiv();
    $this->_itemLoadAttributes();
    $this->_itemSetLieferstatus();
    $this->_itemLadeMediendateien();
    $this->_itemPrepareDescription();
    
    $this->agiManipulateItemObject();
    
    // write item
    $productItem = new Shopgate_Model_Catalog_Product();
    if ($thisIsChild)
      $productItem->setIsChild(1);
    
    $productItem->setUid($this->oExportArticle->kArtikel);
    //$productItem->setItemNumberPublic($this->_pss($this->oExportArticle->cArtNr));
    $productItem->setLastUpdate($this->oExportArticle->dLetzteAktualisierung);
    $productItem->setName($this->_pss(html_entity_decode($this->oExportArticle->cName,ENT_QUOTES,"ISO-8859-15")));
    $productItem->setTaxPercent($this->oExportArticle->fMwSt);
    $productItem->setTaxClass($this->_pss($this->aSteuerklassen[$this->oExportArticle->kSteuerklasse]['cName']));
    $productItem->setCurrency($_SESSION['Waehrung']->cISO);
    $productItem->setDescription($this->_pss($this->oExportArticle->cBeschreibung));
    $productItem->setDeeplink($this->oExportArticle->cDeeplink);
    if ($this->oExportArticle->nTopArtikel)
      $productItem->setPromotionSortOrder(10);
    $productItem->setWeight($this->oExportArticle->fGewicht);
    $productItem->setWeightUnit(Shopgate_Model_Catalog_Product::DEFAULT_WEIGHT_UNIT_KG);
    
    $priceItem = new Shopgate_Model_Catalog_Price();
    $priceItem->setType(Shopgate_Model_Catalog_Price::DEFAULT_PRICE_TYPE_NET);
    $agi_calc_price = $this->oExportArticle->Preise->fVK[1];
    if (!empty($this->oExportArticle->Preise->alterVK[1]) && $this->oExportArticle->Preise->alterVK[1] > $this->oExportArticle->Preise->fVK[1] && isset($this->oExportArticle->Preise->Sonderpreis_aktiv))
    {
      $priceItem->setPrice($this->oExportArticle->Preise->alterVK[1]);
      $priceItem->setSalePrice($this->oExportArticle->Preise->fVK[1]);
    }
    else
      $priceItem->setPrice($this->oExportArticle->Preise->fVK[1]);
    $priceItem->setMsrp(round($this->oExportArticle->fUVP*100/(100+$this->oExportArticle->fMwSt) *$_SESSION['Waehrung']->fFaktor,2));
    $priceItem->setMinimumOrderAmount(empty($this->oExportArticle->fMindestbestellmenge) ? 1 : $this->oExportArticle->fMindestbestellmenge);
    if ($this->oExportArticle->cVPE == 'Y')
    {
      $priceItem->setBasePrice($this->_pss(str_replace('&euro;', '',$this->oExportArticle->cLocalizedVPE[0])));
    }
    // BOF Staffelpreise
    $hatPreisstaffel = false;
    for ($i =1; $i<=5; $i++)
    {
      if (!empty($this->oExportArticle->Preise->{'nAnzahl'.$i}))
      {
        $hatPreisstaffel = true;
        break;
      }
    }
    $allow_tier_prices = true;
    if (isset($this->oExportArticle->nIstVater) && $this->oExportArticle->nIstVater == 1 && !$thisIsChild)
      $allow_tier_prices = false; // 2.01 20141219

    if ($allow_tier_prices && (count($this->aKundengruppen) > 1 || $hatPreisstaffel))
    {
      foreach ($this->aKundengruppen as $kKundengruppe)
      {
        $preise = new Preise($kKundengruppe, $this->oExportArticle->kArtikel);
        $preise->rabbatierePreise($this->oExportArticle->fMaxRabatt);
        $preise->localizePreise();
      
        $tierPriceItem = new Shopgate_Model_Catalog_TierPrice();
        $tierPriceItem->setAggregateChildren(0);
        $tierPriceItem->setCustomerGroupUid($kKundengruppe);
        $tierPriceItem->setReduction($agi_calc_price-$preise->fVK[1]);
        $tierPriceItem->setFromQuantity(1);
        $tierPriceItem->setReductionType(Shopgate_Model_Catalog_TierPrice::DEFAULT_TIER_PRICE_TYPE_FIXED);
        $priceItem->addTierPriceGroup($tierPriceItem);
        if ($hatPreisstaffel)
        {
          for ($i =1; $i<=5; $i++)
          {
            if (!empty($preise->{'nAnzahl'.$i}))
            {
              $tierPriceItem = new Shopgate_Model_Catalog_TierPrice();
              $tierPriceItem->setAggregateChildren(0);
              $tierPriceItem->setCustomerGroupUid($kKundengruppe);
              $tierPriceItem->setFromQuantity($preise->{'nAnzahl'.$i});
              //$tierPriceItem->setToQuantity(20);
              $tierPriceItem->setReduction($agi_calc_price-$preise->{'fStaffelpreis'.$i}[1]);
              $tierPriceItem->setReductionType(Shopgate_Model_Catalog_TierPrice::DEFAULT_TIER_PRICE_TYPE_FIXED);
              $priceItem->addTierPriceGroup($tierPriceItem);
            }
          }
        }
      }
    }
    // EOF Staffelpreise
    $productItem->setPrice($priceItem);
    $count_images = 0;
    if (isset($this->oExportArticle->Bilder))
    {
      foreach ($this->oExportArticle->Bilder as $value)
      {
        if ($thisIsChild == 0 || ($thisIsChild > 0 && strpos($value->cPfadGross, BILD_KEIN_ARTIKELBILD_VORHANDEN) === false))
        {
          $imageItem = new Shopgate_Model_Media_Image();
          $imageItem->setUid($this->oExportArticle->kArtikel.'_'.$value->nNr);
          $imageItem->setAlt(empty($value->cAltAttribut) ? $this->oExportArticle->cName : $value->cAltAttribut);
          $imageItem->setTitle(empty($value->cAltAttribut) ? $this->oExportArticle->cName : $value->cAltAttribut);
          $imageItem->setUrl($this->shopURLEndSlash ? URL_SHOP.$value->cPfadGross : URL_SHOP.'/'.$value->cPfadGross);
          $productItem->addImage($imageItem);
          $count_images++;
        }
      }
    }
    if ($thisIsChild > 0 && $count_images == 0)
    {
      // add parent images
      // lade steuerklassen
      $aRes = $GLOBALS["DB"]->executeQuery("
        SELECT * FROM `tartikelpict` WHERE `kArtikel`=".(int)$this->oExportArticle->kVaterArtikel." ORDER BY `nNr`", 2);
      foreach ($aRes as $row)
      {
        $imageItem = new Shopgate_Model_Media_Image();
        $imageItem->setUid($this->oExportArticle->kArtikel.'_'.$row->nNr);
        $imageItem->setAlt($this->oExportArticle->cName);
        $imageItem->setTitle($this->oExportArticle->cName);
        $imageItem->setUrl($this->shopURLEndSlash ? URL_SHOP.PFAD_PRODUKTBILDER_GROSS.$row->cPfad : URL_SHOP.'/'.PFAD_PRODUKTBILDER_GROSS.$row->cPfad);
        $productItem->addImage($imageItem);
      }
    }
    
    foreach ($this->oExportArticle->aAGIKategorien as $value)
    {
      $categoryPathItem = new Shopgate_Model_Catalog_CategoryPath();
      $categoryPathItem->setUid($value['kKategorie']);
      $categoryPathItem->setSortOrder($this->_getArticleSortInCategory($value['kKategorie']));
      $categoryPathItem->setDeeplink($value['cDeeplink']);
      foreach($value['paths'] as $level => $path)
      {
        $categoryPathItem->addItem($level, $this->_pss($path));
      }
      if (!empty($value['image']))
      {
        $imageItem = new Shopgate_Model_Media_Image();
        $imageItem->setUid($value['kKategorie']);
        $imageItem->setAlt($this->_pss($value['cName']));
        $imageItem->setTitle($this->_pss($value['cName']));
        $imageItem->setUrl($value['image']);
        $categoryPathItem->addImage($imageItem);
      }
      $productItem->addCategoryPath($categoryPathItem);
    }
    
    $shippingItem = new Shopgate_Model_Catalog_Shipping();
    $shippingItem->setIsFree($this->oExportArticle->nOhneVersandkosten);
    $shippingItem->setCostsPerOrder($this->oExportArticle->fVersandkosten);
    $productItem->setShipping($shippingItem);
    
    if (isset($this->oExportArticle->kHersteller) && !empty($this->oExportArticle->kHersteller))
    {
      $manufacturerItem = new Shopgate_Model_Catalog_Manufacturer();
      $manufacturerItem->setUid($this->oExportArticle->kHersteller);
      $manufacturerItem->setTitle($this->_pss($this->oExportArticle->cHersteller));
      $manufacturerItem->setItemNumber($this->oExportArticle->cHAN);
      $productItem->setManufacturer($manufacturerItem);
    }
    
    $stockItem = new Shopgate_Model_Catalog_Stock();
    $stockItem->setStockQuantity($this->oExportArticle->fLagerbestand);
    $stockItem->setAvailabilityText($this->_pss($this->_remove_html($this->oExportArticle->agiLieferstatus)));
    $stockItem->setBackorders(1);
    $stockItem->setIsSaleable($this->oExportArticle->cStatusAktiv == 'inactive' ? 0 : 1);
    $stockItem->setUseStock($this->oExportArticle->nUseStock);
    $stockItem->setMinimumOrderQuantity(empty($this->oExportArticle->fMindestbestellmenge) ? 1 : $this->oExportArticle->fMindestbestellmenge);
    $productItem->setStock($stockItem);
    
    if (isset($this->oExportArticle->Attribute) && !empty($this->oExportArticle->Attribute))
    {
      foreach ($this->oExportArticle->Attribute as $value)
      {
        if (!in_array(strtolower($value->cName), $this->aAttributNichtExportieren))
        {
          $propertyItem = new Shopgate_Model_Catalog_Property();
          $propertyItem->setUid(md5($value->cName));
          $propertyItem->setLabel($this->_pss($value->cName));
          $propertyItem->setValue($this->_pss($value->cWert));
          $productItem->addProperty($propertyItem);
        }
      }
    }
    if (isset($this->oExportArticle->oMerkmale_arr) && !empty($this->oExportArticle->oMerkmale_arr))
    {
      foreach ($this->oExportArticle->oMerkmale_arr as $value)
      {
        foreach ($value->oMerkmalWert_arr AS $wert)
        {
          $propertyItem = new Shopgate_Model_Catalog_Property();
          $propertyItem->setUid($value->kMerkmal.'_'.$wert->kMerkmalWert);
          $propertyItem->setLabel($this->_pss($value->cName));
          $propertyItem->setValue($this->_pss($wert->cWert));
          $productItem->addProperty($propertyItem);
        }
      }
    }
    
    if (isset($this->oExportArticle->cArtNr) && !empty($this->oExportArticle->cArtNr) && $this->oExportArticle->cArtNr != 'n/a')
    {
      $identifierItem = new Shopgate_Model_Catalog_Identifier();
      $identifierItem->setUid(md5('cArtNr'));
      $identifierItem->setType($this->_pss('sku'));
      $identifierItem->setValue($this->_pss($this->oExportArticle->cArtNr));
      $productItem->addIdentifier($identifierItem);
    }
    if (isset($this->oExportArticle->cISBN) && !empty($this->oExportArticle->cISBN) && $this->oExportArticle->cISBN != 'n/a')
    {
      if (!preg_match('/[^\d\-]/', $this->oExportArticle->cBarcode))
      {
        $identifierItem = new Shopgate_Model_Catalog_Identifier();
        $identifierItem->setUid(md5('cISBN'));
        $identifierItem->setType($this->_pss('isbn'));
        $identifierItem->setValue($this->_pss($this->oExportArticle->cISBN));
        $productItem->addIdentifier($identifierItem);
      }
    }
    /*
    if (isset($this->oExportArticle->cASIN) && !empty($this->oExportArticle->cASIN) && $this->oExportArticle->cASIN != 'n/a')
    {
      $identifierItem = new Shopgate_Model_Catalog_Identifier();
      $identifierItem->setUid(md5('cASIN'));
      $identifierItem->setType($this->_pss('asin'));
      $identifierItem->setValue($this->_pss($this->oExportArticle->cASIN));
      $productItem->addIdentifier($identifierItem);
    }
    */
    if (isset($this->oExportArticle->cBarcode) && !empty($this->oExportArticle->cBarcode) && $this->oExportArticle->cBarcode != 'n/a')
    {
      if (!preg_match('/[^\d]/', $this->oExportArticle->cBarcode))
      {
        $identifierItem = new Shopgate_Model_Catalog_Identifier();
        $identifierItem->setUid(md5('cEAN'));
        $identifierItem->setType($this->_pss('ean'));
        $identifierItem->setValue($this->_pss($this->oExportArticle->cBarcode));
        $productItem->addIdentifier($identifierItem);
      }
    }
    if (isset($this->oExportArticle->cUPC) && !empty($this->oExportArticle->cUPC) && $this->oExportArticle->cUPC != 'n/a')
    {
      if (!preg_match('/[^\d]/', $this->oExportArticle->cUPC))
      {
        $identifierItem = new Shopgate_Model_Catalog_Identifier();
        $identifierItem->setUid(md5('cUPC'));
        $identifierItem->setType($this->_pss('upc'));
        $identifierItem->setValue($this->_pss($this->oExportArticle->cUPC));
        $productItem->addIdentifier($identifierItem);
      }
    }
    /*
    if (isset($this->oExportArticle->cUNNummer) && !empty($this->oExportArticle->cUNNummer) && $this->oExportArticle->cUNNummer != 'n/a')
    {
      $identifierItem = new Shopgate_Model_Catalog_Identifier();
      $identifierItem->setUid(md5('cUNNummer'));
      $identifierItem->setType($this->_pss('UNNummer'));
      $identifierItem->setValue($this->_pss($this->oExportArticle->cUNNummer));
      $productItem->addIdentifier($identifierItem);
    }
    */
    
    if (isset($this->oExportArticle->cSuchbegriffe) && !empty($this->oExportArticle->cSuchbegriffe))
    {
      $tmp = explode('  ', $this->oExportArticle->cSuchbegriffe);
      foreach ($tmp as $ttag)
      {
        $ttag = trim($ttag);
        if (!empty($ttag))
        {
          $tagItem = new Shopgate_Model_Catalog_Tag();
          //$tagItem->setUid(md5($ttag));
          $tagItem->setValue($ttag);
          $productItem->addTag($tagItem);
        }
      }
    }
    
    $visibilityItem = new Shopgate_Model_Catalog_Visibility();
    $visibilityItem->setLevel(Shopgate_Model_Catalog_Visibility::DEFAULT_VISIBILITY_CATALOG_AND_SEARCH);
    $visibilityItem->setMarketplace(1);
    $productItem->setVisibility($visibilityItem);
    
    if (isset($this->oExportArticle->aInputAttribute) && !empty($this->oExportArticle->aInputAttribute))
    {
      foreach ($this->oExportArticle->aInputAttribute as $value)
      {
        $inputItem = new Shopgate_Model_Catalog_Input();
        $inputItem->setType(Shopgate_Model_Catalog_Input::DEFAULT_INPUT_TYPE_TEXT);
        $inputItem->setUid($value['kEigenschaft']);
        $inputItem->setRequired($value['nRequired']);
        $inputItem->setLabel($this->_pss($value['cName']));
        $inputItem->setInfoText($this->_pss($value['cInfoText']));
        $inputItem->setAdditionalPrice(0);
        
        $validationItem = new Shopgate_Model_Catalog_Validation();
        $validationItem->setValidationType(Shopgate_Model_Catalog_Validation::DEFAULT_VALIDATION_VARIABLE_STRING);
        $inputItem->setValidation($validationItem);
        $productItem->addInput($inputItem);
      }
    }
    
    if (isset($this->oExportArticle->aSelectAttribute) && !empty($this->oExportArticle->aSelectAttribute))
    {
      foreach ($this->oExportArticle->aSelectAttribute as $value)
      {
        $inputItem = new Shopgate_Model_Catalog_Input();
        $inputItem->setType(Shopgate_Model_Catalog_Input::DEFAULT_INPUT_TYPE_SELECT);
        $inputItem->setUid($value['kEigenschaft']);
        $inputItem->setRequired($value['nRequired']);
        $inputItem->setLabel($this->_pss($value['cName']));
        //$inputItem->setInfoText($this->_pss($value['cInfoText']));// Habe ich einen Infotext fr die Attribute? in aArtikel prfen!
        $sold_out = count($value['aWerte']);
        foreach ($value['aWerte'] as $row)
        {
          if ($this->oExportArticle->cStatusAktiv == 'active' || ($this->oExportArticle->cStatusAktiv == 'stock' && ($row['fLagerbestand'] > 0 || $this->oExportArticle->cLagerVariation == 'N')))
          {
            $optionModel = new Shopgate_Model_Catalog_Option();
            $optionModel->setUid($row['kEigenschaftWert']);
            $optionModel->setLabel($this->_pss($row['cName']));
            $optionModel->setValue($row['kEigenschaftWert']);
            $optionModel->setAdditionalPrice($row['fAufpreisNetto']);
            $inputItem->addOption($optionModel);
          }
          else
            $sold_out--;
        }
        
        $validationItem = new Shopgate_Model_Catalog_Validation();
        $validationItem->setValidationType(Shopgate_Model_Catalog_Validation::DEFAULT_VALIDATION_VARIABLE_INT);
        $inputItem->setValidation($validationItem);
        if ($sold_out > 0)
          $productItem->addInput($inputItem);
      }
    }
    
    // Jetzt schauen, ob es Vater-Kind-Artikel gibt, wenn ja, die Attribute abgreifen und ausgeben
    if (isset($this->oExportArticle->nIstVater) && $this->oExportArticle->nIstVater == 1 && !$thisIsChild)
    {
      if (isset($this->oExportArticle->oVariationenNurKind_arr) && !empty($this->oExportArticle->oVariationenNurKind_arr))
      {
        foreach ($this->oExportArticle->oVariationenNurKind_arr as $row)
        {
          if ($this->oExportArticle->nIstVater)
          {
            $attributeGroupItem = new Shopgate_Model_Catalog_AttributeGroup();
            $attributeGroupItem->setUid($row->kEigenschaft);
            $attributeGroupItem->setLabel($this->_pss($row->cName));
            $productItem->addAttributeGroup($attributeGroupItem);
          }
        }
      }
      
      // Kinder auslesen
      $oVariationsKombiKinder_arr = $GLOBALS['DB']->executeQuery("SELECT DISTINCT tartikel.kArtikel
        FROM teigenschaftkombiwert
        JOIN tartikel ON tartikel.kEigenschaftKombi = teigenschaftkombiwert.kEigenschaftKombi
            AND tartikel.kVaterArtikel = " . $this->oExportArticle->kArtikel . "
        LEFT JOIN tartikelsichtbarkeit ON tartikel.kArtikel = tartikelsichtbarkeit.kArtikel
            AND tartikelsichtbarkeit.kKundengruppe=" . $this->kKundengruppe . "
        WHERE tartikelsichtbarkeit.kArtikel IS NULL
        ORDER BY tartikel.kArtikel, teigenschaftkombiwert.kEigenschaft", 2);
      if(is_array($oVariationsKombiKinder_arr) && count($oVariationsKombiKinder_arr) > 0)
      {
        foreach ($oVariationsKombiKinder_arr as $row)
        {
          $this->_loadOExportArticle($row->kArtikel);
          $childItem = $this->_prepareItemObject($row->kArtikel);
          $productItem->addChild($childItem);
        }
      }
    }
    elseif ($thisIsChild)
    {
      if (isset($this->oExportArticle->oVariationenNurKind_arr) && !empty($this->oExportArticle->oVariationenNurKind_arr))
      {
        foreach ($this->oExportArticle->oVariationenNurKind_arr as $row)
        {
          if(!empty($this->oExportArticle->kVaterArtikel) && !empty($row->Werte[0]))
          {
            $attributeItem = new Shopgate_Model_Catalog_Attribute();
            $attributeItem->setUid($row->Werte[0]->kEigenschaftWert);
            $attributeItem->setGroupUid($row->kEigenschaft);
            $attributeItem->setLabel($this->_pss($row->Werte[0]->cName));
            $productItem->addAttribute($attributeItem);
          }
        }
      }
    }
    if (!$thisIsChild)
      $this->addItemModel($productItem);
    else
      return $productItem;
  }
  protected function _loadShippingCost()
  {
    $this->oExportArticle->cLieferland        = $this->cLieferLand;
    $this->oExportArticle->nOhneVersandkosten = 0;
    $this->oExportArticle->fVersandkosten     = 0;
    if ($this->oExportArticle->kVersandklasse != $this->jtl_plugin_configuration['nStandardVersandklasse'])
    {
      if (!array_key_exists($this->oExportArticle->kVersandklasse, $this->aVersandart))
      {
        $this->aVersandart[$this->oExportArticle->kVersandklasse] = $GLOBALS["DB"]->executeQuery(
          " SELECT *
            FROM tversandart
						WHERE cNurAbhaengigeVersandart='" . $this->cNurAbhaengigeVersandart . "'
						AND cLaender like \"%" . $this->cLieferLand . "%\"
						AND (
              cVersandklassen='-1' or 
              (cVersandklassen like \"% " . $this->oExportArticle->kVersandklasse . " %\" or cVersandklassen like \"% " . $this->oExportArticle->kVersandklasse . "\")
            )
						AND (cKundengruppen='-1' or cKundengruppen like '%;" . intval($this->kKundengruppe) . ";%') order by nSort
          ",
          2
        );
      }
      $price = 0;
      $fStandardVersand = 0;
      foreach ($this->aVersandart[$this->jtl_plugin_configuration['nStandardVersandklasse']] as $row)
      {
        $tmp = berechneVersandpreis($row, $this->cLieferLand, null, $this->oExportArticle);
        if ($tmp != -1)
        {
          $fStandardVersand = $tmp;
          break;
        }
      }
      
      $fArtikelVersand = 0;
      foreach ($this->aVersandart[$this->oExportArticle->kVersandklasse] as $row)
      {
        $tmp = berechneVersandpreis($row, $this->cLieferLand, null, $this->oExportArticle);
        if ($tmp != -1)
        {
          if ($tmp > 0 && $tmp < $fArtikelVersand)
            $fArtikelVersand = $tmp;
          elseif ($fArtikelVersand == 0 && $tmp > 0)
            $fArtikelVersand = $tmp;
          break;
        }
        else
          continue;
      }
      $differenz = $fArtikelVersand - $fStandardVersand;
      if ($differenz > 0)
        $differenz = $differenz*100/(100+$this->oExportArticle->fUst);
      $this->oExportArticle->fVersandkosten = $differenz < 0 ? 0 : round($differenz,3);
    }
  }
  protected function _loadItemCategories()
  {
    $this->oExportArticle->aAGIKategorien = array();
    if(count($this->oExportArticle->oKategorie_arr) > 0)
    {
      foreach ($this->oExportArticle->oKategorie_arr as $oCategorie)
      {
        $kat = array(
          'kKategorie'    => $oCategorie->kKategorie,
          'cName'         => $oCategorie->cName,
          'nSort'         => $oCategorie->nSort,
          'kOberKategorie'=> $oCategorie->kOberKategorie,
          'cDeeplink'     => $oCategorie->cURL,
          'paths'         => array(),
          'image'         => $oCategorie->nBildVorhanden ? $oCategorie->cBild : ''
        );
        $i = 1;
        foreach ($oCategorie->cKategoriePfad_arr as $value)
        {
          $kat['paths'][$i] = $value;
          $i++;
        }
        $this->oExportArticle->aAGIKategorien[] = $kat;
      }
    }
  }
  protected function _itemCheckHightlight()
  {
    if (isset($this->jtl_plugin_configuration['cTopArticleAsHighlight']) && $this->jtl_plugin_configuration['cTopArticleAsHighlight'] == 'Y')
      $this->oExportArticle->nTopArtikel = $this->oExportArticle->cTopArtikel == 'Y' ? 1 : 0;
    else
      $this->oExportArticle->nTopArtikel = 0;
      
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT 
        COUNT(*) AS icount 
      FROM 
        `tartikelsonderpreis` 
      WHERE 
        `kArtikel`='".$this->oExportArticle->kArtikel."' AND `cAktiv`='Y' AND `dStart` <= date(now()) AND (`dEnde` >= date(now()) OR `dEnde`='0000-00-00')
      ",
      1
    );
    if (!empty($tmp->icount))
      $this->oExportArticle->nTopArtikel = 1;
    return true;
  }
  protected function _itemCheckStatusAktiv()
  {
    /** BOF dErscheinungsdatum 2014-01-17 */
    if (isset($this->oExportArticle->dErscheinungsdatum))
    {
      if (!empty($this->oExportArticle->dErscheinungsdatum) && $this->oExportArticle->dErscheinungsdatum != '0000-00-00')
      {
        if (strtotime($this->oExportArticle->dErscheinungsdatum) > time())
        {
          $this->oExportArticle->cStatusAktiv = 'inactive';
          $this->oExportArticle->fLagerbestand= 0;
          $this->oExportArticle->nUseStock = 1;
          return true;
        }
      }
    }
    /** EOF dErscheinungsdatum 2014-01-17 */
    /** BOF Bestandspuffer und Lagerbestand 2014-04-07 */
    if (array_key_exists('aBestandspuffer', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['aBestandspuffer']) && $this->oExportArticle->fLagerbestand > 0)
    {
      foreach ($this->jtl_plugin_configuration['aBestandspuffer'] as $maxKey => $setValue)
      {
        if ($this->oExportArticle->fLagerbestand <= $maxKey)
        {
          $this->oExportArticle->fLagerbestand -= $setValue;
          if ($this->oExportArticle->fLagerbestand < 0)
            $this->oExportArticle->fLagerbestand = 0;
          break;
        }
      }
    }
    if (array_key_exists('maxBestand', $this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['maxBestand']))
    {
      if ($this->oExportArticle->fLagerbestand > $this->jtl_plugin_configuration['maxBestand'])
        $this->oExportArticle->fLagerbestand = $this->jtl_plugin_configuration['maxBestand'];
    }
    /** EOF Bestandspuffer und Lagerbestand 2014-04-07 */
    
    foreach ($this->inaktivStatus_Arr as $tmp)
    {
      if (strtolower($this->oExportArticle->cLieferstatus) == $tmp)
      {
        $this->oExportArticle->cStatusAktiv = 'inactive';
        $this->oExportArticle->fLagerbestand= 0;
        $this->oExportArticle->nUseStock = 1;
        return true;
      }
    }
    
    if (isset($this->oExportArticle->inWarenkorbLegbar) && $this->oExportArticle->inWarenkorbLegbar == -1)
    {
      $this->oExportArticle->cStatusAktiv = 'inactive';
      $this->oExportArticle->fLagerbestand= 0;
      $this->oExportArticle->nUseStock = 1;
      return true;
    }

    if (isset($this->oExportArticle->cLagerBeachten))
    {
      if ($this->oExportArticle->cLagerBeachten == 'Y')
      {
        if (isset($this->oExportArticle->cLagerKleinerNull) && $this->oExportArticle->cLagerKleinerNull == 'Y')
        {
          $this->oExportArticle->cStatusAktiv = 'active';
          $this->oExportArticle->nUseStock = 0;
        }
        else
        {
          $this->oExportArticle->cStatusAktiv = 'stock';
          $this->oExportArticle->nUseStock = 1;
        }
      }
      else
      {
        $this->oExportArticle->cStatusAktiv = 'active';
        $this->oExportArticle->nUseStock = 0;
      }
    }
    else
    {
      $this->oExportArticle->cStatusAktiv = 'stock';
      $this->oExportArticle->nUseStock = 1;
    }
    
    if ($this->oExportArticle->fLagerbestand < 0)
      $this->oExportArticle->fLagerbestand = 0;
    return true;
  }
  protected function _itemGetGrundpreis()
  {
    $this->oExportArticle->Grundpreis = '';
    if ($this->oExportArticle->cVPE == 'Y' && $this->oExportArticle->fVPEWert > 0)
    {
      $this->oExportArticle->Grundpreis = $this->oExportArticle->cLocalizedVPE[1];
    }
  }
  protected function _itemLoadAttributes()
  {
    $this->oExportArticle->aInputAttribute = array();
    $this->oExportArticle->aSelectAttribute = array();
    $aVaterKindEigenschaftenKeys = array();
    if (isset($this->oExportArticle->oVariationenNurKind_arr) && !empty($this->oExportArticle->oVariationenNurKind_arr))
    {
      foreach ($this->oExportArticle->oVariationenNurKind_arr as $row)
        $aVaterKindEigenschaftenKeys[] = $row->kEigenschaft;
    }
    if (isset($this->oExportArticle->Variationen) && !empty($this->oExportArticle->Variationen) && !$this->oExportArticle->nIstVater && !$this->oExportArticle->kVaterArtikel)
    {
      foreach ($this->oExportArticle->Variationen as $variation)
      {
        if ($variation->nLieferbareVariationswerte <= 0 || in_array($variation->kEigenschaft, $aVaterKindEigenschaftenKeys))
          continue;
        
        if (strpos(strtolower($variation->cTyp), 'freifeld') !== FALSE)
        {
          $data = array(
            'kEigenschaft'  => $variation->kEigenschaft,
            'cType'         => 'text',
            'cName'         => $variation->cName,
            'cInfoText'     => '',
            'nRequired'     => strpos(strtolower($variation->cTyp), 'pflicht-freifeld') !== FALSE ? 1 : 0
          );
          $this->oExportArticle->aInputAttribute[$variation->kEigenschaft] = $data;
        }
        else
        {
          $data = array(
            'kEigenschaft'  => $variation->kEigenschaft,
            'cType'         => 'select',
            'cName'         => $variation->cName,
            'aWerte'        => array(),
            'nRequired'     => 1
          );
          foreach ($variation->Werte as $value)
          {
            $dataWert = array(
              'kEigenschaftWert'  => $value->kEigenschaftWert,
              'cName'             => $value->cName,
              'fAufpreisNetto'    => isset($value->fAufpreis) ? $value->fAufpreis[1] *$_SESSION['Waehrung']->fFaktor : 0,
              'fAufpreisBrutto'   => isset($value->fAufpreis) ? $value->fAufpreis[0] *$_SESSION['Waehrung']->fFaktor : 0,
              'cArtNr'            => empty($value->cArtNr) ? '' : $value->cArtNr,
              'fGewichtDiff'      => empty($value->fGewichtDiff) ? 0 : $value->fGewichtDiff,
              'fLagerbestand'     => empty($value->fLagerbestand) ? 0 : $value->fLagerbestand
            );
            $data['aWerte'][$value->kEigenschaftWert] = $dataWert;
          }
          if (!empty($data['aWerte']))
            $this->oExportArticle->aSelectAttribute[$variation->kEigenschaft] = $data;
        }
      }
    }
  }
  protected function _itemSetLieferstatus()
  {
    $this->oExportArticle->agiLieferstatus = $this->oExportArticle->cLieferstatus;
    if (isset($this->jtl_plugin_configuration['cNehmeLieferzeit']) && $this->jtl_plugin_configuration['cNehmeLieferzeit'] == 'ampel')
    {
      if (isset($this->oExportArticle->Lageranzeige) && isset($this->oExportArticle->Lageranzeige->AmpelText) && !empty($this->oExportArticle->Lageranzeige->AmpelText))
        $this->oExportArticle->agiLieferstatus = $this->oExportArticle->Lageranzeige->AmpelText;
      elseif (isset($this->oExportArticle->Lageranzeige) && isset($this->oExportArticle->Lageranzeige->cLagerhinweis) && !empty($this->oExportArticle->Lageranzeige->cLagerhinweis))
        $this->oExportArticle->agiLieferstatus = $this->oExportArticle->Lageranzeige->cLagerhinweis['verfuegbarkeit'];
    }
    elseif (isset($this->jtl_plugin_configuration['cNehmeLieferzeit']) && $this->jtl_plugin_configuration['cNehmeLieferzeit'] == 'zeit')
    {
      if (isset($this->oExportArticle->cEstimatedDelivery) && !empty($this->oExportArticle->cEstimatedDelivery))
        $this->oExportArticle->agiLieferstatus = $this->oExportArticle->cEstimatedDelivery;
    }
    
    if (empty($this->oExportArticle->agiLieferstatus))
    {
      if (isset($this->oExportArticle->Lageranzeige) && isset($this->oExportArticle->Lageranzeige->AmpelText) && !empty($this->oExportArticle->Lageranzeige->AmpelText))
        $this->oExportArticle->agiLieferstatus = $this->oExportArticle->Lageranzeige->AmpelText;
      elseif (isset($this->oExportArticle->Lageranzeige) && isset($this->oExportArticle->Lageranzeige->cLagerhinweis) && !empty($this->oExportArticle->Lageranzeige->cLagerhinweis))
        $this->oExportArticle->agiLieferstatus = $this->oExportArticle->Lageranzeige->cLagerhinweis['verfuegbarkeit'];
      elseif (isset($this->oExportArticle->cEstimatedDelivery) && !empty($this->oExportArticle->cEstimatedDelivery))
        $this->oExportArticle->agiLieferstatus = $this->oExportArticle->cEstimatedDelivery;
    }
  }
  protected function _itemPrepareDescription()
  {
    $this->oExportArticle->bAgiBenutzeKurzbeschreibung = false;
    if (empty($this->oExportArticle->cBeschreibung))
    {
      $this->oExportArticle->bAgiBenutzeKurzbeschreibung = true;
      $this->oExportArticle->cBeschreibung = $this->oExportArticle->cKurzBeschreibung;
    }
    
    $count_ps = substr_count($this->cWrapDescriptionAttribute, '%s');
    if (array_key_exists('artikeldetails_attribute_anhaengen', $this->aTeinstellungenFields) && $this->aTeinstellungenFields['artikeldetails_attribute_anhaengen'] == 'Y')
    {
      if (isset($this->oExportArticle->Attribute) && !empty($this->oExportArticle->Attribute))
      {
        foreach ($this->oExportArticle->Attribute as $attribut)
        {
          if ($count_ps === 2)
            $this->oExportArticle->cBeschreibung .= sprintf($this->cWrapDescriptionAttribute, htmlentities($attribut->cName, ENT_COMPAT, 'ISO-8859-15'), ' '.$attribut->cWert).chr(10);
          elseif ($count_ps === 1)
            $this->oExportArticle->cBeschreibung .= sprintf($this->cWrapDescriptionAttribute, $attribut->cWert).chr(10);
          else
            $this->oExportArticle->cBeschreibung .= htmlentities($attribut->cName, ENT_COMPAT, 'ISO-8859-15').': '.$attribut->cWert.chr(10);
        }
      }
    }
    elseif (!empty($this->aAddDescAttribute))
    {
      if (isset($this->oExportArticle->Attribute) && !empty($this->oExportArticle->Attribute))
      {
        foreach ($this->oExportArticle->Attribute as $attribut)
        {
          if (in_array(strtolower($attribut->cName), $this->aAddDescAttribute))
          {
            if ($count_ps === 2)
              $this->oExportArticle->cBeschreibung .= sprintf($this->cWrapDescriptionAttribute, htmlentities($attribut->cName, ENT_COMPAT, 'ISO-8859-15'), ' '.$attribut->cWert).chr(10);
            elseif ($count_ps === 1)
              $this->oExportArticle->cBeschreibung .= sprintf($this->cWrapDescriptionAttribute, $attribut->cWert).chr(10);
            else
              $this->oExportArticle->cBeschreibung .= htmlentities($attribut->cName, ENT_COMPAT, 'ISO-8859-15').': '.$attribut->cWert.chr(10);
          }
        }
      }
    }
    // Javascript entfernen
    $this->oExportArticle->cBeschreibung = preg_replace('/<script\b[^>]*>(.*?)<\/script>/is', "", $this->oExportArticle->cBeschreibung); // 2.06
    
    // URLs vervollstndigen
    $result = preg_match_all('/(src|href)=([\'"].*?[\'"])/i', $this->oExportArticle->cBeschreibung, $matches);
    if ($result && !empty($matches[2]))
    {
      $replaces = array('from'=>array(),'to'=>array());
      foreach ($matches[2] as $string)
      {
        $nSlash = strpos($string, '//');
        if (!preg_match("~https?://~i", $string) && ($nSlash === FALSE || $nSlash > 1))
        {
          $replaces['from'][] = $string;
          if (substr($string,1,1) == '/')
            $replaces['to'][] = substr($string,0,1).($this->shopURLEndSlash ? substr(URL_SHOP,0,count(URL_SHOP)-1) : URL_SHOP).substr($string,1);
          else
          {
            if ($pos = strrpos($string,'./') !== false)
            {
              $string = substr($string,0,1).substr($string, $pos+2);
              $replaces['to'][] = substr($string,0,1).($this->shopURLEndSlash ? substr(URL_SHOP,0,count(URL_SHOP)-1) : URL_SHOP).substr($string,1);
            }
            else
              $replaces['to'][] = substr($string,0,1).($this->shopURLEndSlash ? URL_SHOP : URL_SHOP.'/').substr($string,1);
          }
        }
      }
      $this->oExportArticle->cBeschreibung = str_replace($replaces['from'], $replaces['to'], $this->oExportArticle->cBeschreibung);
    }
    $this->oExportArticle->cBeschreibung = str_replace(
      '<object type="application/x-shockwave-flash" data="/includes/',
      '<object type="application/x-shockwave-flash" data="'.($this->shopURLEndSlash ? substr(URL_SHOP,0,count(URL_SHOP)-1) : URL_SHOP).'/includes/',
      $this->oExportArticle->cBeschreibung
    );
    $this->oExportArticle->cBeschreibung = str_replace(
      '<param name="movie" value="/includes/',
      '<param name="movie" value="'.($this->shopURLEndSlash ? substr(URL_SHOP,0,count(URL_SHOP)-1) : URL_SHOP).'/includes/',
      $this->oExportArticle->cBeschreibung
    );
    $this->oExportArticle->cBeschreibung = str_replace(
      '<param name="FlashVars" value="flv=/mediafiles/',
      '<param name="FlashVars" value="flv='.($this->shopURLEndSlash ? substr(URL_SHOP,0,count(URL_SHOP)-1) : URL_SHOP).'/mediafiles/',
      $this->oExportArticle->cBeschreibung
    );
    
    if (isset($this->oExportArticle->oMedienDatei_arr) && !empty($this->oExportArticle->oMedienDatei_arr))
    {
      foreach($this->oExportArticle->oMedienDatei_arr as $i => $oMedienDatei)
      {
        if ($oMedienDatei->nErreichbar)
        {
          $link = '<a href="'.$oMedienDatei->cURL.'">'.$oMedienDatei->cURL.'</a>';
          if ($count_ps === 2)
            $this->oExportArticle->cBeschreibung .= sprintf($this->cWrapDescriptionAttribute, htmlentities($oMedienDatei->cName, ENT_COMPAT, 'ISO-8859-15'), ' '.$link).chr(10);
          elseif ($count_ps === 1)
            $this->oExportArticle->cBeschreibung .= sprintf($this->cWrapDescriptionAttribute, $link).chr(10);
          else
            $this->oExportArticle->cBeschreibung .= htmlentities($oMedienDatei->cName, ENT_COMPAT, 'ISO-8859-15').': '.$link.chr(10);
        }
      }
    }
  }
  protected function _itemLadeMediendateien()
  {
    $this->oExportArticle->oMedienDatei_arr = $GLOBALS["DB"]->executeQuery("
      SELECT 
        tmediendatei.kMedienDatei, tmediendatei.cPfad, tmediendatei.cURL, tmediendatei.cTyp, tmediendatei.nSort,
        tmediendateisprache.cName, tmediendateisprache.cBeschreibung, tmediendateisprache.kSprache
      FROM tmediendatei
      JOIN tmediendateisprache ON tmediendateisprache.kMedienDatei = tmediendatei.kMedienDatei
      WHERE tmediendatei.kArtikel=" . $this->oExportArticle->kArtikel . "
        AND tmediendateisprache.kSprache = " . $this->kSprache . "
      ORDER BY tmediendatei.nSort ASC, tmediendateisprache.cName",
    2);
    if(is_array($this->oExportArticle->oMedienDatei_arr) && count($this->oExportArticle->oMedienDatei_arr) > 0)
    {
      $cMedienTyp_arr = array();  // Wird im Template gebraucht um Tabs aufzubauen
      foreach($this->oExportArticle->oMedienDatei_arr as $i => $oMedienDatei)
      {
        $this->oExportArticle->oMedienDatei_arr[$i]->nErreichbar = 0;
        $this->oExportArticle->oMedienDatei_arr[$i]->nExtern = 0;
        if((strlen($oMedienDatei->cPfad) > 0) && file_exists(PFAD_ROOT . PFAD_MEDIAFILES . $oMedienDatei->cPfad))
        {
          $this->oExportArticle->oMedienDatei_arr[$i]->nErreichbar = 1;
          $this->oExportArticle->oMedienDatei_arr[$i]->cURL = $this->shopURLEndSlash ? URL_SHOP.PFAD_MEDIAFILES.$oMedienDatei->cPfad : URL_SHOP.'/'.PFAD_MEDIAFILES.$oMedienDatei->cPfad;
        }
        elseif(strlen($oMedienDatei->cURL) > 0)
        {
          $this->oExportArticle->oMedienDatei_arr[$i]->nErreichbar = 1;
          $this->oExportArticle->oMedienDatei_arr[$i]->nExtern = 1;
        }
      }
    }
  }
  protected function _getArticleSortInCategory($kKategorie)
  {
    $q = "SELECT ta.kArtikel AS id FROM `tkategorieartikel` AS tk LEFT JOIN `tartikel` AS ta ON ta.kArtikel=tk.kArtikel WHERE tk.kKategorie=$kKategorie ORDER BY ";
    if ($this->jtl_plugin_configuration['cTopAtFirst'] == 'Y')
      $q .= 'ta.cTopArtikel DESC, ';
    $q .= 'ta.'.$this->jtl_plugin_configuration['cSortArticle'].' '.$this->jtl_plugin_configuration['cSortArticleOrder'].', ta.cName ASC';
    $aRes = $GLOBALS["DB"]->executeQuery($q, 9);
    $nSort = 999999;
    foreach ($aRes as $row)
    {
      if ($row['id'] == $this->oExportArticle->kArtikel)
        break;
      $nSort--;
    }
    return $nSort;
  }
  
  public function setWrapDescriptionAttributeString($string)
  {
    if (!empty($string) && substr_count($string, '%s') == 2)
      $this->cWrapDescriptionAttribute = $string;
    else
      $this->cWrapDescriptionAttribute = '<p><strong>%s:</strong>%s</p>';
  }
  /// EOF ITEM-FUNCTIONS ///
  
  /// BOF CUSTOMER-FUNCTIONS ///
  public function getCustomer($user, $pass)
  {
    if (SG_DEBUG_LOGGING)
      $this->log('start getCustomer()', ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    // Database connection can be established here
    // Check if the users e-mail address ($user) and password ($pass) exist in the shop system
    $JTL_Client = new Kunde();
    $userNotFoundOrPasswordIsWrong = $JTL_Client->holLoginKunde(
      $this->_prepare_string_for_jtl($user), 
      $this->_prepare_string_for_jtl($pass)
    ) === 1 ? FALSE : TRUE;
    // If user data is available, save them in, for instance, the $dbCustomerData array
    if (SG_DEBUG_LOGGING)
      $this->log($userNotFoundOrPasswordIsWrong ? 'Customer not found' : 'Customer found', ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging

    // If there is no user or the password is wrong:
    if ($userNotFoundOrPasswordIsWrong)
      throw new ShopgateLibraryException(ShopgateLibraryException::PLUGIN_WRONG_USERNAME_OR_PASSWORD, 'User: '.$user);

    $dbCustomerData = $JTL_Client;

    // Additionally, retrieve user addresses and save them in, for instance, the $dbCustomerAddresses array:
    $addresses = array();
    // load delivery-addresses
    $dbCustomerAddresses = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tlieferadresse` WHERE `kKunde`=".$dbCustomerData->kKunde, 9);
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT * FROM `tlieferadresse` WHERE `kKunde`=".$dbCustomerData->kKunde, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    foreach ($dbCustomerAddresses as $dbCustomerAddress) 
    {
      if (SG_DEBUG_LOGGING)
        $this->log("Found delivery-Address ".$dbCustomerAddress['kLieferadresse'], ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      
      if ($dbCustomerAddress['cAnrede'] == 'w')
        $gender = 'f';
      elseif ($dbCustomerAddress['cAnrede'] == 'm')
        $gender = 'm';
      else
        $gender = '';
      
      $address = new ShopgateAddress();
      $address->setId('D'.$dbCustomerAddress['kLieferadresse']);
      $address->setAddressType(ShopgateAddress::DELIVERY);
      if (!empty($gender))
        $address->setGender($gender);
      $address->setFirstName($this->_prepare_string_for_shopgate($dbCustomerAddress['firstname']));
      $address->setLastName($this->_prepare_string_for_shopgate(entschluesselXTEA($dbCustomerAddress['cNachname'])));
      $address->setBirthday($dbCustomerData->dGeburtstag);
      $address->setCompany($this->_prepare_string_for_shopgate(entschluesselXTEA($dbCustomerAddress['cFirma'])));
      $address->setStreet1($this->_prepare_string_for_shopgate(entschluesselXTEA($dbCustomerAddress['cStrasse']).(empty($dbCustomerAddress['cHausnummer']) ? '' : ' '.$dbCustomerAddress['cHausnummer'])));
      $address->setStreet2($this->_prepare_string_for_shopgate($dbCustomerAddress['cAdressZusatz']));
      $address->setCity($this->_prepare_string_for_shopgate($dbCustomerAddress['cOrt']));
      $address->setZipcode($this->_prepare_string_for_shopgate($dbCustomerAddress['cPLZ']));
      $address->setCountry($this->_prepare_string_for_shopgate($dbCustomerAddress['cLand']));
      $address->setPhone($this->_prepare_string_for_shopgate($dbCustomerAddress['cTel']));
      $address->setMobile($this->_prepare_string_for_shopgate($dbCustomerAddress['cMobil']));
      $address->setMail($this->_prepare_string_for_shopgate($dbCustomerAddress['cMail']));
      $addresses[] = $address;
    }
    
    if ($dbCustomerData->cAnrede == 'w')
      $gender = 'f';
    elseif ($dbCustomerData->cAnrede == 'm')
      $gender = 'm';
    else
      $gender = '';
    $address = new ShopgateAddress();
    $address->setId('C'.$dbCustomerData->kKunde);
    $address->setIsInvoiceAddress(1);
    $address->setIsDeliveryAddress(1);
    if (!empty($gender))
      $address->setGender($gender);
    $address->setFirstName($this->_prepare_string_for_shopgate($dbCustomerData->cVorname));
    $address->setLastName($this->_prepare_string_for_shopgate($dbCustomerData->cNachname));
    $address->setBirthday($this->_prepare_string_for_shopgate($dbCustomerData->dGeburtstag));
    $address->setCompany($this->_prepare_string_for_shopgate($dbCustomerData->cFirma));
    $address->setStreet1($this->_prepare_string_for_shopgate($dbCustomerData->cStrasse.(empty($dbCustomerData->cHausnummer) ? '' : ' '.$dbCustomerData->cHausnummer)));
    $address->setStreet2($this->_prepare_string_for_shopgate($dbCustomerData->cAdressZusatz));
    $address->setCity($this->_prepare_string_for_shopgate($dbCustomerData->cOrt));
    $address->setZipcode($this->_prepare_string_for_shopgate($dbCustomerData->cPLZ));
    $address->setCountry($this->_prepare_string_for_shopgate($dbCustomerData->cLand));
    $address->setPhone($this->_prepare_string_for_shopgate($dbCustomerData->cTel));
    $address->setMobile($this->_prepare_string_for_shopgate($dbCustomerData->cMobil));
    $address->setMail($this->_prepare_string_for_shopgate($dbCustomerData->cMail));
    $addresses[] = $address;

    // If the user exists:
    if ($dbCustomerData->cAnrede == 'w')
      $gender = 'f';
    elseif ($dbCustomerData->cAnrede == 'm')
      $gender = 'm';
    else
      $gender = '';
    $customer = new ShopgateCustomer();
    $customer->setCustomerId($dbCustomerData->kKunde);
    if (!empty($dbCustomerData->cKundenNr))
      $customer->setCustomerNumber($dbCustomerData->cKundenNr);
    if (!empty($dbCustomerData->kKundengruppe))
      $customer->setCustomerGroupId($dbCustomerData->kKundengruppe);
    $customer->setGender($gender);
    $customer->setFirstName($this->_prepare_string_for_shopgate($dbCustomerData->cVorname));
    $customer->setLastName($this->_prepare_string_for_shopgate($dbCustomerData->cNachname));
    $customer->setBirthday($this->_prepare_string_for_shopgate($dbCustomerData->dGeburtstag));
    $customer->setPhone($this->_prepare_string_for_shopgate($dbCustomerData->cTel));
    $customer->setMobile($this->_prepare_string_for_shopgate($dbCustomerData->cMobil));
    $customer->setMail($this->_prepare_string_for_shopgate($dbCustomerData->cMail));
    
    if (!empty($dbCustomerData->kKundengruppe))
    {
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT * FROM `tkundengruppe` WHERE `kKundengruppe`=".$dbCustomerData->kKundengruppe,
        1
      );
      if ($tmp)
      {
        $customerGroups = array();
          $group = new ShopgateCustomerGroup();
          $group->setID($dbCustomerData->kKundengruppe);
          $group->setName($this->_pss($tmp->cName));
        $customerGroups[] = $group;
        $customer->setCustomerGroups($customerGroups);
        $customer->setCustomerGroup($this->_pss($tmp->cName));
      }
    }
    
    //var_dump($addresses);
    // Important! Addresses need to be assigned to the customer here
    $customer->setAddresses($addresses);
    
    $customer = $this->agiGetCustomerIndividualAddData($customer);
    
    if (SG_DEBUG_LOGGING)
      $this->log('Submit Customer', ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
 
    return $customer;
  }
  public function registerCustomer($user, $pass, ShopgateCustomer $customer)
  {
    $this->agiRegisterCustomerIndividual($user, $pass, $customer);
    if (SG_DEBUG_LOGGING)
      $this->log('start registerCustomer()', ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    $user = $GLOBALS['DB']->escape(filterXSS($this->_prepare_string_for_jtl($user)));
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT COUNT(*) AS icount FROM `tkunde` WHERE `cMail`='".$user."' AND `nRegistriert`=1",
      1
    );
    if ($tmp->icount > 0)
      throw new ShopgateLibraryException(ShopgateLibraryException::REGISTER_USER_ALREADY_EXISTS, '', true);
    
    $kKundengruppe = $this->kKundengruppe;
    $kSprache = $this->kSprache;
    
    $JTL_Client = new Kunde();
    if ($customer->getGender() == 'f')
      $JTL_Client -> cAnrede  = 'w';
    elseif ($customer->getGender() == 'm')
      $JTL_Client -> cAnrede  = 'm';
    else
      $JTL_Client -> cAnrede  = '';
    
    $JTL_Client -> cVorname = $this->_prepare_string_for_jtl($customer->getFirstName());
    $JTL_Client -> cNachname= $this->_prepare_string_for_jtl($customer->getLastName());
    $JTL_Client -> dGeburtstag = $this->_prepare_string_for_jtl($customer->getBirthday());
    $JTL_Client -> cTel     = $this->_prepare_string_for_jtl($customer->getPhone());
    $JTL_Client -> cMobil   = $this->_prepare_string_for_jtl($customer->getMobile());
    $JTL_Client -> cMail    = $this->_prepare_string_for_jtl($customer->getMail());
    $JTL_Client -> cPasswort = cryptPasswort($this->_prepare_string_for_jtl($pass));
    $JTL_Client -> nRegistriert = 1;
    $JTL_Client -> kKundengruppe= $kKundengruppe;
    $JTL_Client -> kSprache   = $kSprache;
    $JTL_Client -> dErstellt = date('Y-m-d');
    $JTL_Client -> cAktiv    = 'Y';
    $JTL_Client -> cAbgeholt = 'N';
    $JTL_Client -> cHerkunft = 'Shopgate';
    
    $adressen = array();
    $adressList = $customer->getAddresses();
    foreach ($adressList as $adress)
    {
      if ($adress->getIsInvoiceAddress())
        $adressen[] = $adress;
    }
    if (empty($adressen))
    {
      foreach ($adressList as $adress)
        $adressen[] = $adress;
    }
    $first = reset($adressen);
    if ($first)
    {
      $JTL_Client -> cFirma   = $this->_prepare_string_for_jtl($first->getCompany());	
      $JTL_Client -> cStrasse = $this->_prepare_string_for_jtl($first->getStreetName1());
      $JTL_Client -> cHausnummer  = $this->_prepare_string_for_jtl($first->getStreetNumber1());
      $JTL_Client -> cAdressZusatz= $this->_prepare_string_for_jtl($first->getStreet2());
      $JTL_Client -> cPLZ     = $this->_prepare_string_for_jtl($first->getZipcode());
      $JTL_Client -> cOrt     = $this->_prepare_string_for_jtl($first->getCity());
      $JTL_Client -> cLand    = $this->_prepare_string_for_jtl($first->getCountry());
    }
    if (SG_DEBUG_LOGGING)
      $this->log("Save new client", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $JTL_Client -> insertInDB();
    
    if (!$JTL_Client -> kKunde)
      throw new ShopgateLibraryException(ShopgateLibraryException::REGISTER_FAILED_TO_ADD_USER, '', true);
    
    /* return data */
    $customer = new ShopgateCustomer();
    $customer->setCustomerId($JTL_Client->kKunde);
    if (!empty($JTL_Client->cKundenNr))
      $customer->setCustomerNumber($JTL_Client->cKundenNr);
    if (!empty($JTL_Client->kKundengruppe))
      $customer->setCustomerGroupId($JTL_Client->kKundengruppe);
    if ($JTL_Client->cAnrede == 'w')
      $gender = 'f';
    elseif ($JTL_Client->cAnrede == 'm')
      $gender = 'm';
    else
      $gender = '';
    $customer->setGender($gender);
    $customer->setFirstName($this->_prepare_string_for_shopgate($JTL_Client->cVorname));
    $customer->setLastName($this->_prepare_string_for_shopgate($JTL_Client->cNachname));
    $customer->setBirthday($this->_prepare_string_for_shopgate($JTL_Client->dGeburtstag));
    $customer->setPhone($this->_prepare_string_for_shopgate($JTL_Client->cTel));
    $customer->setMobile($this->_prepare_string_for_shopgate($JTL_Client->cMobil));
    $customer->setMail($this->_prepare_string_for_shopgate($JTL_Client->cMail));
    
    if ($first)
    {
      $customerAdress = array();
      if ($JTL_Client->cAnrede == 'w')
        $gender = 'f';
      elseif ($JTL_Client->cAnrede == 'm')
        $gender = 'm';
      else
        $gender = '';
      $address = new ShopgateAddress();
      $address->setId('C'.$JTL_Client->kKunde);
      $address->setIsInvoiceAddress(1);
      $address->setIsDeliveryAddress(1);
      if (!empty($gender))
        $address->setGender($gender);
      $address->setFirstName($this->_prepare_string_for_shopgate($JTL_Client->cVorname));
      $address->setLastName($this->_prepare_string_for_shopgate($JTL_Client->cNachname));
      $address->setBirthday($this->_prepare_string_for_shopgate($JTL_Client->dGeburtstag));
      $address->setCompany($this->_prepare_string_for_shopgate($JTL_Client->cFirma));
      $address->setStreet1($this->_prepare_string_for_shopgate($JTL_Client->cStrasse.(empty($JTL_Client->cHausnummer) ? '' : ' '.$JTL_Client->cHausnummer)));
      $address->setStreet2($this->_prepare_string_for_shopgate($JTL_Client->cAdressZusatz));
      $address->setCity($this->_prepare_string_for_shopgate($JTL_Client->cOrt));
      $address->setZipcode($this->_prepare_string_for_shopgate($JTL_Client->cPLZ));
      $address->setCountry($this->_prepare_string_for_shopgate($JTL_Client->cLand));
      $address->setPhone($this->_prepare_string_for_shopgate($JTL_Client->cTel));
      $address->setMobile($this->_prepare_string_for_shopgate($JTL_Client->cMobil));
      $address->setMail($this->_prepare_string_for_shopgate($JTL_Client->cMail));
      $customerAdress[] = $address;
      $customer->setAddresses($customerAdress);
    }
    
    if (SG_DEBUG_LOGGING)
      $this->log('Submit Customer', ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    return $customer;
  }
  /// EOF CUSTOMER-FUNCTIONS ///
  
  
  /// BOF ORDER-FUNCTIONS ///
  public function addOrder(ShopgateOrder $order)
  {
    $this->agiAddOrderIndividual($order);
    if (SG_DEBUG_LOGGING)
      $this->log('start addOrder()', ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    $additional_comments = array();
    $Einstellungen = getEinstellungen(array(CONF_GLOBAL));
    
    // Check if an order with the number ($order->getOrderNumber())
    // has already been imported from Shopgate
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT COUNT(*) AS icount FROM `xplugin_agi_shopgate_plugin_connect` WHERE `kBestellungShopgate`='".$order->getOrderNumber()."'",
      1
    );
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT COUNT(*) AS icount FROM `xplugin_agi_shopgate_plugin_connect` WHERE `kBestellungShopgate`='".$order->getOrderNumber()."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $dbOrder = $tmp->icount;
 
    // If an order is found with the order number ($order->getOrderNumber()) 
    // abort:
    if (!empty($dbOrder)) {
      throw new ShopgateLibraryException(ShopgateLibraryException::PLUGIN_DUPLICATE_ORDER);
    }

    // Has the order been placed by an existing customer?
    // Check if a user with the $customerId already exists and save the order
    // together with the user
    /* 
    // Bis Version 1.4 wurde anhand der "getExternalCustomerId" geprft, ob ein Kunde bereits vorhanden ist
    // Dann teilte mir Sopgate mit, dass die Kunden-Ids im fall eines Shopsystemwechsels nicht mehr aktualisiert werden
    // Dadurch werden die Bestellungen im Shop den falschen Kunden zugeordnet was natrlich zu massiven Problemen fhrt
    // Daher erfolgt die prfung ab version 1.5 Anhand der Kunden-Id und der E-Mail-Adresse. Nur wenn beides stimmt, wird der Kunde zugeordnet
    // ansonsten erfolgt die Bestellung als Gastbestellung
    $customerId = $order->getExternalCustomerId();
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kKunde` FROM `tkunde` WHERE `kKunde`='".$customerId."' AND `nRegistriert`=1",
      1
    );
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT `kKunde` FROM `tkunde` WHERE `kKunde`='".$customerId."' AND `nRegistriert`=1", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $dbClient = $tmp->kKunde;
    // Ende bis v 1.4 */
    /* BOF Version 1.5 */
    $cMail = $this->_prepare_string_for_jtl($order->getMail());
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kKunde` FROM `tkunde` WHERE `cMail`='".$GLOBALS['DB']->escape($cMail)."' AND `nRegistriert`=1",
      1
    );
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT `kKunde` FROM `tkunde` WHERE `cMail`='".$GLOBALS['DB']->escape($cMail)."' AND `nRegistriert`=1", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $dbClient = $tmp;
    /* EOF Version 1.5 */
    // If a user does not exist: create a guest account in the shop system
    // ...
    $invoice = $order->getInvoiceAddress();
    if (empty($dbClient))
    {
      $JTL_Client = new Kunde();
      if ($invoice->getGender() == 'f')
        $JTL_Client -> cAnrede  = 'w';
      elseif ($invoice->getGender() == 'm')
        $JTL_Client -> cAnrede  = 'm';
      else
        $JTL_Client -> cAnrede  = '';
      
      $JTL_Client -> cVorname = $this->_prepare_string_for_jtl($invoice->getFirstName());
      $JTL_Client -> cNachname= $this->_prepare_string_for_jtl($invoice->getLastName());
      $JTL_Client -> cFirma   = $this->_prepare_string_for_jtl($invoice->getCompany());	
      $JTL_Client -> cStrasse = $this->_prepare_string_for_jtl($invoice->getStreetName1());
      $JTL_Client -> cHausnummer  = $this->_prepare_string_for_jtl($invoice->getStreetNumber1());
      $JTL_Client -> cAdressZusatz= $this->_prepare_string_for_jtl($invoice->getStreet2()); // 1.6
      $JTL_Client -> cPLZ     = $this->_prepare_string_for_jtl($invoice->getZipcode());
      $JTL_Client -> cOrt     = $this->_prepare_string_for_jtl($invoice->getCity());
      //$JTL_Client -> cBundesland  = $this->_prepare_string_for_jtl($invoice->getState());
      $JTL_Client -> cLand    = $this->_prepare_string_for_jtl($invoice->getCountry());
      $JTL_Client -> cTel     = $this->_prepare_string_for_jtl($order->getPhone());
      $JTL_Client -> cMobil   = $this->_prepare_string_for_jtl($order->getMobile());
      //$JTL_Client -> cFax     = $invoice->();
      $JTL_Client -> cMail    = $this->_prepare_string_for_jtl($order->getMail());
      //$JTL_Client -> cUSTID   = $invoice->();
      //$JTL_Client -> cWWW     = $invoice->();
      $JTL_Client -> nRegistriert = 0;
      $JTL_Client -> kKundengruppe= $this->kKundengruppe;
      $JTL_Client -> kSprache   = $this->kSprache;
      $JTL_Client -> dErstellt = date('Y-m-d');
      $JTL_Client -> cAktiv    = 'Y';
      $JTL_Client -> cAbgeholt = 'N';
      $JTL_Client -> cHerkunft = 'Shopgate';
      if (SG_DEBUG_LOGGING)
        $this->log("Save new client", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $JTL_Client -> insertInDB();
    }
    else
      $JTL_Client = new Kunde((int)$dbClient->kKunde);
      
    // create invoice address
    $JTL_Invoice = new Rechnungsadresse();
    $JTL_Invoice->kKunde = $JTL_Client->kKunde;
    if ($invoice->getGender() == 'f')
      $JTL_Invoice -> cAnrede  = 'w';
    elseif ($invoice->getGender() == 'm')
      $JTL_Invoice -> cAnrede  = 'm';
    else
      $JTL_Invoice -> cAnrede  = '';
    $JTL_Invoice->cVorname    = $this->_prepare_string_for_jtl($invoice->getFirstName());
    $JTL_Invoice->cNachname   = $this->_prepare_string_for_jtl($invoice->getLastName());
    $JTL_Invoice->cFirma      = $this->_prepare_string_for_jtl($invoice->getCompany());
    $JTL_Invoice->cStrasse    = $this->_prepare_string_for_jtl($invoice->getStreetName1());
    $JTL_Invoice->cHausnummer = $this->_prepare_string_for_jtl($invoice->getStreetNumber1());
    $JTL_Invoice->cAdressZusatz= $this->_prepare_string_for_jtl($invoice->getStreet2());
    $JTL_Invoice->cPLZ        = $this->_prepare_string_for_jtl($invoice->getZipcode());
    $JTL_Invoice->cOrt        = $this->_prepare_string_for_jtl($invoice->getCity());
    //$JTL_Invoice->cBundesland = $this->_prepare_string_for_jtl($invoice->getState());
    $JTL_Invoice->cLand       = $this->_prepare_string_for_jtl($invoice->getCountry());
    $JTL_Invoice->cTel        = $this->_prepare_string_for_jtl($invoice->getPhone());
    $JTL_Invoice->cMobil      = $this->_prepare_string_for_jtl($invoice->getMobile());
    $JTL_Invoice->cMail       = $this->_prepare_string_for_jtl($invoice->getMail());
    if (SG_DEBUG_LOGGING)
      $this->log("Save Invoice-Address", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    //$JTL_Invoice-> insertInDB(); // don't know, why it does not work
    
    $inv_address = new stdClass();
    $inv_address->kKunde    = $JTL_Client->kKunde;
    $inv_address->cAnrede   = $JTL_Invoice -> cAnrede;
    $inv_address->cVorname  = $JTL_Invoice -> cVorname;
    $inv_address->cNachname = verschluesselXTEA(trim($JTL_Invoice -> cNachname));
    $inv_address->cFirma    = verschluesselXTEA(trim($JTL_Invoice -> cFirma));
    $inv_address->cStrasse  = verschluesselXTEA(trim($JTL_Invoice -> cStrasse));
    $inv_address->cHausnummer = $JTL_Invoice -> cHausnummer;
    $inv_address->cAdressZusatz = $JTL_Invoice -> cAdressZusatz;
    $inv_address->cPLZ      = $JTL_Invoice -> cPLZ;
    $inv_address->cOrt      = $JTL_Invoice -> cOrt;
    $inv_address->cLand     = $JTL_Invoice -> cLand;
    $inv_address->cTel      = $JTL_Invoice -> cTel;
    $inv_address->cMobil    = $JTL_Invoice -> cMobil;
    $inv_address->cMail     = empty($JTL_Invoice -> cMail) ? $JTL_Client -> cMail : $JTL_Invoice -> cMail;
    $JTL_Invoice->kRechnungsadresse = $GLOBALS["DB"]->insertRow("trechnungsadresse", $inv_address);
    
    
    // check delivery-address
    $equal_address = true;
    $delivery = $order->getDeliveryAddress();
    $JTL_Delivery = new Lieferadresse();
    $JTL_Delivery->kKunde = $JTL_Client->kKunde;
    if ($delivery->getGender() == 'f')
      $JTL_Delivery -> cAnrede  = 'w';
    elseif ($delivery->getGender() == 'm')
      $JTL_Delivery -> cAnrede  = 'm';
    else
      $JTL_Delivery -> cAnrede  = '';
    $JTL_Delivery->cVorname    = $this->_prepare_string_for_jtl($delivery->getFirstName());
    $JTL_Delivery->cNachname   = $this->_prepare_string_for_jtl($delivery->getLastName());
    $JTL_Delivery->cFirma      = $this->_prepare_string_for_jtl($delivery->getCompany());
    $JTL_Delivery->cStrasse    = $this->_prepare_string_for_jtl($delivery->getStreetName1());
    $JTL_Delivery->cHausnummer = $this->_prepare_string_for_jtl($delivery->getStreetNumber1());
    $JTL_Delivery->cAdressZusatz = $this->_prepare_string_for_jtl($delivery->getStreet2());
    $JTL_Delivery->cPLZ        = $this->_prepare_string_for_jtl($delivery->getZipcode());
    $JTL_Delivery->cOrt        = $this->_prepare_string_for_jtl($delivery->getCity());
    //$JTL_Delivery->cBundesland = $this->_prepare_string_for_jtl($delivery->getState());
    $JTL_Delivery->cLand       = $this->_prepare_string_for_jtl($delivery->getCountry());
    $JTL_Delivery->cTel        = $this->_prepare_string_for_jtl($delivery->getPhone());
    $JTL_Delivery->cMobil      = $this->_prepare_string_for_jtl($delivery->getMobile());
    $JTL_Delivery->cMail       = $this->_prepare_string_for_jtl($delivery->getMail());
    if (
      $JTL_Delivery->cVorname != $JTL_Client->cVorname ||
      $JTL_Delivery->cNachname != $JTL_Client->cNachname ||
      $JTL_Delivery->cStrasse != $JTL_Client->cStrasse ||
      $JTL_Delivery->cPLZ != $JTL_Client->cPLZ ||
      $JTL_Delivery->cOrt != $JTL_Client->cOrt ||
      $JTL_Delivery->cMail != $JTL_Client->cMail
    )
    {
      $equal_address = false;
      if (SG_DEBUG_LOGGING)
        $this->log("Save delivery-Address", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      //$JTL_Delivery-> insertInDB(); same like saving invoice-Address
      $del_address = new stdClass();
      $del_address->kKunde    = $JTL_Client->kKunde;
      $del_address->cAnrede   = $JTL_Delivery -> cAnrede;
      $del_address->cVorname  = $JTL_Delivery -> cVorname;
      $del_address->cNachname = verschluesselXTEA(trim($JTL_Delivery -> cNachname));
      $del_address->cFirma    = verschluesselXTEA(trim($JTL_Delivery -> cFirma));
      $del_address->cStrasse  = verschluesselXTEA(trim($JTL_Delivery -> cStrasse));
      $del_address->cHausnummer = $JTL_Delivery -> cHausnummer;
      $del_address->cAdressZusatz = $JTL_Delivery -> cAdressZusatz;
      $del_address->cPLZ      = $JTL_Delivery -> cPLZ;
      $del_address->cOrt      = $JTL_Delivery -> cOrt;
      $del_address->cLand     = $JTL_Delivery -> cLand;
      $del_address->cTel      = $JTL_Delivery -> cTel;
      $del_address->cMobil    = $JTL_Delivery -> cMobil;
      $del_address->cMail     = $JTL_Delivery -> cMail;
      $JTL_Delivery->kLieferadresse = $GLOBALS["DB"]->insertRow("tlieferadresse", $del_address);
    }
    
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: After delivery", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    // look for kWaehrung
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kWaehrung` FROM `twaehrung` WHERE `cISO`='".$order->getCurrency()."'",
      1
    );
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT `kWaehrung` FROM `twaehrung` WHERE `cISO`='".$order->getCurrency()."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $kWaehrung = $tmp->kWaehrung;
    if (empty($kWaehrung))
    {
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `kWaehrung` FROM `twaehrung` WHERE `cStandard`='Y'",
        1
      );
      if (SG_DEBUG_LOGGING)
        $this->log("QRY: SELECT `kWaehrung` FROM `twaehrung` WHERE `cStandard`='Y'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $kWaehrung = $tmp->kWaehrung;
      $additional_comments[] = 'Whrung '.$order->getCurrency().' nicht korrekt zugeordnet, bitte prfen.';
    }
    
    $string_comments = '';
    if (!empty($additional_comments))
    {
      $string_comments = chr(10).implode(chr(10), $additional_comments);
    }
    
    // create Basket
    if (SG_DEBUG_LOGGING)
      $this->log("Start Basket", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $basket = new stdClass();
    $basket->kKunde = $JTL_Client->kKunde;
    $basket->kLieferadresse = 0;
    $basket->kZahlungsInfo  = 0;
    if (SG_DEBUG_LOGGING)
      $this->log("Save Basket", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $kWarenkorb = $GLOBALS["DB"]->insertRow("twarenkorb", $basket);
    
    // add items to baset
    $oItems = $order->getItems();
    $verfuegbarkeitResult_arr = array('cArtikelName_arr' => array());
    $aWarenkorbVersandklassen = array();
    foreach($oItems as $orderItem) 
    {
      if (SG_DEBUG_LOGGING)
        $this->log("get and save article-item ".$orderItem->getItemNumber(), ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      // try to load article
      $oArtikelOptionen = new stdClass();
      $oArtikelOptionen->nMerkmale = 1;
      $oArtikelOptionen->nAttribute = 1;
      $oArtikelOptionen->nArtikelAttribute = 1;
      $oArtikelOptionen->nKategorie = 0;
      $oArtikelOptionen->nKeinLagerbestandBeachten = 1;//??
      $oArtikelOptionen->nVariationKombiKinder = 1;
      
      $article = new Artikel();
      $article->fuelleArtikel(
        $orderItem->getItemNumber(),
        $oArtikelOptionen,
        $JTL_Client -> kKundengruppe,
        $JTL_Client -> kSprache
      );
      
      $calcprice = round($orderItem->getUnitAmountWithTax()*100/(100+$orderItem->getTaxPercent()),5); /* 20140514*/
      $attributeSum = 0;
      $options = $orderItem->getOptions();
      if (!empty($options))
        $attributeSum = $this->_get_optionsPriceNetto($options, $orderItem->getTaxPercent());
      $calcpriceEinzel = $calcprice-$attributeSum;
      
      $warenkorbpos = new stdClass();
      $warenkorbpos->kWarenkorb      = $kWarenkorb;
      $warenkorbpos->kArtikel        = $orderItem->getItemNumber();
      $warenkorbpos->kVersandklasse  = $article->kVersandklasse;
      $warenkorbpos->cName           = $this->_prepare_string_for_jtl($orderItem->getName());
      $warenkorbpos->cLieferstatus   = $article->cLieferstatus;
      $warenkorbpos->cArtNr          = $this->_prepare_string_for_jtl($orderItem->getItemNumberPublic());
      $warenkorbpos->cEinheit        = $article->cEinheit;
      $warenkorbpos->fPreisEinzelNetto = $calcpriceEinzel; // 20140514 //$orderItem->getUnitAmount();
      $warenkorbpos->fPreis          = $calcprice; // 20140514 //$orderItem->getUnitAmount();
      $warenkorbpos->fMwSt           = $orderItem->getTaxPercent();
      $warenkorbpos->nAnzahl         = $orderItem->getQuantity();
      $warenkorbpos->nPosTyp         = C_WARENKORBPOS_TYP_ARTIKEL;
      $warenkorbpos->cHinweis        = '';
      $warenkorbpos->cUnique         = '';
      $warenkorbpos->kKonfigitem     = 0;
      $warenkorbpos->kBestellpos     = 0;
      if (SG_DEBUG_LOGGING)
        $this->log("save basket-position", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $kWarenkorbPos = $GLOBALS["DB"]->insertRow("twarenkorbpos", $warenkorbpos);
      
      if ($article->cLagerBeachten == "Y" && $article->cLagerKleinerNull == "Y" && $Einstellungen['global']['global_lieferverzoegerung_anzeigen'] === "Y")
      {
        if ($warenkorbpos->nAnzahl > $article->fLagerbestand)
          $verfuegbarkeitResult_arr['cArtikelName_arr'][] = $article->cName;
      }
      
      // Eigenschaften?
      $wpEigenschaftArr = array();
			if(!empty($options)) 
      {
        if (SG_DEBUG_LOGGING)
          $this->log("article has option", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
        foreach($options as $option)
        {
          // search for attribute in Database
          $tmp = $GLOBALS["DB"]->executeQuery(
            "SELECT `kEigenschaft` FROM `teigenschaft` WHERE `kArtikel`='".$orderItem->getItemNumber()."' AND `kEigenschaft`='".$option->getOptionNumber()."'",
            1
          );
          if (SG_DEBUG_LOGGING)
            $this->log("QRY: SELECT `kEigenschaft` FROM `teigenschaft` WHERE `kArtikel`='".$orderItem->getItemNumber()."' AND `kEigenschaft`='".$option->getOptionNumber()."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
          if (!empty($tmp->kEigenschaft))
          {
            $kEigenschaft = $tmp->kEigenschaft;
            $tmp2 = $GLOBALS["DB"]->executeQuery(
              "SELECT `kEigenschaftWert` FROM `teigenschaftwert` WHERE `kEigenschaft`='".$kEigenschaft."' AND `kEigenschaftWert`='".$option->getValueNumber()."'",
              1
            );
            if (SG_DEBUG_LOGGING)
              $this->log("QRY: SELECT `kEigenschaftWert` FROM `teigenschaftwert` WHERE `kEigenschaft`='".$kEigenschaft."' AND `kEigenschaftWert`='".$option->getValueNumber()."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            if (!empty($tmp2->kEigenschaftWert))
            {
              $kEigenschaftWert = $tmp2->kEigenschaftWert;
            }
            else
              $kEigenschaftWert = 0;
          }
          else
          {
            $kEigenschaft = 0;
            $kEigenschaftWert = 0;
          }
          
          $wpEigenschaft = new stdClass();
          $wpEigenschaft->kWarenkorbPos      = $kWarenkorbPos;
          $wpEigenschaft->kEigenschaft       = $kEigenschaft;
          $wpEigenschaft->kEigenschaftWert   = $kEigenschaftWert;
          $wpEigenschaft->cEigenschaftName   = $this->_prepare_string_for_jtl($option->getName());
          $wpEigenschaft->cEigenschaftWertName = $this->_prepare_string_for_jtl($option->getValue());
          $wpEigenschaft->cFreifeldWert      = $this->_prepare_string_for_jtl($option->getValue());
          $wpEigenschaft->fAufpreis          = round($option->getAdditionalAmountWithTax()*100/(100+$orderItem->getTaxPercent()), 4);
          if (SG_DEBUG_LOGGING)
            $this->log("save basket-position-option", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
          $kWarenkorbPosEigenschaft = $GLOBALS["DB"]->insertRow("twarenkorbposeigenschaft", $wpEigenschaft);
          $wpEigenschaftArr[] = $wpEigenschaft;
        }
      }
      
      $inputs = $orderItem->getInputs();
      if (!empty($inputs))
      {
        if (SG_DEBUG_LOGGING)
          $this->log("article has inputOptions", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
        foreach($inputs as $inputOption)
        {
          // search for attribute in Database
          $tmp = $GLOBALS["DB"]->executeQuery(
            "SELECT `kEigenschaft` FROM `teigenschaft` WHERE `kArtikel`='".$orderItem->getItemNumber()."' AND `kEigenschaft`='".$inputOption->getInputNumber()."'",
            1
          );
          if (SG_DEBUG_LOGGING)
            $this->log("QRY: SELECT `kEigenschaft` FROM `teigenschaft` WHERE `kArtikel`='".$orderItem->getItemNumber()."' AND `kEigenschaft`='".$inputOption->getInputNumber()."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
          if (!empty($tmp->kEigenschaft))
          {
            $kEigenschaft = $tmp->kEigenschaft;
            $kEigenschaftWert = 0;
          }
          else
          {
            $kEigenschaft = 0;
            $kEigenschaftWert = 0;
          }
          
          $wpEigenschaft = new stdClass();
          $wpEigenschaft->kWarenkorbPos      = $kWarenkorbPos;
          $wpEigenschaft->kEigenschaft       = $kEigenschaft;
          $wpEigenschaft->kEigenschaftWert   = $kEigenschaftWert;
          $wpEigenschaft->cEigenschaftName   = $this->_prepare_string_for_jtl($inputOption->getLabel());
          $wpEigenschaft->cEigenschaftWertName = $this->_prepare_string_for_jtl($inputOption->getUserInput());
          $wpEigenschaft->cFreifeldWert      = $this->_prepare_string_for_jtl($inputOption->getUserInput());
          $wpEigenschaft->fAufpreis          = round($inputOption->getAdditionalAmountWithTax()*100/(100+$orderItem->getTaxPercent()), 4);
          if (SG_DEBUG_LOGGING)
            $this->log("save basket-position-inputOption", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
          $kWarenkorbPosEigenschaft = $GLOBALS["DB"]->insertRow("twarenkorbposeigenschaft", $wpEigenschaft);
          $wpEigenschaftArr[] = $wpEigenschaft;
        }
      }
    
      aktualisiereLagerbestand($article, $warenkorbpos->nAnzahl, $wpEigenschaftArr);
      aktualisiereBestseller($warenkorbpos->kArtikel, $warenkorbpos->nAnzahl);
      if (!in_array($article->kVersandklasse, $aWarenkorbVersandklassen))
        $aWarenkorbVersandklassen[] = $article->kVersandklasse;
    }
    if (count($verfuegbarkeitResult_arr['cArtikelName_arr']) > 0) 
    {
      $cHinweis = str_replace("%s", "", $GLOBALS['oSprache']->gibWert('orderExpandInventory', 'basket'));
      $verfuegbarkeitResult_arr['cHinweis'] = $cHinweis;
    }
    
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kSteuerzone` FROM `tsteuerzoneland` WHERE `cISO`='".$this->_prepare_string_for_jtl($JTL_Delivery->cLand)."'",
      1
    );
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT `kSteuerzone` FROM `tsteuerzoneland` WHERE `cISO`='".$this->_prepare_string_for_jtl($JTL_Delivery->cLand)."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    if (!empty($tmp))
    {
      $kSteuerzone = $tmp->kSteuerzone;
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `kSteuerklasse` FROM `tsteuerklasse` WHERE `cStandard`='Y'",
        1
      );
      if (SG_DEBUG_LOGGING)
        $this->log("QRY: SELECT `kSteuerklasse` FROM `tsteuerklasse` WHERE `cStandard`='Y'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $kSteuerklasse = $tmp->kSteuerklasse;
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `fSteuersatz` FROM `tsteuersatz` WHERE `kSteuerklasse`=$kSteuerklasse AND `kSteuerzone`=$kSteuerzone",
        1
      );
      if (SG_DEBUG_LOGGING)
        $this->log("QRY: SELECT `fSteuersatz` FROM `tsteuersatz` WHERE `kSteuerklasse`=$kSteuerklasse AND `kSteuerzone`=$kSteuerzone", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $fSteuersatz = $tmp->fSteuersatz;
    }
    else
      $fSteuersatz = $this->fallback_steuersatz;
    
    $aKupons = $order->getExternalCoupons();
    $addKuponBestellung = array();
    if (!empty($aKupons))
    {
      foreach ($aKupons as $oKupon)
      {
        $cInfo = $oKupon->getInternalInfo();
        if (!empty($cInfo))
        {
          $aInfo = $this->jsonDecode($cInfo, true);
          $kKupon = array_key_exists('kKupon', $aInfo) ? $aInfo['kKupon'] : 0;
          if (!empty($kKupon))
          {
            $fAmount = $oKupon->getAmount();
            $fAmountNet = round($fAmount*100/(100+$fSteuersatz),4);
            $warenkorbpos = new stdClass();
            $warenkorbpos->kWarenkorb      = $kWarenkorb;
            $warenkorbpos->kArtikel        = 0;
            $warenkorbpos->kVersandklasse  = 0;
            $warenkorbpos->cName           = $this->_prepare_string_for_jtl($oKupon->getName());
            $warenkorbpos->cLieferstatus   = '';
            $warenkorbpos->cArtNr          = '';
            $warenkorbpos->cEinheit        = '';
            $warenkorbpos->fPreisEinzelNetto = $fAmountNet*-1;
            $warenkorbpos->fPreis          = $fAmountNet*-1;
            $warenkorbpos->fMwSt           = $fSteuersatz;
            $warenkorbpos->nAnzahl         = 1;
            $warenkorbpos->nPosTyp         = C_WARENKORBPOS_TYP_KUPON;
            $warenkorbpos->cHinweis        = '';
            $warenkorbpos->cUnique         = '';
            $warenkorbpos->kKonfigitem     = 0;
            $warenkorbpos->kBestellpos     = 0;
            if (SG_DEBUG_LOGGING)
              $this->log("add basket-external-coupon-position", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            $kWarenkorbPos = $GLOBALS["DB"]->insertRow("twarenkorbpos", $warenkorbpos);
            
            $GLOBALS["DB"]->executeQuery("UPDATE `tkupon` SET `nVerwendungenBisher`=`nVerwendungenBisher`+1 WHERE `kKupon`=".$kKupon,4);
            
            $KuponKunde = new stdClass();
            $KuponKunde->kKupon=$kKupon;
            $KuponKunde->kKunde=$JTL_Client->kKunde;
            $KuponKunde->dErstellt="now()";
            $KuponKunde->nVerwendungen=1;

            $KuponKundeBisher = $GLOBALS["DB"]->executeQuery("SELECT `nVerwendungen` FROM `tkuponkunde` WHERE `kKupon`=$kKupon AND `kKunde`=".$JTL_Client->kKunde,1);
            if ($KuponKundeBisher)
            {
              if ($KuponKundeBisher->nVerwendungen>0)
                $KuponKunde->nVerwendungen += $KuponKundeBisher->nVerwendungen;
            }
            $GLOBALS["DB"]->executeQuery("DELETE FROM `tkuponkunde` WHERE `kKupon`=$kKupon AND `kKunde`=".$JTL_Client->kKunde,4);
            $GLOBALS["DB"]->insertRow('tkuponkunde',$KuponKunde);
            $addKuponBestellung[] = $kKupon;
          }
          elseif (array_key_exists('kundenguthaben', $aInfo) && $aInfo['kundenguthaben'] == $JTL_Client->kKunde)
          {
            $fAmount = $oKupon->getAmount();
            $fAmountNet = round($fAmount*100/(100+$fSteuersatz),4);
            $warenkorbpos = new stdClass();
            $warenkorbpos->kWarenkorb      = $kWarenkorb;
            $warenkorbpos->kArtikel        = 0;
            $warenkorbpos->kVersandklasse  = 0;
            $warenkorbpos->cName           = $this->_prepare_string_for_jtl($oKupon->getName());
            $warenkorbpos->cLieferstatus   = '';
            $warenkorbpos->cArtNr          = '';
            $warenkorbpos->cEinheit        = '';
            $warenkorbpos->fPreisEinzelNetto = $fAmountNet*-1;
            $warenkorbpos->fPreis          = $fAmountNet*-1;
            $warenkorbpos->fMwSt           = $fSteuersatz;
            $warenkorbpos->nAnzahl         = 1;
            $warenkorbpos->nPosTyp         = C_WARENKORBPOS_TYP_ARTIKEL;
            $warenkorbpos->cHinweis        = '';
            $warenkorbpos->cUnique         = '';
            $warenkorbpos->kKonfigitem     = 0;
            $warenkorbpos->kBestellpos     = 0;
            if (SG_DEBUG_LOGGING)
              $this->log("add basket-external-coupon-position", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            $kWarenkorbPos = $GLOBALS["DB"]->insertRow("twarenkorbpos", $warenkorbpos);
            
            // lese Kundenguthaben und speichere neues Guthaben
            $fAmount *= 1;
            $GLOBALS["DB"]->executeQuery("UPDATE `tkunde` SET `fGuthaben`=`fGuthaben`-$fAmount WHERE `kKunde`=".$JTL_Client->kKunde,4);
          }
        }
      }
    }
    
    // add shipping
    // load default shipping_name from export-plugin
    $cInfo = $order->getShippingInfos()->getInternalShippingInfo();
    $bShippingInfo = false;
    if (!empty($cInfo))
    {
      $aInfo = $this->jsonDecode($cInfo, true);
      if (array_key_exists('kShipping', $aInfo) && array_key_exists('cShipping', $aInfo))
      {
        if (!empty($aInfo['kShipping']))
        {
          $nShippingKey = $aInfo['kShipping'];
          $cShippingName = $this->_prepare_string_for_jtl($aInfo['cShipping']);
          $bShippingInfo = true;
        }
      }
    }
    if (!$bShippingInfo)
    {
      $cShippingName = $this->_prepare_string_for_jtl($order->getShippingInfos()->getName());
      $nShippingKey = $this->getKVersandartByName($cShippingName, $aWarenkorbVersandklassen, $JTL_Client->kKundengruppe, $JTL_Delivery->cLand);
    }
    
    $shippingAmountWithoutTax = $order->getAmountShipping();

    if(!empty($fSteuersatz)) {
      // remove tax from shipping costs
      $shippingAmountWithoutTax /= 1+$fSteuersatz/100;
    }
    $warenkorbpos = new stdClass();
    $warenkorbpos->kWarenkorb      = $kWarenkorb;
    $warenkorbpos->kArtikel        = 0;
    $warenkorbpos->kVersandklasse  = 0;
    $warenkorbpos->cName           = $cShippingName; //'Versand'; // THERE IS NO SHOPGATE SOLUTION
    $warenkorbpos->cLieferstatus   = '';
    $warenkorbpos->cArtNr          = '';
    $warenkorbpos->cEinheit        = '';
    $warenkorbpos->fPreisEinzelNetto = $shippingAmountWithoutTax;
    $warenkorbpos->fPreis          = $shippingAmountWithoutTax;
    $warenkorbpos->fMwSt           = $fSteuersatz;
    $warenkorbpos->nAnzahl         = 1;
    $warenkorbpos->nPosTyp         = C_WARENKORBPOS_TYP_VERSANDPOS;
    $warenkorbpos->cHinweis        = '';
    $warenkorbpos->cUnique         = '';
    $warenkorbpos->kKonfigitem     = 0;
    $warenkorbpos->kBestellpos     = 0;
    if (SG_DEBUG_LOGGING)
      $this->log("add basket-shipping-position", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $kWarenkorbPos = $GLOBALS["DB"]->insertRow("twarenkorbpos", $warenkorbpos);
    
    // get payment-infos
    $payment_result = $this->plugin_handle_payment($order);
    $paymentType    = $payment_result['paymentType'];
    $paymentComment = $payment_result['paymentComment'];
    $kZahlart       = $payment_result['kZahlart'];
    $cZahlart       = $payment_result['cZahlart'];
    $cGebuehr       = $payment_result['cGebuehr'];
    if (array_key_exists('tZahlungseingang', $payment_result))
      $tZahlungseingang = $payment_result['tZahlungseingang'];
    
    if (!empty($paymentComment))
    {
      $paymentComment = chr(10).'Payment'.chr(10).$paymentComment;
    }
    
    // add payment
    if($order->getAmountShopPayment() != 0)
    {
      if (SG_DEBUG_LOGGING)
        $this->log("prepare payment-infos", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
			$paymentInfos = $order->getPaymentInfos();
      $paymentAmountWithoutTax = $order->getAmountShopPayment();
			if(!empty($fSteuersatz)) {
        // remove tax from shipping costs
        $paymentAmountWithoutTax /= 1+$fSteuersatz/100;
      }
      
			$warenkorbpos = new stdClass();
      $warenkorbpos->kWarenkorb      = $kWarenkorb;
      $warenkorbpos->kArtikel        = 0;
      $warenkorbpos->kVersandklasse  = 0;
      $warenkorbpos->cName           = $cGebuehr;
      $warenkorbpos->cLieferstatus   = '';
      $warenkorbpos->cArtNr          = '';
      $warenkorbpos->cEinheit        = '';
      $warenkorbpos->fPreisEinzelNetto = $paymentAmountWithoutTax;
      $warenkorbpos->fPreis          = $order->getAmountShopPayment();
      $warenkorbpos->fMwSt           = $fSteuersatz;
      $warenkorbpos->nAnzahl         = 1;
      $warenkorbpos->nPosTyp         = C_WARENKORBPOS_TYP_ZAHLUNGSART;
      $warenkorbpos->cHinweis        = '';
      $warenkorbpos->cUnique         = '';
      $warenkorbpos->kKonfigitem     = 0;
      $warenkorbpos->kBestellpos     = 0;
      $kWarenkorbPos = $GLOBALS["DB"]->insertRow("twarenkorbpos", $warenkorbpos);
      if (SG_DEBUG_LOGGING)
        $this->log("add payment-position", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
		}
    
    if (SG_DEBUG_LOGGING)
      $this->log("start order-object", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    /* BOF Build order-number */
    $tmp_order_number = '';
    if (array_key_exists('use_sg_number', $this->jtl_plugin_configuration))
    {
      if ($this->jtl_plugin_configuration['use_sg_number'] == 'yes')
        $tmp_order_number = $order->getOrderNumber();
      else
        $tmp_order_number = baueBestellnummer();
      $tmp_order_number = $this->jtl_plugin_configuration['number_prefix'].$tmp_order_number.$this->jtl_plugin_configuration['number_suffix'];
    }
    else
      $tmp_order_number = baueBestellnummer().'SG';
    /* EOF Build order-number */
    
    // create Order-object
    $JTL_Order = new Bestellung();
    $JTL_Order->kRechnungsadresse = $JTL_Invoice->kRechnungsadresse;
    $JTL_Order->kLieferadresse    = $equal_address ? 0 : $JTL_Delivery->kLieferadresse;
    $JTL_Order->kKunde            = $JTL_Client->kKunde;
    $JTL_Order->kZahlungsart      = $kZahlart;
    $JTL_Order->kVersandart       = $nShippingKey; // hope it works
    $JTL_Order->kWaehrung         = $kWaehrung;
    $JTL_Order->kSprache          = $JTL_Client -> kSprache;
    $JTL_Order->fGesamtsumme      = $order->getAmountComplete();
    $JTL_Order->cBestellNr        = $tmp_order_number;
    $JTL_Order->cKommentar        = 'shopgate '.$order->getOrderNumber(); //.$string_comments.$paymentComment;
    $JTL_Order->cVersandartName   = $cShippingName;
    $JTL_Order->cZahlungsartName  = $cZahlart; //$paymentType;
    $JTL_Order->dErstellt         = date('Y-m-d H:i:s');
    $JTL_Order->cStatus           = $order->getIsPaid() ? BESTELLUNG_STATUS_BEZAHLT : BESTELLUNG_STATUS_OFFEN;
    if ($order->getIsPaid())
      $JTL_Order->dBezahltDatum = $order->getPaymentTime('Y-m-d');
    $JTL_Order->kWarenkorb        = $kWarenkorb;
    $JTL_Order->cAbgeholt         = 'N';
    
    if ($order->getIsShippingBlocked() == 1)
    {
      $JTL_Order->cKommentar .= chr(10).chr(10).'SHOPGATE : Versand blockiert!';
    }
    if (SG_DEBUG_LOGGING)
      $this->log("save order in JTL", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $kBestellung = $JTL_Order->insertInDB();
    $GLOBALS["DB"]->executeQuery("UPDATE `tkunde` SET `cAbgeholt`='N' WHERE `kKunde`=".$JTL_Client->kKunde,4);
    
    $bestellid  = new stdClass();
    $bestellid->cId = gibUID(40, $kBestellung.md5(time()));
    $bestellid->kBestellung = $kBestellung;
    $bestellid->dDatum = "now()";
    $GLOBALS["DB"]->insertRow('tbestellid',$bestellid);
    
    $bestellstatus  = new stdClass();
    $bestellstatus->kBestellung = $kBestellung;
    $bestellstatus->dDatum ="now()";
    $bestellstatus->cUID = gibUID(40, (time().$kBestellung).substr(time(),-8));
    $GLOBALS["DB"]->insertRow('tbestellstatus',$bestellstatus);
    
    foreach ($addKuponBestellung as $row)
    {
      $KuponBestellung = new stdClass();
      $KuponBestellung->kKupon = $row;
      $KuponBestellung->kBestellung = $kBestellung;
      $GLOBALS['DB']->insertRow('tkuponbestellung', $KuponBestellung);
    }
    
    // safe in seperate table
    $ordersShopgateOrder  = new stdClass();
    $ordersShopgateOrder->kBestellung  = $kBestellung;
    $ordersShopgateOrder->kBestellungShopgate = $order->getOrderNumber();
    $ordersShopgateOrder->created      = date('Y-m-d H:i:s');
    $ordersShopgateOrder->modified     = date('Y-m-d H:i:s');
    $ordersShopgateOrder->sgShopNumber = $this->request_shop_number;
    if (SG_DEBUG_LOGGING)
      $this->log("save order in plugin-db", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $GLOBALS["DB"]->insertRow("xplugin_agi_shopgate_plugin_connect", $ordersShopgateOrder);
    
    if (isset($tZahlungseingang))
    {
      $tZahlungseingang->kBestellung  = $kBestellung;
      if (SG_DEBUG_LOGGING)
        $this->log("save payment-information in payment-db", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $GLOBALS["DB"]->insertRow("tzahlungseingang", $tZahlungseingang);
    }

    // Bestellmail versenden
    if (array_key_exists('cSendOrderConfirmation',$this->jtl_plugin_configuration) && $this->jtl_plugin_configuration['cSendOrderConfirmation'] == 'Y')
    {
      require_once DIR_BASE_PATH.'/includes/mailTools.php';
      $obj = new stdClass();
      $obj->cVerfuegbarkeit_arr = $verfuegbarkeitResult_arr;
      $bestellung = new Bestellung($kBestellung);
      $bestellung->fuelleBestellung(0);
      $obj->tkunde = $JTL_Client;
      $obj->tbestellung = $bestellung;
      sendeMail(MAILTEMPLATE_BESTELLBESTAETIGUNG, $obj);
    }
    
    // Return the order ID and number of the order saved to the database
    return array(
      'external_order_id' => $kBestellung,        // this is used to inform a developer in case there was a problem
      'external_order_number' => $JTL_Order->cBestellNr // this is used to inform a merchant in case there was a problem
    );
  }
  protected function _get_optionsPriceNetto($options, $tax = 19)
  {
    $sumNet = 0;
    if (!empty($options))
    {
      foreach($options as $option)
        $sumNet += round($option->getAdditionalAmountWithTax()*100/(100+$tax), 4);
    }
    return $sumNet;
  }
  public function updateOrder(ShopgateOrder $order)
  {
    $this->agiUpdateOrderIndividual($order);
    if (SG_DEBUG_LOGGING)
      $this->log("start updateOrder", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    // The database connection can be established here
    // Check if the order in question has already been imported into the system
    // with the Shopgate order number ($order->getOrderNumber()).
    // the order cannot be found in the system:
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kBestellung`, `history` FROM `xplugin_agi_shopgate_plugin_connect` WHERE `kBestellungShopgate`='".$order->getOrderNumber()."'",
      1
    );
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT `kBestellung`, `history` FROM `xplugin_agi_shopgate_plugin_connect` WHERE `kBestellungShopgate`='".$order->getOrderNumber()."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $dbOrderID = $tmp->kBestellung;
    $dbOrderHistory = $tmp->history;
    
    if (empty($dbOrderID)) {
      throw new ShopgateLibraryException(ShopgateLibraryException::PLUGIN_ORDER_NOT_FOUND, "Shopgate order number: '{$order->getOrderNumber()}'.");
    }
    
    // load some order-information
    $dbOrder = $GLOBALS["DB"]->executeQuery(
      "SELECT `cBestellNr`, `dBezahltDatum`, `cKommentar` FROM `tbestellung` WHERE `kBestellung`='".$dbOrderID."'",
      1
    );
    
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: SELECT `cBestellNr`, `dBezahltDatum`, `cKommentar` FROM `tbestellung` WHERE `kBestellung`='".$dbOrderID."'", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    $something_changed = false;
    $history_comments = array();
    $updateOrder  = new stdClass();
    if ($order->getUpdatePayment() == 1) 
    {
      if (SG_DEBUG_LOGGING)
        $this->log("payment changed", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      // Payment status or PaymentInfos has changed
      if ($order->getIsPaid() && $dbOrder->dBezahltDatum == '0000-00-00')
      {
        $updateOrder->dBezahltDatum = date('Y-m-d');
        $updateOrder->cStatus       = BESTELLUNG_STATUS_BEZAHLT;
        //$updateOrder->cKommentar    = empty($dbOrder->cKommentar) ? '' : $dbOrder->cKommentar.chr(10);
        $history_comments[] = 'Bestellstatus von Shopgate gendert: Zahlung erhalten';
        
        // get payment-infos
        $payment_result = $this->plugin_handle_payment($order);
        $paymentType    = $payment_result['paymentType'];
        $paymentComment = $payment_result['paymentComment'];
        $kZahlart       = $payment_result['kZahlart'];
        $cZahlart       = $payment_result['cZahlart'];
        if (array_key_exists('tZahlungseingang', $payment_result))
          $tZahlungseingang = $payment_result['tZahlungseingang'];
        
        if (!empty($paymentComment))
        {
          $paymentComment = chr(10).'Payment '.date('Y-m-d').chr(10).$paymentComment;
          //if (!isset($updateOrder->cKommentar))
            //$updateOrder->cKommentar = '';
          //$updateOrder->cKommentar .= $paymentComment;
        }
        // add payment information to shop
        if (isset($tZahlungseingang))
        {
          $tZahlungseingang->kBestellung  = $dbOrderID;
          if (SG_DEBUG_LOGGING)
            $this->log("save payment-information in payment-db for Paypal", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
          $GLOBALS["DB"]->insertRow("tzahlungseingang", $tZahlungseingang);
        }
        else
        {
          $objBestellung = new Bestellung($dbOrderID);
          $fBetrag       = $objBestellung->fGesamtsummeKundenwaehrung;
          $objISO = $GLOBALS["DB"]->executeQuery("SELECT cISO FROM twaehrung WHERE kWaehrung = '".$objBestellung->kWaehrung."'", 1);
          $cISO = $objISO->cISO;
          // safe in seperate table
          $ordersPayment  = new stdClass();
          $ordersPayment->kBestellung       = $dbOrderID;
          $ordersPayment->cZahlungsanbieter = $cZahlart; //$paymentType;
          $ordersPayment->fBetrag           = $fBetrag;
          $ordersPayment->cISO              = $cISO;
          $ordersPayment->dZeit             = date('Y-m-d H:i:s');
          $ordersPayment->cAbgeholt         = 'N';
          if (SG_DEBUG_LOGGING)
            $this->log("save payment-information in payment-db", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
          $GLOBALS["DB"]->insertRow("tzahlungseingang", $ordersPayment);
          $something_changed = true;
        }
      }
      elseif (!$order->getIsPaid() && $dbOrder->dBezahltDatum != '0000-00-00')
      {
        $updateOrder->dBezahltDatum = '0000-00-00';
        $updateOrder->cStatus       = BESTELLUNG_STATUS_OFFEN;
        $history_comments[] = 'Bestellstatus von Shopgate gendert: Zahlung noch nicht erhalten';
        $something_changed = true;
      }
    }

    if ($order->getUpdateShipping() == 1) 
    {
      
      if (SG_DEBUG_LOGGING)
        $this->log("shipping changed", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      // Released or blocked for shipping
      if ($order->getIsShippingBlocked() == 1)
      {
        $history_comments[] = 'Versand blockiert!';
        //if (!isset($updateOrder->cKommentar))
          //$updateOrder->cKommentar = '';
        //$updateOrder->cKommentar .= chr(10).date('Y-m-d').' Versand blockiert!';
        $something_changed = true;
      }
      else
      {
        $history_comments[] = 'Versand freigegeben';
        //if (!isset($updateOrder->cKommentar))
          //$updateOrder->cKommentar = '';
        //$updateOrder->cKommentar .= chr(10).date('Y-m-d').' Versand freigegeben!';
        $something_changed = true;
      }
    }
    
    if ($something_changed)
    {
      if (SG_DEBUG_LOGGING)
        $this->log("something changed and must be saved", ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
      $GLOBALS["DB"]->updateRow("tbestellung", "kbestellung", $dbOrderID, $updateOrder);
      $aUpdate = array(
        'modified'  => date('Y-m-d H:i:s')
      );
      if (!empty($history_comments))
        $aUpdate['history'] = $dbOrderHistory.chr(10).chr(10).'Update '.date('Y-m-d H:i:s').chr(10).implode(chr(10), $history_comments);
        
      if (!empty($aUpdate))
      {
        $uQuery = "UPDATE `xplugin_agi_shopgate_plugin_connect` SET ";
        $i = 0;
        foreach ($aUpdate as $key => $value)
        {
          if($i > 0)
            $uQuery .= ", ";
          $uQuery .= "`$key`='".mysql_real_escape_string($value)."'";
          $i++;
        }
        $uQuery .= " WHERE `kbestellung`=$dbOrderID";
        if (!empty($this->request_shop_number))
          $uQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
        if (SG_DEBUG_LOGGING)
          $this->log($uQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
        $GLOBALS["DB"]->executeQuery($uQuery, 3);
      }
    }
    
    // Return the order ID and number of the order saved to the database
    return array(
      'external_order_id' => $dbOrderID,        // this is used to inform a developer in case there was a problem
      'external_order_number' => $dbOrder->cBestellNr // this is used to inform a merchant in case there was a problem
    );
  }
  /// EOF ORDER-FUNCTIONS ///
  
  
  /// BOF CRONJOB-FUNCTIONS ///
  public function cron($jobname, $params, &$message, &$errorcount) 
  {
    switch($jobname) {
			case "set_shipping_completed":
				$aProcessLog = $this->cronSetShippingCompleted($message, $errorcount);
				break;
      case "cancel_orders":
				$aProcessLog = $this->cronGetCancelOrder($message, $errorcount);
				break;
			default:
				throw new ShopgateLibraryException(ShopgateLibraryException::PLUGIN_CRON_UNSUPPORTED_JOB, "{$jobname}", true);
		}
  }
  
  protected function cronSetShippingCompleted(&$message, &$errorcount)
  {
    $cQuery = "SELECT 
        xp.kBestellung, xp.kBestellungShopgate, tb.dVersandDatum
      FROM
        `xplugin_agi_shopgate_plugin_connect` AS xp, `tbestellung` AS tb
      WHERE
        xp.kBestellung=tb.kBestellung AND xp.sgVersandstatusGesendet=0 AND tb.dVersandDatum>'0000-00-00'
    ";
    if (!empty($this->request_shop_number))
      $cQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: ".$cQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    $builder = new ShopgateBuilder($this->config);
    $api = $builder->buildMerchantApi();
    
    $aRes = $GLOBALS["DB"]->executeQuery($cQuery, 9);
    foreach ($aRes as $row)
    {
      try 
      {
        $resp = $api->setOrderShippingCompleted($row['kBestellungShopgate']);
        if ($resp->error == 0)
        {
          $aUpdate = array(
            'sgVersandstatusGesendet'  => 1
          );
          if (!empty($aUpdate))
          {
            $uQuery = "UPDATE `xplugin_agi_shopgate_plugin_connect` SET ";
            $i = 0;
            foreach ($aUpdate as $key => $value)
            {
              if($i > 0)
                $uQuery .= ", ";
              $uQuery .= "`$key`='".(is_string($value) ? mysql_real_escape_string($value) : $value)."'";
              $i++;
            }
            $uQuery .= " WHERE `kBestellung`=".$row['kBestellung'];
            if (!empty($this->request_shop_number))
              $uQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
            if (SG_DEBUG_LOGGING)
              $this->log($uQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            $GLOBALS["DB"]->executeQuery($uQuery, 3);
          }
        }
        else
        {
          $this->log('cronSetShippingCompleted(): Code '.$resp->error.': '.$resp->error_text, ShopgateLogger::LOGTYPE_DEBUG);
        }
      }
      catch (Exception $e) 
      {
        $eCode = $e->getCode();
        if ($eCode == 204 || $eCode == 201)
        {
          $aUpdate = array(
            'sgVersandstatusGesendet'  => 1
          );
          if (!empty($aUpdate))
          {
            $uQuery = "UPDATE `xplugin_agi_shopgate_plugin_connect` SET ";
            $i = 0;
            foreach ($aUpdate as $key => $value)
            {
              if($i > 0)
                $uQuery .= ", ";
              $uQuery .= "`$key`='".(is_string($value) ? mysql_real_escape_string($value) : $value)."'";
              $i++;
            }
            $uQuery .= " WHERE `kBestellung`=".$row['kBestellung'];
            if (!empty($this->request_shop_number))
              $uQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
            if (SG_DEBUG_LOGGING)
              $this->log($uQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            $GLOBALS["DB"]->executeQuery($uQuery, 3);
            $message = 'Bestellung '.$row['kBestellungShopgate'].' war bereits manuell auf versendet gesetzt. JTL-Datenbank wurde aktualisiert.';
            $errorcount++;
          }
        }
        else
          echo 'Exception abgefangen: ',  $e->getMessage(), "\n";
      }
    }
  }

  protected function cronGetCancelOrder(&$message, &$errorcount)
  {
    $cQuery = "SELECT 
        xp.kBestellung, xp.kBestellungShopgate, tb.dVersandDatum
      FROM
        `xplugin_agi_shopgate_plugin_connect` AS xp, `tbestellung` AS tb
      WHERE
        xp.kBestellung=tb.kBestellung AND xp.sgBestellungStorniert=0 AND tb.cStatus='".BESTELLUNG_STATUS_STORNO."'
    ";
    if (!empty($this->request_shop_number))
      $cQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
    if (SG_DEBUG_LOGGING)
      $this->log("QRY: ".$cQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
    
    $builder = new ShopgateBuilder($this->config);
    $api = $builder->buildMerchantApi();
    
    $aRes = $GLOBALS["DB"]->executeQuery($cQuery, 9);
    foreach ($aRes as $row)
    {
      try 
      {
        $resp = $api->cancelOrder($row['kBestellungShopgate'], 1);
        if ($resp->error == 0)
        {
          $aUpdate = array(
            'sgBestellungStorniert'  => 1
          );
          if (!empty($aUpdate))
          {
            $uQuery = "UPDATE `xplugin_agi_shopgate_plugin_connect` SET ";
            $i = 0;
            foreach ($aUpdate as $key => $value)
            {
              if($i > 0)
                $uQuery .= ", ";
              $uQuery .= "`$key`='".(is_string($value) ? mysql_real_escape_string($value) : $value)."'";
              $i++;
            }
            $uQuery .= " WHERE `kBestellung`=".$row['kBestellung'];
            if (!empty($this->request_shop_number))
              $uQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
            if (SG_DEBUG_LOGGING)
              $this->log($uQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            $GLOBALS["DB"]->executeQuery($uQuery, 3);
          }
        }
        else
        {
          $this->log('cronGetCancelOrder(): Code '.$resp->error.': '.$resp->error_text, ShopgateLogger::LOGTYPE_DEBUG);
        }
      }
      catch (Exception $e) 
      {
        $eCode = $e->getCode();
        if ($eCode == 222 || $eCode == 201)
        {
          $aUpdate = array(
            'sgBestellungStorniert'  => 1
          );
          if (!empty($aUpdate))
          {
            $uQuery = "UPDATE `xplugin_agi_shopgate_plugin_connect` SET ";
            $i = 0;
            foreach ($aUpdate as $key => $value)
            {
              if($i > 0)
                $uQuery .= ", ";
              $uQuery .= "`$key`='".(is_string($value) ? mysql_real_escape_string($value) : $value)."'";
              $i++;
            }
            $uQuery .= " WHERE `kBestellung`=".$row['kBestellung'];
            if (!empty($this->request_shop_number))
              $uQuery .= " AND `sgShopNumber`=".$this->request_shop_number;
            if (SG_DEBUG_LOGGING)
              $this->log($uQuery, ShopgateLogger::LOGTYPE_DEBUG); // AGI debug_logging
            $GLOBALS["DB"]->executeQuery($uQuery, 3);
            $message = 'Bestellung '.$row['kBestellungShopgate'].' war bereits manuell storniert gesetzt. JTL-Datenbank wurde aktualisiert.';
            $errorcount++;
          }
        }
        else
          echo 'Exception abgefangen: ',  $e->getMessage(), "\n";
      }
    }
  }
  /// EOF CRONJOB-FUNCTIONS ///
  
  /// BOF STOCK AND CART_FUNCTIONS ///
  public function checkStock(ShopgateCart $shopgateCart) 
  {
    $this->agiCheckStockIndividual($shopgateCart);
    $items = $shopgateCart->getItems();
    
    $this->_loadCreateItemsConfig();
    
    $aItemResponse = array();
    foreach($items as $checkItem)
    {
      $itemId = $checkItem->getItemNumber();
      $itemQuantity = 100;
      $itemOptions = $checkItem->getOptions();
      $itemInputs = $checkItem->getInputs();
      
      // prepare response
      $oItemResponse = new ShopgateCartItem();
      $oItemResponse->setItemNumber($itemId);
      $oItemResponse->setOptions($itemOptions);
      $oItemResponse->setInputs($itemInputs);
      
      // load Article
      $this->_loadOExportArticle($itemId);
      if (!empty($this->oExportArticle->kArtikel))
      {
        $this->_itemCheckStatusAktiv();
        $this->_itemLoadAttributes();
        
        $oItemResponse = new ShopgateCartItem();
        $oItemResponse->setItemNumber($itemId);
        
        if ($this->oExportArticle->cStatusAktiv == 'inactive')
        {
          $oItemResponse->setIsBuyable(0);
          $oItemResponse->setStockQuantity(0);
          $oItemResponse->setError(300);
          $oItemResponse->setErrorText('cart item out of stock');
        }
        elseif ($this->oExportArticle->cStatusAktiv == 'stock')
        {
          $oItemResponse->setStockQuantity($this->oExportArticle->fLagerbestand);
          /*
          if ($this->oExportArticle->fLagerbestand < $itemQuantity)
          {
            $oItemResponse->setQtyBuyable($this->oExportArticle->fLagerbestand);
            $oItemResponse->setIsBuyable(0);
            $oItemResponse->setError(302);
            $oItemResponse->setErrorText('cart item requested quantity not available');
          }
          else
          */
          if($this->oExportArticle->fLagerbestand < 1)
          {
            $oItemResponse->setError(300);
            $oItemResponse->setErrorText('cart item out of stock');
          }
          else
            $oItemResponse->setIsBuyable(1);
        }
        else
        {
          if (!$this->oExportArticle->nUseStock)
          {
            $oItemResponse->setStockQuantity(100);
          }
          else
            $oItemResponse->setStockQuantity($this->oExportArticle->fLagerbestand);
          $oItemResponse->setIsBuyable(1);
        }
        if (!empty($itemOptions) && !empty($this->oExportArticle->aSelectAttribute))
        {
          foreach ($itemOptions as $checkOption)
          {
            $option_number = $checkOption->getOptionNumber();
            $value_number = $checkOption->getValueNumber();
            if (
              array_key_exists($option_number, $this->oExportArticle->aSelectAttribute) 
              && array_key_exists($value_number, $this->oExportArticle->aSelectAttribute[$option_number]['aWerte']))
            {
              $aOption = $this->oExportArticle->aSelectAttribute[$option_number]['aWerte'][$value_number];
              if ($this->oExportArticle->cStatusAktiv == 'active' || ($this->oExportArticle->cStatusAktiv == 'stock' && ($aOption['fLagerbestand'] > 0 || $this->oExportArticle->cLagerVariation == 'N')))
              {
                if ($this->oExportArticle->cStatusAktiv == 'stock')
                {
                  if ($this->oExportArticle->cLagerVariation == 'Y' && $aOption['fLagerbestand'] <= 0)
                  {
                    $oItemResponse->setStockQuantity(0);
                    $oItemResponse->setIsBuyable(0);
                    $oItemResponse->setError(300);
                    $oItemResponse->setErrorText('cart item out of stock');
                  }
                  /*
                  elseif ($this->oExportArticle->cLagerVariation == 'Y' && $aOption['fLagerbestand'] < $itemQuantity)
                  {
                    $oItemResponse->setStockQuantity($aOption['fLagerbestand']);
                    $oItemResponse->setIsBuyable(0);
                    $oItemResponse->setQtyBuyable($aOption['fLagerbestand']);
                    $oItemResponse->setError(302);
                    $oItemResponse->setErrorText('cart item requested quantity not available');
                  }
                  */
                }
              }
              else
              {
                $oItemResponse->setIsBuyable(0);
                $oItemResponse->setStockQuantity(0);
                $oItemResponse->setError(300);
                $oItemResponse->setErrorText('cart item out of stock');
              }
            }
            else
            {
              $oItemResponse->setError(301);
              $oItemResponse->setErrorText('cart item product-option not found');
            }
          }
        }
        elseif (!empty($itemOptions) && empty($this->oExportArticle->aSelectAttribute))
        {
          $oItemResponse->setError(301);
          $oItemResponse->setErrorText('cart item product has no options');
        }
      }
      else
      {
        $oItemResponse->setError(301);
        $oItemResponse->setErrorText('cart item product not found');
      }
      
      $aItemResponse[] = $oItemResponse;
    }
    return $aItemResponse;
  }
  
  public function checkCart(ShopgateCart $shopgateCart)
  {
    $this->agiCheckCartIndividual($shopgateCart);
    $items = $shopgateCart->getItems();
    
    $this->_loadCreateItemsConfig();
    
    $aItemResponse = array();
    $aPositionen   = array();
    $aWarenWertGet = array('brutto'=>0, 'netto'=>0);
    $aWarenWertSet = array('brutto'=>0, 'netto'=>0);
    $_SESSION['Warenkorb'] = new Warenkorb();
    foreach($items as $checkItem)
    {
      $itemId = $checkItem->getItemNumber();
      $itemsTaxPercent = $checkItem->getTaxPercent();
      $itemQuantity = $checkItem->getQuantity();
      $itemOptions = $checkItem->getOptions();
      $itemInputs = $checkItem->getInputs();
      $aOptionsWert  = array('brutto'=>0, 'netto'=>0);
      
      $aWarenWertGet['brutto'] += $itemQuantity*$checkItem->getUnitAmountWithTax();
      $aWarenWertGet['netto'] += $itemQuantity*$checkItem->getUnitAmount();
      $bAllowForBasket = true;
      
      // prepare response
      $oItemResponse = new ShopgateCartItem();
      $oItemResponse->setItemNumber($itemId);
      $oItemResponse->setUnitAmount($checkItem->getUnitAmount());
      $oItemResponse->setUnitAmountWithTax($checkItem->getUnitAmountWithTax());
      $oItemResponse->setOptions($itemOptions);
      $oItemResponse->setInputs($itemInputs);
      
      // load Article
      $this->_loadOExportArticle($itemId);
      if (!empty($this->oExportArticle->kArtikel))
      {
        $this->_itemCheckStatusAktiv();
        $this->_itemLoadAttributes();
        
        $tmpKats = array();
        if(count($this->oExportArticle->oKategorie_arr) > 0)
        {
          foreach ($this->oExportArticle->oKategorie_arr as $oCategorie)
            $tmpKats[] = $oCategorie->kKategorie;
        }
        $aPosition = array(
          'kArtikel'    => $this->oExportArticle->kArtikel,
          'cArtNr'      => $this->oExportArticle->cArtNr,
          'aKategorien' => $tmpKats
        );
        $aPositionen[] = $aPosition;
        
        //$oItemResponse = new ShopgateCartItem();
        $oItemResponse->setItemNumber($itemId);
        
        if ($this->oExportArticle->cStatusAktiv == 'inactive')
        {
          $oItemResponse->setIsBuyable(0);
          $oItemResponse->setQtyBuyable(0);
          $oItemResponse->setStockQuantity(0);
          $oItemResponse->setError(300);
          $oItemResponse->setErrorText('cart item out of stock');
          $bAllowForBasket = false;
        }
        elseif ($this->oExportArticle->cStatusAktiv == 'stock')
        {
          $oItemResponse->setStockQuantity($this->oExportArticle->fLagerbestand);
          if ($this->oExportArticle->fLagerbestand < $itemQuantity)
          {
            $oItemResponse->setQtyBuyable($this->oExportArticle->fLagerbestand);
            $oItemResponse->setIsBuyable(0);
            $oItemResponse->setError(302);
            $oItemResponse->setErrorText('cart item requested quantity not available');
            if($this->oExportArticle->fLagerbestand < 1)
            {
              $oItemResponse->setError(300);
              $oItemResponse->setErrorText('cart item out of stock');
            }
            $bAllowForBasket = false;
          }
          else
          {
            if ($this->oExportArticle->fMindestbestellmenge > $itemQuantity)
            {
              $oItemResponse->setQtyBuyable($this->oExportArticle->fMindestbestellmenge);
              $oItemResponse->setIsBuyable(0);
              $oItemResponse->setError(304);
              $oItemResponse->setErrorText('requested quantity is lower than required minimum quantity');
              $bAllowForBasket = false;
            }
            else
            {
              $oItemResponse->setQtyBuyable($itemQuantity);
              $oItemResponse->setIsBuyable(1);
            }
          }
        }
        else
        {
          $oItemResponse->setStockQuantity($this->oExportArticle->fLagerbestand);
          $oItemResponse->setQtyBuyable($itemQuantity);
          $oItemResponse->setIsBuyable(1);
        }
        $oEigenschaftwerte_arr = array();
        if (!empty($itemOptions) && !empty($this->oExportArticle->aSelectAttribute))
        {
          foreach ($itemOptions as $checkOption)
          {
            $option_number = $checkOption->getOptionNumber();
            $value_number = $checkOption->getValueNumber();
            if (
              array_key_exists($option_number, $this->oExportArticle->aSelectAttribute) 
              && array_key_exists($value_number, $this->oExportArticle->aSelectAttribute[$option_number]['aWerte']))
            {
              $fOptionPrice = $checkOption->getAdditionalAmountWithTax()/100;
              $aOptionsWert['brutto'] += $fOptionPrice;
              $aOptionsWert['netto']  += round($fOptionPrice*100/(100+$itemsTaxPercent),5);
              $aOption = $this->oExportArticle->aSelectAttribute[$option_number]['aWerte'][$value_number];
              
              $oEigenschaftwerte = new stdClass();
              $oEigenschaftwerte->kEigenschaft = $option_number;
              $oEigenschaftwerte->cFreifeldWert= '';
              $oEigenschaftwerte->kEigenschaftWert=$value_number;
              $oEigenschaftwerte->fAufpreisNetto = round($fOptionPrice*100/(100+$itemsTaxPercent),5);
              $oEigenschaftwerte_arr[] = $oEigenschaftwerte;
              
              if ($this->oExportArticle->cStatusAktiv == 'active' || ($this->oExportArticle->cStatusAktiv == 'stock' && ($aOption['fLagerbestand'] > 0 || $this->oExportArticle->cLagerVariation == 'N')))
              {
                if ($this->oExportArticle->cStatusAktiv == 'stock')
                {
                  if ($this->oExportArticle->cLagerVariation == 'Y' && $aOption['fLagerbestand'] <= 0)
                  {
                    $oItemResponse->setStockQuantity(0);
                    $oItemResponse->setIsBuyable(0);
                    $oItemResponse->setError(300);
                    $oItemResponse->setErrorText('cart item out of stock');
                    $bAllowForBasket = false;
                  }
                  elseif ($this->oExportArticle->cLagerVariation == 'Y' && $aOption['fLagerbestand'] < $itemQuantity)
                  {
                    $oItemResponse->setStockQuantity($aOption['fLagerbestand']);
                    $oItemResponse->setIsBuyable(0);
                    $oItemResponse->setQtyBuyable($aOption['fLagerbestand']);
                    $oItemResponse->setError(302);
                    $oItemResponse->setErrorText('cart item requested quantity not available');
                    $bAllowForBasket = false;
                  }
                }
              }
              else
              {
                $oItemResponse->setIsBuyable(0);
                $oItemResponse->setStockQuantity(0);
                $oItemResponse->setError(300);
                $oItemResponse->setErrorText('cart item out of stock');
                $bAllowForBasket = false;
              }
            }
            else
            {
              $oItemResponse->setError(301);
              $oItemResponse->setErrorText('cart item product-option not found');
            }
          }
        }
        elseif (!empty($itemOptions) && empty($this->oExportArticle->aSelectAttribute))
        {
          $oItemResponse->setError(301);
          $oItemResponse->setErrorText('cart item product has no options');
        }
        
        if (!empty($itemInputs) && !empty($this->oExportArticle->aInputAttribute))
        {
          foreach ($itemInputs as $checkOption)
          {
            $option_number = $checkOption->getInputNumber();
            if (array_key_exists($option_number, $this->oExportArticle->aInputAttribute))
            {
              $oEigenschaftwerte = new stdClass();
              $oEigenschaftwerte->kEigenschaft = $option_number;
              $oEigenschaftwerte->cFreifeldWert= $checkOption->getUserInput();
              $oEigenschaftwerte->kEigenschaftWert=0;
              $oEigenschaftwerte->fAufpreisNetto=0;
              $oEigenschaftwerte_arr[] = $oEigenschaftwerte;
            }
          }
        }
      }
      else
      {
        $oItemResponse->setError(301);
        $oItemResponse->setErrorText('cart item product not found');
        $bAllowForBasket = false;
      }
      
      if ($bAllowForBasket)
      {
        $NeuePosition = new WarenkorbPos();
        $NeuePosition->Artikel = $this->oExportArticle;
        $NeuePosition->nAnzahl = $itemQuantity;
        $NeuePosition->kArtikel = $NeuePosition->Artikel->kArtikel;
        $NeuePosition->kVersandklasse = $NeuePosition->Artikel->kVersandklasse;
        $NeuePosition->kSteuerklasse = $NeuePosition->Artikel->kSteuerklasse;
        $NeuePosition->fPreisEinzelNetto = $checkItem->getUnitAmount();
        $NeuePosition->fPreis = $checkItem->getUnitAmount()+$aOptionsWert['netto'];		
        $NeuePosition->cArtNr = $NeuePosition->Artikel->cArtNr;
        $NeuePosition->nPosTyp = C_WARENKORBPOS_TYP_ARTIKEL;
        $NeuePosition->cEinheit = $NeuePosition->Artikel->cEinheit;
        $NeuePosition->fGesamtgewicht = $NeuePosition->gibGesamtgewicht();
        $NeuePosition->WarenkorbPosEigenschaftArr = array();
        
        if(is_array($NeuePosition->Artikel->Variationen) && count($NeuePosition->Artikel->Variationen) > 0)
        {
          foreach ($NeuePosition->Artikel->Variationen as $eWert)
          {
            foreach ($oEigenschaftwerte_arr as $oEigenschaftwerte)
            {
              //gleiche Eigenschaft suchen
              if ($oEigenschaftwerte->kEigenschaft == $eWert->kEigenschaft)
              {
                if ($eWert->cTyp=="FREIFELD" || $eWert->cTyp=="PFLICHT-FREIFELD")
                {
                  $NeueWarenkorbPosEigenschaft = new WarenkorbPosEigenschaft();
                  $NeueWarenkorbPosEigenschaft->kEigenschaft = $oEigenschaftwerte->kEigenschaft;
                  $NeueWarenkorbPosEigenschaft->kEigenschaftWert = 0;
                  $NeueWarenkorbPosEigenschaft->fGewichtsdifferenz = 0;
                  $NeueWarenkorbPosEigenschaft->fAufpreis = 0;
                  $NeuePosition->WarenkorbPosEigenschaftArr[] = $NeueWarenkorbPosEigenschaft;
                }
                elseif ($oEigenschaftwerte->kEigenschaftWert > 0)
                {
                  $EigenschaftWert = new EigenschaftWert($oEigenschaftwerte->kEigenschaftWert);
                  $Eigenschaft = new Eigenschaft($oEigenschaftwerte->kEigenschaft);
                  // Varkombi Kind?
                  if($NeuePosition->Artikel->kVaterArtikel > 0)
                  {
                    if ($Eigenschaft->kArtikel == $NeuePosition->Artikel->kVaterArtikel)
                    {
                      $NeueWarenkorbPosEigenschaft = new WarenkorbPosEigenschaft();
                      $NeueWarenkorbPosEigenschaft->kEigenschaft = $oEigenschaftwerte->kEigenschaft;
                      $NeueWarenkorbPosEigenschaft->kEigenschaftWert = $oEigenschaftwerte->kEigenschaftWert;
                      $NeueWarenkorbPosEigenschaft->fGewichtsdifferenz = $EigenschaftWert->fGewichtDiff;
                      $NeueWarenkorbPosEigenschaft->fAufpreis = $oEigenschaftwerte->fAufpreisNetto;
                      
                      $NeuePosition->WarenkorbPosEigenschaftArr[] = $NeueWarenkorbPosEigenschaft;
                      $NeuePosition->fGesamtgewicht += $itemQuantity*$EigenschaftWert->fGewichtDiff;
                    }
                  }
                  else
                  {
                    if ($Eigenschaft->kArtikel == $NeuePosition->kArtikel)
                    {
                      $NeueWarenkorbPosEigenschaft = new WarenkorbPosEigenschaft();
                      $NeueWarenkorbPosEigenschaft->kEigenschaft = $oEigenschaftwerte->kEigenschaft;
                      $NeueWarenkorbPosEigenschaft->kEigenschaftWert = $oEigenschaftwerte->kEigenschaftWert;
                      $NeueWarenkorbPosEigenschaft->fGewichtsdifferenz = $EigenschaftWert->fGewichtDiff;
                      $NeueWarenkorbPosEigenschaft->fAufpreis = $oEigenschaftwerte->fAufpreisNetto;
                      
                      $NeuePosition->WarenkorbPosEigenschaftArr[] = $NeueWarenkorbPosEigenschaft;
                      $NeuePosition->fGesamtgewicht += $itemQuantity*$EigenschaftWert->fGewichtDiff;
                    }
                  }
                }
              }
            }
          }
        }
        
        $_SESSION['Warenkorb']->PositionenArr[] = $NeuePosition;
        
        $aWarenWertSet['brutto'] += $itemQuantity*($checkItem->getUnitAmountWithTax()+$aOptionsWert['brutto']);
        $aWarenWertSet['netto'] += $itemQuantity*($checkItem->getUnitAmount()+$aOptionsWert['netto']);
      }
      $aItemResponse[] = $oItemResponse;
    }
    
    $aCustomerResponse = array('customer_groups'=>array());
    $kKunde = 0;
    $kKundengruppe = $this->kKundengruppe;
    $fKundeGuthabenBrutto = 0;
    $cKundenMail = $shopgateCart->getMail();
    if (!empty($cKundenMail))
    {
      $cMail = $this->_prepare_string_for_jtl($cKundenMail);
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `kKunde`, `kKundengruppe`, `fGuthaben` FROM `tkunde` WHERE `cMail`='".$GLOBALS['DB']->escape($cMail)."' AND `nRegistriert`=1",
        1
      );
      if (!empty($tmp))
      {
        $kKundengruppe = $tmp->kKundengruppe;
        $kKunde = $tmp->kKunde;
        $fKundeGuthabenBrutto = $tmp->fGuthaben;
      }
    }
    else
    {
      $nKundengruppe = 0; //$shopgateCart->getExternalCustomerGroupId();
      if (!empty($nKundengruppe))
      {
        $oKundengruppe = $GLOBALS['DB']->executeQuery(
          "SELECT `kKundengruppe` FROM `tkundengruppe` WHERE `kKundengruppe`='".(int)$nKundengruppe."'", 
          1
        );
        if(isset($oKundengruppe->kKundengruppe) && $oKundengruppe->kKundengruppe > 0)
          $kKundengruppe = $oKundengruppe->kKundengruppe;
      }
    }
    $group = new ShopgateCartCustomerGroup();
    $group->setId($kKundengruppe);
    $aCustomerResponse = new ShopgateCartCustomer();
    $aCustomerResponse->setCustomerGroups(array($group));
    
    $deliveryCountry = false;
    $oDelivery = $shopgateCart->getDeliveryAddress();
    if ($oDelivery)
    {
      $tmp = $this->_prepare_string_for_jtl($oDelivery->getCountry());
      if (!empty($tmp))
        $deliveryCountry = $tmp;
    }
    
    // ermittle Steuersatz
    $LandSteuersatz = !$deliveryCountry ? $this->cLieferLand : $deliveryCountry;
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kSteuerzone` FROM `tsteuerzoneland` WHERE `cISO`='$cLandSteuersatz'",
      1
    );
    if (!empty($tmp))
    {
      $kSteuerzone = $tmp->kSteuerzone;
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `kSteuerklasse` FROM `tsteuerklasse` WHERE `cStandard`='Y'",
        1
      );
      $kSteuerklasse = $tmp->kSteuerklasse;
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `fSteuersatz` FROM `tsteuersatz` WHERE `kSteuerklasse`=$kSteuerklasse AND `kSteuerzone`=$kSteuerzone",
        1
      );
      $fSteuersatz = $tmp->fSteuersatz;
    }
    else
      $fSteuersatz = $this->fallback_steuersatz;
    
    $aCouponsResponse = array();
    $aGuthabenKupon = array();
    $fSummeKupons = array('brutto'=>0, 'netto'=>0);
    $coupons = $shopgateCart->getExternalCoupons();
    $hatVersandkupon = false;
    foreach ($coupons as $checkCoupon)
    {
      //suche code
      $cCode = $checkCoupon->getCode();
      if (!empty($cCode))
      {
        $tmpCode = $this->_prepare_string_for_jtl($cCode);
        if ($tmpCode == 'GUTHABENVERRECHNUNG')
        {
          $aGuthabenKupon = array(
            'amount_netto'  => $checkCoupon->getAmountNet()/100
          );
        }
        else
        {
          $oKupon = $GLOBALS["DB"]->executeQuery(
            "SELECT * FROM `tkupon` WHERE `cCode`='".$GLOBALS['DB']->escape($tmpCode)."'", 
            1
          );
          if($oKupon)
          {
            $kuponSprache = $GLOBALS["DB"]->executeQuery("SELECT * `tkuponsprache` WHERE `kKupon`=".$oKupon->kKupon." AND `cISOSprache`='".$_SESSION['cISOSprache']."'", 1);
            if ($oKupon->cWertTyp == 'prozent')
            {
              $kuponwert = array(
                'brutto'  => round($aWarenWertSet['brutto']*$oKupon->fWert/100, 5),
                'netto'   => round($aWarenWertSet['netto']*$oKupon->fWert/100, 5)
              );
            }
            else
            {
              $kuponwert = array(
                'brutto'  => $oKupon->fWert,
                'netto'   => round($oKupon->fWert*100/(100+$fSteuersatz), 5)
              );
            }
            $checkResult = $this->_checkCoupon($oKupon, $kKunde, $kKundengruppe, $aWarenWertSet, $aPositionen, $deliveryCountry);
            $kupon = new ShopgateExternalCoupon();
            $kupon->setIsValid($checkResult > 0 ? 0 : 1);
            $kupon->setNotValidMessage($checkResult > 0 ? $this->_getKuponErrorMessage($checkResult) : '');
            $kupon->setCode($this->_pss($oKupon->cCode));
            $kupon->setName($this->_pss($kuponSprache ? $kuponSprache->cName : $oKupon->cName));
            $kupon->setDescription('');
            //$kupon->setAmountGross($kuponwert['brutto']);
            $kupon->setAmountNet($kuponwert['netto']);
            $kupon->setTaxType('auto');
            $kupon->setIsFreeShipping($checkResult == 0 && $oKupon->cKuponTyp == 'versandkupon' ? 1 : 0);
            $aInfo = array('kKupon'=>$oKupon->kKupon);
            $kupon->setInternalInfo($checkResult == 0 ? $this->jsonEncode($aInfo) : ''); // ID des Coupons, um ihn bei Add-Order schnell zuordnen zu knnen
            $aCouponsResponse[] = $kupon;
            if ($checkResult == 0 && $oKupon->cKuponTyp == 'versandkupon')
              $hatVersandkupon = true;
            if ($checkResult == 0)
            {
              $fSummeKupons['brutto'] += $kuponwert['brutto'];
              $fSummeKupons['netto'] += $kuponwert['netto'];
            }
          }
          else
          {
            $kupon = $checkCoupon;
            $kupon->setIsValid(0);
            $kupon->setNotValidMessage('Der Gutscheincode ist nicht korrekt');
            $aCouponsResponse[] = $kupon;
          }
        }
      }
    }
    
    $sgCoupons = $shopgateCart->getShopgateCoupons();
    foreach ($sgCoupons as $checkCoupon)
    {
      if ($checkCoupon->getIsFreeShipping())
        $hatVersandkupon = true;
    }
    
    $fWarenkorbWarenwert = array(
      'brutto'=>$aWarenWertSet['brutto']-$fSummeKupons['brutto'], 
      'netto'=>$aWarenWertSet['netto']-$fSummeKupons['netto']
    );
    
    // fge Guthabenkupon ein
    if (!empty($kKunde) && $fKundeGuthabenBrutto > 0 && $this->jtl_plugin_configuration['cGuthabenverrechnung'] == 'Y')
    {
      // erlaubtes Guthaben darf nicht hher als der Warenwert sein
      $fErlaubtesGuthaben = $fKundeGuthabenBrutto > $fWarenkorbWarenwert['brutto'] ? $fWarenkorbWarenwert['brutto'] : $fKundeGuthabenBrutto;
      if ($fErlaubtesGuthaben > 0)
      {
        $kupon = new ShopgateExternalCoupon();
        $kupon->setIsValid(1);
        $kupon->setNotValidMessage('');
        $kupon->setCode('GUTHABENVERRECHNUNG');
        $kupon->setName('Guthabenverrechnung');
        $kupon->setDescription('');
        //$kupon->setAmountGross($fErlaubtesGuthaben);
        $kupon->setAmountNet(round($fErlaubtesGuthaben*100/(100+$fSteuersatz), 5));
        $kupon->setTaxType('auto');
        $kupon->setIsFreeShipping(0);
        $aInfo = array('kundenguthaben'=>$kKunde);
        $kupon->setInternalInfo($this->jsonEncode($aInfo));
        $aCouponsResponse[] = $kupon;
      }
    }
    elseif (!empty($aGuthabenKupon))
    {
      $kupon = new ShopgateExternalCoupon();
      $kupon->setIsValid(0);
      $kupon->setNotValidMessage('Guthabenverrechnung nicht mglich');
      $kupon->setCode('GUTHABENVERRECHNUNG');
      $kupon->setName('Guthabenverrechnung');
      $kupon->setDescription('');
      $kupon->setAmountNet($aGuthabenKupon['amount_netto']);
      $kupon->setTaxType('auto');
      $kupon->setIsFreeShipping(0);
      $kupon->setInternalInfo('');
      $aCouponsResponse[] = $kupon;
    }
    
    $aShippingMethods = array();
    
    $deliveryZip = $oDelivery ? $this->_prepare_string_for_jtl($oDelivery->getZipcode()) : false;
    $oVersandart_arr = $this->_gibMoeglicheVersandarten($deliveryCountry, $deliveryZip, gibVersandklassen($_SESSION['Warenkorb']), $kKundengruppe);
    foreach ($oVersandart_arr as $oVersandart)
    {
      $oShippingMethod = new ShopgateShippingMethod();
      $oShippingMethod->setId($oVersandart->kVersandart);
      $oShippingMethod->setTitle($this->_pss($oVersandart->angezeigterName));
      $oShippingMethod->setDescription($this->_pss($this->_remove_html($oVersandart->angezeigterHinweistext)));
      //$oShippingMethod->setSortOrder($oVersandart->nSort);
      if ($oVersandart->fVersandkostenfreiAbX > 0 && $fWarenkorbWarenwert['brutto'] > $oVersandart->fVersandkostenfreiAbX)
      {
        $oShippingMethod->setAmountWithTax(0);
      }
      else
      {
        if ($oVersandart->eSteuer == 'brutto')
          $oShippingMethod->setAmountWithTax($hatVersandkupon ? 0 : $oVersandart->fEndpreis);
        else
          $oShippingMethod->setAmount($hatVersandkupon ? 0 : $oVersandart->fEndpreis);
        //$oShippingMethod->setTaxClass();
        //$oShippingMethod->setTaxPercent();
      }
      $aInfo = array('kShipping'=>$oVersandart->kVersandart,'cShipping'=>$this->_pss($oVersandart->angezeigterName));
      $oShippingMethod->setInternalShippingInfo($this->jsonEncode($aInfo));
      $aShippingMethods[] = $oShippingMethod;
      
    }
    
    $response = array(
      'currency'  => $_SESSION['Waehrung']->cISO,
      'customer'  => $aCustomerResponse,
      'external_coupons'  => $aCouponsResponse,
      'shipping_methods'  => $aShippingMethods,
      'items'     => $aItemResponse
    );
    return $response;
  }
  public function redeemCoupons(ShopgateCart $shopgateCart)
  {
    $this->agiCheckCartIndividual($shopgateCart);
    $items = $shopgateCart->getItems();
    
    $this->_loadCreateItemsConfig();
    
    $aPositionen   = array();
    $aWarenWertGet = array('brutto'=>0, 'netto'=>0);
    $aWarenWertSet = array('brutto'=>0, 'netto'=>0);
    
    foreach($items as $checkItem)
    {
      $itemId = $checkItem->getItemNumber();
      $itemsTaxPercent = $checkItem->getTaxPercent();
      $itemQuantity = $checkItem->getQuantity();
      $itemOptions = $checkItem->getOptions();
      $itemInputs = $checkItem->getInputs();
      $aOptionsWert  = array('brutto'=>0, 'netto'=>0);
      
      $aWarenWertGet['brutto'] += $itemQuantity*$checkItem->getUnitAmountWithTax();
      $aWarenWertGet['netto'] += $itemQuantity*$checkItem->getUnitAmount();
      $bAllowForBasket = true;
      
      // load Article
      $this->_loadOExportArticle($itemId);
      if (!empty($this->oExportArticle->kArtikel))
      {
        $this->_itemCheckStatusAktiv();
        $this->_itemLoadAttributes();
        
        $tmpKats = array();
        if(count($this->oExportArticle->oKategorie_arr) > 0)
        {
          foreach ($this->oExportArticle->oKategorie_arr as $oCategorie)
            $tmpKats[] = $oCategorie->kKategorie;
        }
        $aPosition = array(
          'kArtikel'    => $this->oExportArticle->kArtikel,
          'cArtNr'      => $this->oExportArticle->cArtNr,
          'aKategorien' => $tmpKats
        );
        $aPositionen[] = $aPosition;
        
        if ($this->oExportArticle->cStatusAktiv == 'inactive')
        {
          $bAllowForBasket = false;
        }
        elseif ($this->oExportArticle->cStatusAktiv == 'stock')
        {
          if ($this->oExportArticle->fLagerbestand < $itemQuantity)
          {
            $bAllowForBasket = false;
          }
          else
          {
            if ($this->oExportArticle->fMindestbestellmenge > $itemQuantity)
            {
              $bAllowForBasket = false;
            }
          }
        }
        if (!empty($itemOptions) && !empty($this->oExportArticle->aSelectAttribute))
        {
          foreach ($itemOptions as $checkOption)
          {
            $option_number = $checkOption->getOptionNumber();
            $value_number = $checkOption->getValueNumber();
            if (
              array_key_exists($option_number, $this->oExportArticle->aSelectAttribute) 
              && array_key_exists($value_number, $this->oExportArticle->aSelectAttribute[$option_number]['aWerte']))
            {
              $fOptionPrice = $checkOption->getAdditionalAmountWithTax()/100;
              $aOptionsWert['brutto'] += $fOptionPrice;
              $aOptionsWert['netto']  += round($fOptionPrice*100/(100+$itemsTaxPercent),5);
              $aOption = $this->oExportArticle->aSelectAttribute[$option_number]['aWerte'][$value_number];
              if ($this->oExportArticle->cStatusAktiv == 'active' || ($this->oExportArticle->cStatusAktiv == 'stock' && ($aOption['fLagerbestand'] > 0 || $this->oExportArticle->cLagerVariation == 'N')))
              {
                if ($this->oExportArticle->cStatusAktiv == 'stock')
                {
                  if ($this->oExportArticle->cLagerVariation == 'Y' && $aOption['fLagerbestand'] <= 0)
                  {
                    $bAllowForBasket = false;
                  }
                  elseif ($this->oExportArticle->cLagerVariation == 'Y' && $aOption['fLagerbestand'] < $itemQuantity)
                  {
                    $bAllowForBasket = false;
                  }
                }
              }
              else
              {
                $bAllowForBasket = false;
              }
            }
          }
        }
      }
      else
      {
        $bAllowForBasket = false;
      }
      
      if ($bAllowForBasket)
      {
        $aWarenWertSet['brutto'] += $itemQuantity*($checkItem->getUnitAmountWithTax()+$aOptionsWert['brutto']);
        $aWarenWertSet['netto'] += $itemQuantity*($checkItem->getUnitAmount()+$aOptionsWert['netto']);
      }
    }
    
    $kKunde = 0;
    $kKundengruppe = $this->kKundengruppe;
    $fKundeGuthabenBrutto = 0;
    $cKundenMail = $shopgateCart->getMail();
    if (!empty($cKundenMail))
    {
      $cMail = $this->_prepare_string_for_jtl($cKundenMail);
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `kKunde`, `kKundengruppe`, `fGuthaben` FROM `tkunde` WHERE `cMail`='".$GLOBALS['DB']->escape($cMail)."' AND `nRegistriert`=1",
        1
      );
      if (!empty($tmp))
      {
        $kKundengruppe = $tmp->kKundengruppe;
        $kKunde = $tmp->kKunde;
        $fKundeGuthabenBrutto = $tmp->fGuthaben;
      }
    }
    else
    {
      $nKundengruppe = 0; //$shopgateCart->getExternalCustomerGroupId();
      if (!empty($nKundengruppe))
      {
        $oKundengruppe = $GLOBALS['DB']->executeQuery(
          "SELECT `kKundengruppe` FROM `tkundengruppe` WHERE `kKundengruppe`='".(int)$nKundengruppe."'", 
          1
        );
        if(isset($oKundengruppe->kKundengruppe) && $oKundengruppe->kKundengruppe > 0)
          $kKundengruppe = $oKundengruppe->kKundengruppe;
      }
    }
    
    $deliveryCountry = false;
    $oDelivery = $shopgateCart->getDeliveryAddress();
    if ($oDelivery)
    {
      $tmp = $this->_prepare_string_for_jtl($oDelivery->getCountry());
      if (!empty($tmp))
        $deliveryCountry = $tmp;
    }
    
    // ermittle Steuersatz
    $cLandSteuersatz = !$deliveryCountry ? $this->cLieferLand : $deliveryCountry;
    $tmp = $GLOBALS["DB"]->executeQuery(
      "SELECT `kSteuerzone` FROM `tsteuerzoneland` WHERE `cISO`='$cLandSteuersatz'",
      1
    );
    if (!empty($tmp))
    {
      $kSteuerzone = $tmp->kSteuerzone;
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `kSteuerklasse` FROM `tsteuerklasse` WHERE `cStandard`='Y'",
        1
      );
      $kSteuerklasse = $tmp->kSteuerklasse;
      $tmp = $GLOBALS["DB"]->executeQuery(
        "SELECT `fSteuersatz` FROM `tsteuersatz` WHERE `kSteuerklasse`=$kSteuerklasse AND `kSteuerzone`=$kSteuerzone",
        1
      );
      $fSteuersatz = $tmp->fSteuersatz;
    }
    else
      $fSteuersatz = $this->fallback_steuersatz;
    
    $aCouponsResponse = array();
    $aGuthabenKupon = array();
    $fSummeKupons = array('brutto'=>0, 'netto'=>0);
    $coupons = $shopgateCart->getExternalCoupons();
    foreach ($coupons as $checkCoupon)
    {
      //suche code
      $cCode = $checkCoupon->getCode();
      if (!empty($cCode))
      {
        $tmpCode = $this->_prepare_string_for_jtl($cCode);
        if ($tmpCode == 'GUTHABENVERRECHNUNG')
        {
          $aGuthabenKupon = array(
            'amount_netto'  => $checkCoupon->getAmountNet()/100
          );
        }
        else
        {
          $oKupon = $GLOBALS["DB"]->executeQuery(
            "SELECT * FROM `tkupon` WHERE `cCode`='".$GLOBALS['DB']->escape($tmpCode)."'", 
            1
          );
          if($oKupon)
          {
            $kuponSprache = $GLOBALS["DB"]->executeQuery("SELECT * `tkuponsprache` WHERE `kKupon`=".$oKupon->kKupon." AND `cISOSprache`='".$_SESSION['cISOSprache']."'", 1);
            if ($oKupon->cWertTyp == 'prozent')
            {
              $kuponwert = array(
                'brutto'  => round($aWarenWertSet['brutto']*$oKupon->fWert/100, 5),
                'netto'   => round($aWarenWertSet['netto']*$oKupon->fWert/100, 5)
              );
            }
            else
            {
              $kuponwert = array(
                'brutto'  => $oKupon->fWert,
                'netto'   => round($oKupon->fWert*100/(100+$fSteuersatz), 5)
              );
            }
            $checkResult = $this->_checkCoupon($oKupon, $kKunde, $kKundengruppe, $aWarenWertSet, $aPositionen, $deliveryCountry);
            $kupon = new ShopgateExternalCoupon();
            $kupon->setIsValid($checkResult > 0 ? 0 : 1);
            $kupon->setNotValidMessage($checkResult > 0 ? $this->_getKuponErrorMessage($checkResult) : '');
            $kupon->setCode($this->_pss($oKupon->cCode));
            $kupon->setName($this->_pss($kuponSprache ? $kuponSprache->cName : $oKupon->cName));
            $kupon->setDescription('');
            //$kupon->setAmountGross($kuponwert['brutto']);
            $kupon->setAmountNet($kuponwert['netto']);
            $kupon->setTaxType('auto');
            $kupon->setIsFreeShipping($checkResult == 0 && $oKupon->cKuponTyp == 'versandkupon' ? 1 : 0);
            $aInfo = array('kKupon'=>$oKupon->kKupon);
            $kupon->setInternalInfo($checkResult == 0 ? $this->jsonEncode($aInfo) : ''); // ID des Coupons, um ihn bei Add-Order schnell zuordnen zu knnen
            $aCouponsResponse[] = $kupon;
            if ($checkResult == 0)
            {
              $fSummeKupons['brutto'] += $kuponwert['brutto'];
              $fSummeKupons['netto'] += $kuponwert['netto'];
            }
          }
          else
          {
            $kupon = $checkCoupon;
            $kupon->setIsValid(0);
            $kupon->setNotValidMessage('Der Gutscheincode ist nicht korrekt');
            $aCouponsResponse[] = $kupon;
          }
        }
      }
    }
    
    $fWarenkorbWarenwert = array(
      'brutto'=>$aWarenWertSet['brutto']-$fSummeKupons['brutto'], 
      'netto'=>$aWarenWertSet['netto']-$fSummeKupons['netto']
    );
    
    // fge Guthabenkupon ein
    if (!empty($kKunde) && $fKundeGuthabenBrutto > 0 && !empty($aGuthabenKupon) && $this->jtl_plugin_configuration['cGuthabenverrechnung'] == 'Y')
    {
      // erlaubtes Guthaben darf nicht hher als der Warenwert sein
      $fErlaubtesGuthaben = $fKundeGuthabenBrutto > $fWarenkorbWarenwert['brutto'] ? $fWarenkorbWarenwert['brutto'] : $fKundeGuthabenBrutto;
      if ($fErlaubtesGuthaben > 0)
      {
        $kupon = new ShopgateExternalCoupon();
        $kupon->setIsValid(1);
        $kupon->setNotValidMessage('');
        $kupon->setCode('GUTHABENVERRECHNUNG');
        $kupon->setName('Guthabenverrechnung');
        $kupon->setDescription('');
        //$kupon->setAmountGross($fErlaubtesGuthaben);
        $kupon->setAmountNet(round($fErlaubtesGuthaben*100/(100+$fSteuersatz), 5));
        $kupon->setTaxType('auto');
        $kupon->setIsFreeShipping(0);
        $aInfo = array('kundenguthaben'=>$kKunde);
        $kupon->setInternalInfo($this->jsonEncode($aInfo));
        $aCouponsResponse[] = $kupon;
      }
    }
    elseif (!empty($aGuthabenKupon))
    {
      $kupon = new ShopgateExternalCoupon();
      $kupon->setIsValid(0);
      $kupon->setNotValidMessage('Guthabenverrechnung nicht mglich');
      $kupon->setCode('GUTHABENVERRECHNUNG');
      $kupon->setName('Guthabenverrechnung');
      $kupon->setDescription('');
      $kupon->setAmountNet($aGuthabenKupon['amount_netto']);
      $kupon->setIsFreeShipping(0);
      $kupon->setInternalInfo('');
      $aCouponsResponse[] = $kupon;
    }
    
    $response = array(
      'external_coupons'  => $aCouponsResponse
    );
    return $response;
  }
  protected function _checkCoupon($oKupon, $kKunde, $kKundengruppe, $aWarenwert, $aPositionen, $deliveryCountry=false)
  {
    $ungueltig = 0;
    if ($oKupon->cAktiv!="Y")
      $ungueltig = 1;
    if (strtotime($oKupon->dGueltigBis) < time() && $oKupon->dGueltigBis != '0000-00-00 00:00:00')
      $ungueltig = 2;
    if (strtotime($oKupon->dGueltigAb)>time())
      $ungueltig = 3;
    if ($oKupon->fMindestbestellwert>$aWarenwert['netto'])
      $ungueltig = 4;
    if ($oKupon->kKundengruppe>0 && $oKupon->kKundengruppe!=$kKundengruppe)
      $ungueltig = 5;
    if ($oKupon->nVerwendungen>0 && $oKupon->nVerwendungen<=$oKupon->nVerwendungenBisher)
      $ungueltig = 6;
    if ($oKupon->cArtikel && $this->_hatKuponfaehigeArtikel($oKupon,$aPositionen))
      $ungueltig = 7;
    if ($oKupon->cKategorien && $oKupon->cKategorien!=-1 && $this->_hatKuponfaehigeKategorien($oKupon,$aPositionen))
      $ungueltig = 8;
    if ($oKupon->cKunden!=-1 && $kKunde>0 && strpos($oKupon->cKunden, $kKunde . ";") === false && $oKupon->cKuponTyp!="neukundenkupon")
      $ungueltig = 9;    
    if ($oKupon->cKuponTyp === 'versandkupon' && $deliveryCountry && strpos($oKupon->cLieferlaender, $deliveryCountry) === false)
      $ungueltig = 10;
      
    if ($kKunde>0)
    {
      //hat der kunde schon die max. Verwendungsanzahl erreicht?
      $anz = $GLOBALS["DB"]->executeQuery("SELECT `nVerwendungen` FROM `tkuponkunde` WHERE `kKunde`=".$kKunde." AND `kKupon`=".$oKupon->kKupon, 1);
      if ($anz->nVerwendungen>=$oKupon->nVerwendungenProKunde && $oKupon->nVerwendungenProKunde>0)
        $ungueltig = 6;
    }
    
    return $ungueltig;
  }

  private function _hatKuponfaehigeArtikel($oKupon,$aPositionen)
  {
    if (is_array($aPositionen))
    {
      foreach ($aPositionen as $Pos)
      {
        if (eregi($Pos['cArtNr'].";",$oKupon->cArtikel))
          return false;
      }
    }
    else
      return false;
    return true;
  }

  private function _hatKuponfaehigeKategorien($oKupon,$aPositionen)
  {
    if (is_array($aPositionen))
    {
      $kats = array();
      foreach ($aPositionen as $Pos)
      {
        $tKats = $Pos['aKategorien'];
        if(pruefeIstVariKind($Pos['kArtikel']))
        {
          $kArtikel = gibkVaterArtikel($Pos['kArtikel']);
          $tKats = array();
          $Kats_arr = $GLOBALS["DB"]->executeQuery("SELECT `kKategorie` FROM `tkategorieartikel` WHERE `kArtikel` = " . $kArtikel, 2);
          if (is_array($Kats_arr))
          {
            foreach ($Kats_arr as $Kat)
            {
              if (!in_array($Kat->kKategorie,$tKats))
                $tKats[] = $Kat->kKategorie;
            }
          }
        }
        if (!empty($tKats))
          $kats = array_merge($kats, $tKats);
      }
      $kats = array_unique($kats);
      foreach ($kats as $kat)
      {
        if(stristr($oKupon->cKategorien, $kat . ";") !== false)		
          return false;
      }
    }
    else
      return false;
    return true;
  }

  private function _getKuponErrorMessage($code)
  {
    switch ($code)
    {
      case 1: return 'Der Kupon ist nicht aktiv (1)'; break;
      case 2: return 'Der Kupon ist abgelaufen (2)'; break;
      case 3: return 'Der Kupon ist nicht aktiv (3)'; break;
      case 4: return 'Der Mindestbestellwert fr diesen Kupon ist nicht erreicht (4)'; break;
      case 5: return 'Kupon ist nicht aktiv (5)'; break;
      case 6: return 'Kupon ist nicht mehr aktiv (6)'; break;
      case 7: return 'Artikel im Warenkorb sind nicht Kupon-fhig (7)'; break;
      case 8: return 'Artikel im Warenkorb sind nicht Kupon-fhig (8)'; break;
      case 9: return 'Kupon ist nicht aktiv (9)'; break;
      case 10: return 'Der Kupon kann nicht mit dem gewhlten Lieferland kombiniert werden. (10)'; break;
      default: return 'Der Kupon kann nicht genutzt werden';
    }
  }
  private function _gibMoeglicheVersandarten($lieferland, $plz, $versandklassen, $kKundengruppe)
  {
    $moeglicheVersandarten = array();
    $minVersand = 10000;
    
    if (empty($versandklassen))
      $versandklassen = $this->jtl_plugin_configuration['nStandardVersandklasse'];
    if (!$lieferland)
      $lieferland = $this->cLieferLand;
    $cISO = $lieferland;

    $cNurAbhaengigeVersandart = "N";
    if (normalerArtikelversand($lieferland) == false)
      $cNurAbhaengigeVersandart = "Y";
      
    $versandarten = $GLOBALS["DB"]->executeQuery(
      "SELECT *
      FROM `tversandart`
      WHERE `cNurAbhaengigeVersandart`='" . $cNurAbhaengigeVersandart . "'
        AND `cLaender` LIKE \"%" . $cISO . "%\"
        AND (`cVersandklassen`='-1' OR (`cVersandklassen` LIKE \"% " . $versandklassen . " %\" OR `cVersandklassen` LIKE \"% " . $versandklassen . "\"))
        AND (`cKundengruppen`='-1' OR `cKundengruppen` LIKE '%;" . $kKundengruppe . ";%') ORDER BY `nSort`",
      2
    );
    $cnt = count($versandarten);

    for ($i=0;$i<$cnt;$i++)
    {
      if ($plz)
        $versandarten[$i]->Zuschlag = $this->_gibVersandZuschlag($versandarten[$i],$cISO,$plz);
      else
        $versandarten[$i]->Zuschlag = null;
      $versandarten[$i]->fEndpreis = berechneVersandpreis($versandarten[$i], $cISO, null);
      $name_spr = $GLOBALS["DB"]->executeQuery("SELECT `cName`, `cLieferdauer`, `cHinweistext` FROM `tversandartsprache` WHERE `kVersandart`=".$versandarten[$i]->kVersandart." AND `cISOSprache`='".$_SESSION['cISOSprache']."'",1);
      $versandarten[$i]->angezeigterName = $name_spr->cName;
			$versandarten[$i]->angezeigterHinweistext = $name_spr->cHinweistext;
			$versandarten[$i]->cLieferdauer = $name_spr->cLieferdauer;
      if ($versandarten[$i]->fEndpreis==-1)
      {
        unset($versandarten[$i]);
        continue;
      }
      if ($versandarten[$i]->fEndpreis<$minVersand)
        $minVersand = $versandarten[$i]->fEndpreis;
    }
    
    //$versandarten = array_merge($versandarten);

    //auf anzeige filtern
    foreach ($versandarten as $versandart)
    {
      switch ($versandart->cAnzeigen)
      {
        case 'guenstigste':
          if ($versandart->fEndpreis<=$minVersand)
            array_push($moeglicheVersandarten,$versandart);
          break;
        case 'immer':
            array_push($moeglicheVersandarten,$versandart);
          break;
      }
    }
    return $moeglicheVersandarten;
  }
  private function _gibVersandZuschlag($versandart,$cISO,$plz)
  {
    $waehrung = $_SESSION['Waehrung'];
    $versandzuschlaege = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tversandzuschlag` WHERE `kVersandart`=".$versandart->kVersandart." AND `cISO`='".$cISO."'",2);
    foreach ($versandzuschlaege as $versandzuschlag)
    {
      $plz_x = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tversandzuschlagplz` WHERE ((`cPLZAb`<='".$plz."' AND `cPLZBis`>='".$plz."') OR `cPLZ`='".$plz."') AND `kVersandzuschlag`=".$versandzuschlag->kVersandzuschlag,1);
      if ($plz_x && $plz_x->kVersandzuschlagPlz>0)
      {
        $versandzuschlag->fZuschlag = number_format($versandzuschlag->fZuschlag*$waehrung->fFaktor, 2, $waehrung->cTrennzeichenCent, $waehrung->cTrennzeichenTausend);
        return $versandzuschlag;
      }
    }
  }
  /// EOF STOCK AND CART_FUNCTIONS ///
  
  /// GET REVIEWS ///
  public function createReviews($limit = null, $offset = null, array $uids = array())
  {
    if (!empty($uids))
    {
      $inUids = '';
      foreach ($uids as $value)
      {
        if (!empty($inUids))
          $inUids .= ',';
        $inUids .= "'".(int)$value."'";
      }
      $q = "SELECT * FROM `tbewertung` WHERE `kArtikel` IN ($inUids)";
      if ($this->aTeinstellungenFields['bewertung_freischalten'] == 'Y')
        $q .= " AND `nAktiv`=1";
      $q .= " ORDER BY `kBewertung`";
    }
    else
    {
      $q = "SELECT * FROM `tbewertung`";
      if ($this->aTeinstellungenFields['bewertung_freischalten'] == 'Y')
        $q .= " WHERE `nAktiv`=1";
      $q .= " ORDER BY `kBewertung`";
    }
    $sLimit = '';
    if (!empty($limit))
      $sLimit = (int) $limit;
    if (!empty($limit) && !empty($offset))
      $sLimit = ((int) $offset).','.$sLimit;
    if (!empty($sLimit))
      $sLimit = ' LIMIT '.$sLimit;
    $result = $GLOBALS["DB"]->executeQuery($q.$sLimit, 9);
    if (!empty($result))
    {
      foreach ($result as $review)
      {
        $oReview = new Shopgate_Model_Review();
        $oReview->setUid($review['kBewertung']);
        $oReview->setItemUid($review['kArtikel']);
        $oReview->setTitle($this->_pss($review['cTitel']));
        $oReview->setText($this->_pss($this->_remove_html($review['cText'])));
        $oReview->setScore($review['nSterne'] * 2);
        $oReview->setReviewerName($this->_pss($review['cName']));
        $oReview->setDate($review['dDatum']);
        $this->addReviewModel($oReview);
      }
    }
  }
  
  public function getSettings()
  {
    $settings = array(
      'allowed_address_countries' => array(),
      'allowed_shipping_countries'=> array(),
			'customer_groups'       => array(),
      'tax'                   => array(
        'product_tax_classes'   => array(),
        'customer_tax_classes'  => array(array('id' => 1, 'key' => "default")),
        'tax_rates'             => array(),
        'tax_rules'             => array()
      )
		);
    $aLaender = gibBelieferbareLaender($this->kKundengruppe);
    $aSteuerLaender = array();
    foreach ($aLaender as $oLand)
    {
      $settings['allowed_address_countries'][] = array(
        'country' => $oLand->cISO,
        'state'   => array('all')
      );
      $settings['allowed_shipping_countries'][] = array(
        'country' => $oLand->cISO,
        'state'   => array('all')
      );
      $aSteuerLaender[$oLand->cISO] = $oLand->cISO;
    }
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tkundengruppe`", 2);
    foreach ($aRes as $row)
    {
      $group = array(
        'id' => $row->kKundengruppe,
        'name' => $this->_pss($row->cName),
        'is_default' => $row->cStandard == 'Y' ? 1 : 0
      );
      $settings['customer_groups'][] = $group;
    }
    $aSteuerklassen = $GLOBALS["DB"]->executeQuery("SELECT * FROM `tsteuerklasse`", 2);
    $def_tax_class = '';
    foreach ($aSteuerklassen as $row)
    {
      $group = array(
        'id' => $row->kSteuerklasse,
        'key' => $this->_pss($row->cName)
      );
      $settings['tax']['product_tax_classes'][] = $group;
      if ($row->cStandard == 'Y')
        $def_tax_class = $row->cName;
    }
    if (empty($def_tax_class))
    {
      $def_rate = current($settings['tax']['product_tax_classes']);
      $def_tax_class = $def_rate['key'];
    }
    
    // Alle Steuerinfos laden
    $cQuery = "SELECT 
      ts.kSteuersatz, ts.kSteuerzone, ts.kSteuerklasse, ts.fSteuersatz, ts.nPrio,
      tz.cName AS cNameSteuerzone,
      tk.cName AS cNameSteuerklasse, tk.cStandard,
      tl.cISO 
    FROM tsteuersatz AS ts
    LEFT JOIN tsteuerzone AS tz ON ts.kSteuerzone=tz.kSteuerzone
    LEFT JOIN tsteuerklasse AS tk ON ts.kSteuerklasse=tk.kSteuerklasse
    LEFT JOIN tsteuerzoneland AS tl ON ts.kSteuerzone=tl.kSteuerzone
    WHERE ts.fSteuersatz > 0";
    $tax_rates = $GLOBALS["DB"]->executeQuery($cQuery, 9);

    foreach ($tax_rates as $tax)
    {
      $settings['tax']['tax_rates'][] = array(
        'id'            => $tax['kSteuersatz'].'_'.$tax['kSteuerzone'].'_'.$tax['cISO'],
        'key'           => $this->_pss($tax['fSteuersatz'].' '.$tax['cNameSteuerklasse'].' '.$tax['cNameSteuerzone'].' '.$tax['cISO']),
        'display_name'  => $this->_pss($this->tSprache['vat']),
        'tax_percent'   => $tax['fSteuersatz'],
        'country'       => $this->_pss($tax['cISO']),
        'state'         => '',
        'zipcode_type'  => 'all'
      );
      $cKeyTmp = $tax['kSteuerzone'].'_'.$tax['kSteuerklasse'];
      if (!array_key_exists($cKeyTmp, $settings['tax']['tax_rules']))
      {
        $settings['tax']['tax_rules'][$cKeyTmp] = array(
          'name'      => $this->_pss($tax['cNameSteuerzone'].' '.$tax['cNameSteuerklasse']),
          'priority'  => 100-$tax['nPrio'],
          'product_tax_classes'   => array(array('key' => $this->_pss($tax['cNameSteuerklasse']))),
          'customer_tax_classes'  => array(array('key' => 'default')),
          'tax_rates' => array()
        );
      }
      $settings['tax']['tax_rules'][$cKeyTmp]['tax_rates'][] = array(
        'id'  => $tax['kSteuersatz'].'_'.$tax['kSteuerzone'].'_'.$tax['cISO'],
        'key' => $this->_pss($tax['fSteuersatz'].' '.$tax['cNameSteuerklasse'].' '.$tax['cNameSteuerzone'].' '.$tax['cISO'])
      );
      unset($aSteuerLaender[$tax['cISO']]);
    }
    /*
    foreach ($aSteuerLaender as $setLand => $setLandIso)
    {
      foreach ($aSteuerklassen as $aSteuerklasse)
      {
        $settings['tax']['tax_rates'][] = array(
          'id'            => '0_0_'.$setLandIso,
          'key'           => $this->_pss('0 '.$aSteuerklasse->cName.' steuerfrei '.$setLandIso),
          'display_name'  => $this->_pss($this->tSprache['vat']),
          'tax_percent'   => 0,
          'country'       => $this->_pss($setLandIso),
          'state'         => '',
          'zipcode_type'  => 'all'
        );
      }
      $cKeyTmp = '0_'.$aSteuerklasse->kSteuerklasse;
      if (!array_key_exists($cKeyTmp, $settings['tax']['tax_rules']))
      {
        $settings['tax']['tax_rules'][$cKeyTmp] = array(
          'name'      => $this->_pss('steuerfrei '.$aSteuerklasse->cName),
          'priority'  => 101,
          'product_tax_classes'   => array(array('key' => $this->_pss($aSteuerklasse->cName))),
          'customer_tax_classes'  => array(array('key' => 'default')),
          'tax_rates' => array()
        );
      }
      $settings['tax']['tax_rules'][$cKeyTmp]['tax_rates'][] = array(
        'id'  => '0_0_'.$setLandIso,
        'key' => $this->_pss('0 '.$aSteuerklasse->cName.' steuerfrei '.$setLandIso)
      );
    }
    */
    
    return $settings;
  }
  
  
  //// EMPTY FUNCTION, NOT IMPLEMENTED ////
  protected function createItemsCsv()
  {
    // empty function
  }
  protected function createReviewsCsv()
  {
    // empty function
  }
  protected function createMediaCsv()
  {
    // empty function
  }
  public function syncFavouriteList($customerToken, $items)
  {
    // empty function
  }
  public function getOrders($customerToken, $customerLanguage, $limit = 10, $offset = 0, $orderDateFrom = '', $sortOrder = 'created_desc')
  {
    // empty function
  }
  
  //// FUNCTIONS FOR AGI-JTL-PLUGIN ///
  public function getJTLPluginConfiguration($field)
  {
    if (!array_key_exists($field, $this->jtl_plugin_configuration))
      return null;
    else
      return $this->jtl_plugin_configuration['field'];
  }

  //// BOF FUNCTIONS TO BE OVERWRITTEN IN EXTENDED CLASS ////
  public function agiGetCustomerIndividualAddData($customer)
  {
    return $customer;
  }
  public function agiOverwriteCategoriesArray($aKategories, $limit = null, $offset = null, $uids = array())
  {
    return $aKategories;
  }
  public function agiManipulateCategoriesArrayItem($aItem)
  {
    return $aItem;
  }
  public function agiCreateItemsOnStart() { }
  public function agiManipulateItemObject() { }
  public function agiAddOrderIndividual($order) { }
  public function agiUpdateOrderIndividual($order) { }
  public function agiRegisterCustomerIndividual($user, $pass, $customer) { }
  public function agiCheckStockIndividual($shopgateCart) { }
  public function agiCheckCartIndividual($shopgateCart) { }
  //// EOF FUNCTIONS TO BE OVERWRITTEN IN EXTENDED CLASS ////
  
  /*
   * prepares shopgate String for JTL
   * @var string
   * @return string
   */
  public function _prepare_string_for_jtl($string)
  {
    //$string = utf8_decode($string);
    $string = iconv('UTF-8', 'windows-1252', $this->clear_text_for_csv($string));
    return $string;
  }
  
  /*
   * prepares shopgate String for Shopgate
   * @var string
   * @return string
   */
  public function _prepare_string_for_shopgate($string, $csv=false)
  {
    //$string = utf8_encode($string);
    $string = iconv('windows-1252', 'UTF-8', $csv ? $this->clear_text_for_csv($string) : $string);
    return $string;
  }
  public function _pss($string, $csv=false)
  {
    if (is_string($string))
      return is_string($string) ? $this->_prepare_string_for_shopgate($string, $csv) : $string;
  }
  public function _setSessionVar($key, $value)
  {
    $_SESSION[$key] = $value;
  }
  /**
   * remove all html-Tags from the given string
   * @param   string  $string
   * @return  string
   */
  private function _remove_html($string)
  {
    $replace_to = array('<br>','<br />','<p>','</p>','&nbsp;','</tr>','</td>','</li>'); // needles
    $replace_with = array(chr(10),chr(10),chr(10).chr(10),chr(10),' ',chr(10),chr(9),chr(10)); // replace-with
    
    $string = str_replace($replace_to, $replace_with, $string);
    $string = strip_tags($string);
    $string = html_entity_decode($string,ENT_QUOTES,"ISO-8859-15");
    $string = trim($string);
    return $string;
  }
  /* BOF CSV-Fallback */
  private function clear_text_for_csv($text, $short = 0, $mask=true)
  {
    $cleared_text = $text;
    $cleared_text = str_replace("\n"," ",$cleared_text);
    $cleared_text = str_replace("\r"," ",$cleared_text);
    $cleared_text = str_replace("\t"," ",$cleared_text);
    $cleared_text = str_replace("\v"," ",$cleared_text);
    if ($mask)
      $cleared_text = str_replace('"','""',$cleared_text);
    //$cleared_text = str_replace("|",",",$cleared_text);
    $cleared_text = preg_replace("/ {2,}/"," ",$cleared_text);
    if ($short > 0)
    {
      $shorten = wordwrap($cleared_text, $short, "|");
      $shorten = explode("|", $shorten);
      $cleared_text = $shorten[0];
    }
    
    $cleared_text = trim($cleared_text);
    return $cleared_text;
  }
  private function encodeValue($value)
  {
    //return is_string($value) ? '"'.utf8_encode($this->clear_text_for_csv($value)).'"' : $value;
    return is_string($value) ? '"'.iconv('ISO-8859-15', 'UTF-8', $this->clear_text_for_csv($value)).'"' : $value;
  }
  /* EOF CSV-Fallback */
  
  public function get_payment_fallback()
  {
    $payments = array(
      'SHOPGATE'  => array('id'=>1, 'name'=>'Shopgate'),
      'PREPAY'    => array('id'=>1, 'name'=>'Vorkasse'),
      'SG_PREPAY' => array('id'=>1, 'name'=>'SG_PREPAY'),
  
      'DEBIT'     => array('id'=>1, 'name'=>'DEBIT'),
      'COD'       => array('id'=>1, 'name'=>'Nachnahme'),
      'COLL_STORE'=> array('id'=>1, 'name'=>'COLL_STORE'),
      
      'INVOICE'   => array('id'=>1, 'name'=>'Rechnung'),
      'KLARNA_INV'=> array('id'=>1, 'name'=>'KLARNA Rechnung'),
      'BILLSAFE'  => array('id'=>1, 'name'=>'Billsafe'),
      'MSTPAY_INV'=> array('id'=>1, 'name'=>'MSTPAY_INV'),
      'SG_INVOICE'=> array('id'=>1, 'name'=>'SG_INVOICE'),
      
      'PAYPAL'    => array('id'=>1, 'name'=>'Paypal'),
      'CMPTOP_PP' => array('id'=>1, 'name'=>'CMPTOP_PP'),
      'MASTPAY_PP'=> array('id'=>1, 'name'=>'MASTPAY_PP'),
      'SAGEPAY_PP'=> array('id'=>1, 'name'=>'SAGEPAY_PP'),
      'SG_PAYPAL' => array('id'=>1, 'name'=>'SG_PAYPAL'),
      
      'CC'        => array('id'=>1, 'name'=>'Kreditkarte'),
      'DT_CC'     => array('id'=>1, 'name'=>'DT_CC'),
      'OGONE_CC'  => array('id'=>1, 'name'=>'OGONE_CC'),
      'SG_CC'     => array('id'=>1, 'name'=>'SG_CC'),
  
      'SUE'       => array('id'=>1, 'name'=>'Sofortueberweisung'),
      'MSTPAY_SUE'=> array('id'=>1, 'name'=>'MSTPAY_SUE'),
      'SG_SUE'    => array('id'=>1, 'name'=>'SG_SUE'),
      
      'OTHER'     => array('id'=>1, 'name'=>'Shopgate')
    );
    return $payments;
  }

  public function plugin_handle_payment($order)
  {
    // get payment-infos
    // load jtl payments
    $lang_default = $_SESSION['cISOSprache'];
    $jtlZahlarten = array();
    $aRes = $GLOBALS["DB"]->executeQuery("SELECT z.kZahlungsart, zs.cName, zs.cGebuehrname FROM `tzahlungsart` AS z, `tzahlungsartsprache` AS zs WHERE zs.kZahlungsart=z.kZahlungsart AND zs.cISOSprache = '$lang_default' ORDER BY z.kZahlungsart", 9);
    foreach ($aRes as $row)
    {
      $jtlZahlarten[$row['kZahlungsart']] = array('name'=>$row['cName'],'gebuehrName'=>$row['cGebuehrname']);
    }
    
    $shopgate_payments_fallback = $this->get_payment_fallback();
    if (array_key_exists('payment_relation',$this->jtl_plugin_configuration) && !empty($this->jtl_plugin_configuration['payment_relation']))
      $shopgate_payments = unserialize($this->jtl_plugin_configuration['payment_relation']);
    else
      $shopgate_payments = $shopgate_payments_fallback;
    
    $paymentInfos   = $order->getPaymentInfos();
    $check_payment  = $order->getPaymentMethod();
    $hinweis_name   = array_key_exists('shopgate_payment_name', $paymentInfos) ? $this->_prepare_string_for_jtl($paymentInfos['shopgate_payment_name']) : $check_payment;
    $paymentComment = '';
    $kZahlart = array_key_exists('OTHER', $shopgate_payments) ? $shopgate_payments['OTHER'] : $shopgate_payments_fallback['OTHER'];
    $cZahlart = array_key_exists('OTHER', $shopgate_payments) ? $shopgate_payments['OTHER'] : $shopgate_payments_fallback['OTHER'];
    $cGebuehr = 'Gebhr';
    if (array_key_exists($order->getPaymentMethod(), $shopgate_payments))
    {
      $kZahlart = $shopgate_payments[$check_payment]['id'];
      //$cZahlart = $shopgate_payments[$check_payment]['name'];
      $cZahlart = array_key_exists($kZahlart, $jtlZahlarten) ? $jtlZahlarten[$kZahlart]['name'] : $shopgate_payments[$check_payment]['name'];
      $cGebuehr = array_key_exists($kZahlart, $jtlZahlarten) ? $jtlZahlarten[$kZahlart]['gebuehrName'] : $shopgate_payments[$check_payment]['name'].' Gebhr';
    }
    elseif (array_key_exists($check_payment, $shopgate_payments_fallback))
    {
      $kZahlart = $shopgate_payments_fallback[$check_payment]['id'];
      $cZahlart = $shopgate_payments_fallback[$check_payment]['name'];
      $cGebuehr = $shopgate_payments_fallback[$check_payment]['name'].' Gebhr';
    }
    
    switch ($order->getPaymentMethod()) {
      case ShopgateOrder::SHOPGATE:
        // Payment Method: Shopgate 
        // This covers all the payment methods settled via Shopgate
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::SHOPGATE);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name;
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;
      
      case ShopgateOrder::PREPAY:
        // Payment Method: Prepayment
        // Reference number: 
        $paymentComment .= 'Referenz: '.$this->_prepare_string_for_jtl($paymentInfos['purpose']);
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::PREPAY);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name;
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      case ShopgateOrder::INVOICE:
        // Payment Method: Invoice 
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::INVOICE);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name;
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      case ShopgateOrder::DEBIT:
        // Payment Method: Direct Debit
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::DEBIT);
        $paymentComment .= 'bank_account_holder: '.$this->_prepare_string_for_jtl($paymentInfos["bank_account_holder"]).chr(10);
        $paymentComment .= 'bank_account_number: '.$this->_prepare_string_for_jtl($paymentInfos["bank_account_number"]).chr(10);
        $paymentComment .= 'bank_name: '.$this->_prepare_string_for_jtl($paymentInfos["bank_name"]).chr(10);
        $paymentComment .= 'bank_code: '.$this->_prepare_string_for_jtl($paymentInfos["bank_code"]).chr(10);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name;
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      case ShopgateOrder::COD:
        // Payment Method: Cash on Delivery
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::COD);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name;
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      case ShopgateOrder::DT_CC:
        // Payment Method: DataTrans Credit Card
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::DT_CC);
        $paymentComment .= 'upp_transaction_id: '.$this->_prepare_string_for_jtl($paymentInfos["upp_transaction_id"]).chr(10);
        $paymentComment .= 'authorization: '.$this->_prepare_string_for_jtl($paymentInfos["authorization"]).chr(10);
        $paymentComment .= 'settlement: '.$this->_prepare_string_for_jtl($paymentInfos["settlement"]).chr(10);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name.chr(10);
          $tZahlungseingang->cHinweis           .= 'UPP: '.$this->_prepare_string_for_jtl($paymentInfos["upp_transaction_id"]);
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      case ShopgateOrder::BILLSAFE:
        // Payment Method: Billsafe
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::BILLSAFE);
        $paymentComment .= 'Billsafe-transaction-ID: '.$this->_prepare_string_for_jtl($paymentInfos["billsafe_transaction_id"]);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name.chr(10);
          $tZahlungseingang->cHinweis           .= 'BID: '.$this->_prepare_string_for_jtl($paymentInfos["billsafe_transaction_id"]);
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      case ShopgateOrder::KLARNA_INV:
        // Payment Method: Klarna
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::KLARNA_INV);
        $paymentComment .= 'Klarna-reservation-number: '.$this->_prepare_string_for_jtl($paymentInfos["reservation_number"]);
        $paymentComment .= 'Klarna-activation_invoice_number: '.$this->_prepare_string_for_jtl($paymentInfos["activation_invoice_number"]);
        $paymentComment .= 'Invoice-URL: '.$paymentInfos["invoice_pdf_url"];
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name.chr(10);
          $tZahlungseingang->cHinweis           .= 'KRN: '.$this->_prepare_string_for_jtl($paymentInfos["reservation_number"]);
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;
      
      case ShopgateOrder::PAYPAL:
        // Payment Method: Paypal
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::PAYPAL);
        $paymentComment .= 'payment_status: '.$this->_prepare_string_for_jtl($paymentInfos["payment_status"]);
        if (strtolower($this->_prepare_string_for_jtl($paymentInfos["payment_status"])) == 'completed')
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = $this->_prepare_string_for_jtl($paymentInfos["mc_fee"]);
          $tZahlungseingang->fBetrag            = $this->_prepare_string_for_jtl($paymentInfos["mc_gross"]);
          $tZahlungseingang->cISO               = $this->_prepare_string_for_jtl($paymentInfos["mc_currency"]);
          $tZahlungseingang->cEmpfaenger        = $this->_prepare_string_for_jtl($paymentInfos["receiver_email"]);
          $tZahlungseingang->cZahler            = $this->_prepare_string_for_jtl($paymentInfos["payer_email"]);
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name.chr(10).$this->_prepare_string_for_jtl($paymentInfos["transaction_id"]);
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;
      
      case ShopgateOrder::SUE:
        // Payment Method: Sofortueberweisung
        $paymentType = $this->_prepare_string_for_jtl(ShopgateOrder::SUE);
        $paymentComment .= 'transaction_id: '.$this->_prepare_string_for_jtl($paymentInfos["transaction_id"]);
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name.chr(10);
          $tZahlungseingang->cHinweis           .= 'TN: '.$this->_prepare_string_for_jtl($paymentInfos["transaction_id"]);
          $tZahlungseingang->cAbgeholt          = 'N';
        }
      break;

      default:
        // When no concrete payment method processing is possible/successful, 
        // register the payment as mobile_payment and enter PaymentInfos 
        // as a comment. PaymentInfos always contains the 
        // name of the payment type as (shopgate_payment_name) field
        //$cZahlart = 'mobile_payment';
        $paymentType = 'mobile_payment';
        foreach ($paymentInfos as $key => $value) {
          $paymentComment .= $this->_prepare_string_for_jtl($key).': '.$this->_prepare_string_for_jtl($value)."\n";
        }
        if ($order->getIsPaid())
        {
          $tZahlungseingang = new stdClass();
          // $tZahlungseingang->kBestellung = // to implement later
          $tZahlungseingang->cZahlungsanbieter  = $cZahlart;
          $tZahlungseingang->fZahlungsgebuehr   = 0;
          $tZahlungseingang->fBetrag            = $order->getAmountComplete();
          $tZahlungseingang->cISO               = 'EUR';
          $tZahlungseingang->cHinweis           = 'SG: '.$hinweis_name;
          $tZahlungseingang->cAbgeholt          = 'N';
        }
        // save comments to the order
      break;
    }
    $result = array(
      'cZahlart'        => $cZahlart,
      'cGebuehr'        => $cGebuehr,
      'kZahlart'        => $kZahlart,
      'paymentType'     => $paymentType,
      'paymentComment'  => $paymentComment
    );
    if (isset($tZahlungseingang))
      $result['tZahlungseingang'] = $tZahlungseingang;
    return $result;
  }

  private function getKVersandartByName($cShippingName, $aWarenkorbVersandklassen, $kKundengruppe, $cLieferland = 'DE')
  {
    $kVersandart = 0;
    $aVersandartSprache = $GLOBALS["DB"]->executeQuery(
      "SELECT * FROM tversandartsprache WHERE `cName`='".$cShippingName."'
      ", 
      2
    );
    if (count($aVersandartSprache) > 1)
    {
      $diff_keys = false;
      $check_key = $aVersandartSprache[0]->kVersandart;
      foreach ($aVersandartSprache as $versandartSprache)
      {
        if ($check_key <> $versandartSprache->kVersandart)
        {
          $diff_keys = true;
          break;
        }
        $check_key = $versandartSprache->kVersandart;
      }
      if ($diff_keys)
      {
        sort($aWarenkorbVersandklassen);
        $cVersandklassen = implode('-', $aWarenkorbVersandklassen);
        $versandarten = $GLOBALS["DB"]->executeQuery("SELECT kVersandart
          FROM tversandart
          WHERE cNurAbhaengigeVersandart='" . $this->cNurAbhaengigeVersandart . "'
            AND cLaender like \"%" . $cLieferland . "%\"
            AND (cVersandklassen='-1' or (cVersandklassen like \"% " . $cVersandklassen . " %\" or cVersandklassen like \"% " . $cVersandklassen . "\"))
            AND (cKundengruppen='-1' or cKundengruppen like '%;" . $kKundengruppe . ";%') order by nSort", 2);
        $cnt = count($versandarten);
        if ($cnt > 0)
        {
          $aVersand = array();
          foreach ($versandarten as $value)
            $aVersand[] = $value->kVersandart;
          foreach ($aVersandartSprache as $oVersandartSprache)
          {
            if (in_array($oVersandartSprache->kVersandart, $aVersand))
            {
              $kVersandart = $oVersandartSprache->kVersandart;
              break;
            }
          }
        }
      }
      else
        $kVersandart = $check_key;
    }
    else if (count($aVersandartSprache) == 1)
      $kVersandart = $aVersandartSprache[0]->kVersandart;
    return $kVersandart;
  }
}

?>